rebol [
	TITLE: "Score Reverse"
	Author: "Grard Joyez"
	Creation-Date: 14/1/2005
	Purpose: {To provide possible contract + result to explain a Bridge score }
	Method: {Building four tables of all possible score:
	- one for contract made non vulnerable
	- one for contract made being vulnerable
	- one for contract defeated non vulnerable
	- one for contract defeated vulnerable
	Each table is a series (hash!) of three data: score contract relative result sorted by score
	According to the vulnerability of the score camp and opponent, two tables are searched and relevant portions
	of series are extracted.
	Information are the reduced to the most meaningful set}
	Note: {This script may work stand alone or as a slave to Bridge Moniteur}
]

;===========================
;Determining if stand alone
;===========================
autonome?: error? try [reduce[Score-explain?]]

;===========================
; Global variables
;===========================
Contract: ""
Vul-Cases: copy ["None" "NS" "EW" "All"]
Rel-Result: 0
Declarer-seat: 0
alpha-pique: copy to-string to-char 170
alpha-coeur: copy to-string to-char 169
;===========================
;	scoring
;===========================
Marque: does [
; first determine if the declarer is vulnerable
	V-Decl?: to-logic False
	Switch Vulnerable [
		"All"		[V-Decl?: to-logic true]
		"Both"	[V-Decl?: to-logic true]
		"EW"		[if (Declarer-seat // 2 = 1) [V-Decl?: to-logic true]]
		"NS"		[if (Declarer-seat // 2 = 0) [V-Decl?: to-logic true]]
	]
	Contre?: Surcontre?: to-logic false
	if (last Contract) = #"X" [contre?: to-logic true]
	if ((skip tail contract -2) = "XX") [Surcontre?: to-logic true]
	Col: to-string second Contract
	Contract-level: to-integer to-string first Contract
	N0: Contract-level * (switch Col ["C" 20 "D" 20 "H" 30 "S" 30 "N" 30])
	if Col = "N" [N0: N0 + 10]
	If contre? [N0: N0 * 2 if surcontre? [N0: N0 * 2]]
	either Rel-Result >= 0 [		; successful contract
		either N0 < 100 [Prime: 50][either V-Decl? [Prime: 500][Prime: 300]]
		Prime-Chelem: 0
		If Contract-level = 6 [Prime-Chelem: either V-Decl? [750][500]]
		If Contract-level = 7 [Prime-Chelem: either V-Decl? [1500][1000]]
		M: N0 + Prime + Prime-Chelem
		eitHer Contre? [
			M: M + 50 + (Rel-Result * 100)
			if V-Decl? [M: M + (Rel-Result * 100)]
			if Surcontre? [
				M: M + 50 + (Rel-result * 100)
				if V-Decl? [M: M + (Rel-Result * 100)]
			]
			][
			M: M + (Rel-Result * (switch Col ["C" 20 "D" 20 "H" 30 "S" 30 "N" 30]))
		]
		][				; contrat chuts
		M: rel-Result * Either V-decl? [100][50]
		if Contre? [
			M: M * 2 + ((Rel-Result + 1) * 100)
			if Rel-Result < -3 [if not V-Decl? [M: M + ((Rel-Result + 3) * 100)]]
		]
		If SurContre? [M: M * 2]
	]
	return M	 
]

;========================
; building tables
;========================

Build-array-made: does[
	Possible-scores: copy[]
	For Contract-level 1 7 1[					;scaning levels
		foreach Couleur ["C" "H" "NT"][			;scaning minor/major/notrump
			foreach Contre-status ["" "X" "XX"][	;scaning doubling
				Contract: rejoin[Contract-level Couleur Contre-status] ;Building possibles contracts
				upper-result: 13 - 6 - Contract-level
				for R 0 upper-result 1[		;scaning made results
					rel-result: R
					append Possible-scores reduce[marque contract R]
				]
			]
		]
	]
	return Possible-scores
]
Build-array-down: does[
	Possible-scores: copy[]
	Contract-level 7					;scaning levels
	Couleur: copy "NT"			
	foreach Contre-status ["" "X" "XX"][	;scaning doubling
		Contract: rejoin[Contract-level Couleur Contre-status] ;Building possibles contracts
		lower-result: - 6 - Contract-level
		for R lower-result -1 1[		;scaning made results
			rel-result: R
			append Possible-scores reduce[- marque Contre-status R]
		]
	]
	return Possible-scores
]
;scaning vulnerable cases
Vulnerable: first Vul-cases
NV-made: to-hash sort/skip/compare Build-array-made 3 1
NV-down: to-hash sort/skip/compare build-array-down 3 1
Vulnerable: last Vul-cases
V-made: to-hash sort/skip/compare Build-array-made 3 1
V-down: to-hash sort/skip/compare build-array-down 3 1


; extract a score
Demande-score: layout[
	across
;	h2 "Score  chercher:" Score--trouver: field 40 return
	h2 "Score  chercher:" Score--trouver: field 40 "150" return
	h2 "Score de:" 110 right ;return
	here: at
	NS-rad: radio of 'grp1 true h2 "Nord/Sud" return
	at here + 0x30 EW-rad: radio of 'grp1 h2 "Est/Ouest" return
	h2 "Vulnrabilit:" 110 right ;return
	NS-Chk: Check false text "Nord/sud" return
	at here + 0x90 EW-Chk: Check false text "Est/Ouest" return
	button "Ok" [Cherche-Contrats]
	button "Fermer" [quit]
]
write %none-Scores.txt form NV-made
;Score--trouver: 400
Rsultats: Layout/size[
	origin 0x0
	below
	space 0x0
;	button "Ok" [hide-popup]
]200x200
ajouter-chute: func[
	C [string!]
	][
	insert Rsultats/pane layout/size/offset[
		Backdrop 150.150.150
		space 0
		across
		at 0x0
		h2 c black 
		] 220x20 O
]
ajouter-fait: func[
	L  R [integer!] c [string!]][
	Res: either R > 0[join "+" R]["="]
	either Found? find L "N"[
		L: copy to-string first L
		insert Rsultats/pane layout/size/offset[
			Backdrop 150.150.150
			space 0
			across
			origin  0x0
			h2 black L
			h2 " Sans Atout " 
			h2 Res
			h2 C 
		]220x20 O
		][
		either Found? find L "C"[
			Couleur1: ""
			Couleur2:	""
			alpha-col1: red
			alpha-col2: black
			][
			Couleur1: alpha-pique
			Couleur2: alpha-coeur
			alpha-col1: black
			alpha-col2: red
		]
		L: copy to-string first L
		insert Rsultats/pane layout/size/offset[
			Backdrop 150.150.150
			space 0
			across
			origin  0x0
			h2 black L 
			here: at 
			at here - 0x10 h2 alpha-col1 Couleur1 font-name "symbol" font-size 25 top
			at here + 20x0 h2 "/"
			at here + 25x-10 h2 alpha-col2 font-name "symbol" Couleur2 font-size 25 top
			at here + 90x0 h2 Res
			h2 C 
		] 220x20 O
	]
]
Cherche-Contrats: does[
	contrats: copy []
	a: copy either ns-rad/data[
		either ns-chk/data[V-made][NV-made]
		][
		either EW-chk/data[V-made][NV-made]
	]
	b: to-integer Score--trouver/text
	if found? find a b[
		debut-contrats: (index? find a b) - 1
		fin-contrats: 2 + index? find/last a b
		contrats: copy/part skip a debut-contrats (fin-contrats - debut-contrats)
	]
	a: copy either ns-rad/data[
		either ew-chk/data[V-down][NV-down]
		][
		either ns-chk/data[V-down][NV-down]
	]
	if found? find a b[
		debut-contrats: (index? find a b) - 1
		fin-contrats: 2 + index? find/last a b
		append contrats copy/part skip a debut-contrats (fin-contrats - debut-contrats)
	]
	clear head rsultats/pane
	O: 0x0
	Liste-rduite: copy []
	either 0 < length? contrats [
		a: copy[]
		forskip Contrats 3[
			either found? find ["" "X" "XX"] second Contrats[
				append a reduce[second contrats "" third contrats]
				][
				append a reduce[second contrats second second contrats third contrats]
			]
		]
		sort/skip/compare a 3 2
		Contrat: first a
		Couleur: second a
		Rsultat: third a
		forskip a 3[
			either "" = second a[
				if  Contrat <> first a[append Liste-rduite reduce[Contrat Rsultat]]
				][
				if Couleur <> second a[Couleur: second a append Liste-rduite reduce[Contrat Rsultat]]
			]
			Contrat: first a
			Rsultat: third a
		]
		append Liste-rduite reduce[Contrat Rsultat]
		forskip liste-rduite 2[
			Contr: ""
			a: first liste-rduite
			if found? find a "X" [Contr: "Contr"]
			if found? find a "XX" [Contr: "Surcontr"]
			if a = "" [Contr: "Non contr"]
			Contrat: ""
			either Found? find ["" "X" "XX"] a[
				ajouter-chute rejoin [- (second liste-rduite) " de chute " contr]
				o: O + 0x21
				][
				ajouter-Fait first liste-rduite second liste-rduite Contr
				o: O + 0x21
			]
		]
		liste-rduite: head liste-rduite 
		][
		ajouter-chute "Illogique"
		o: O + 0x21
	]
	rsultats/size: to-pair compose[200 (o/y )]
	either autonome?[
		Place: Demande-score/offset + 120x190
		inform/title/offset rsultats (join b " ?") Place
		][
		N: (length? liste-rduite)
		if N = 0 [N: 1]
		res-offset: res-offset - to-pair compose[0 (N * 11)]
;limit the move of inform window
		H: com-zone/offset/y + freqs/offset/y + freqs/size/y - O/y  + 40
		if res-offset/y > H [res-offset/y: H]
		inform/offset/title rsultats res-offset (join b " ?")
	]
]
if autonome?[View Demande-score]