REBOL [
	title: "Bridge Moniteur"
	author: "Grard Joyez"
    purpose: {
    	To allow training at playing bridge on a computer network (home network or Internet).
	Basic features of a Table Manager (TM) according Blue Chip Bridge Protocol
	Extra features to make easy Bridge training.
	No Bridge science content. Monitoring and support only. 
	}
	Note: {The implementation uses a file PBN-like with the important exception that for played card, they appear in the play order during the game, not according to the player's place for simplicity of coding 
	Is corrected later at the end of game when saved}
	Note2: {this Table Manager may accept less than four sockets to be connected before launching the start of the board. If this is the case, then it should be provided a manual player for the vacant(s) seat(s). This human player must play on the TM host computer. He then sees all hands.}
	Note3: {In deviation with the Blue chip protocol, no check is made on the team-name, such as any combination of players will be accepted.
	The Blue chip Bridge specification version is not thorougly tested as well as long as it is not certain that the tested program may not be up-to-date with any version. These features may be added later on to fully comply with the Blue chip protocol. This addition is to be made in the Get-Client routine. However, connected players using the version 17 and 18 are recognized in order to meet its new requirements. When used as a human interce for playing, version 18 is used. Any mix of version can be used as the program is upward compatible.}
	Note4: {Possible operation on internet using TCP/IP protocol}
	Note5: {operating as a real TM for a tournament (no second round)or match (with second round). Tournament deals must be single pbn-like files in a folder, when match is a multiple pbn file.}
	Note6: {For anyone whishing to adapt this script to his own needs, the script is organized in sections.
		There are 14 sections:
	1 - Global variable definitions. All variables defined and or initialized in this section will be recognized and 			shared by any procedure
	2 - ToolBox. General Purpose modules. Includes two Task Managers one synchronous and another asynchronous
	3 - Bridge Engine. Dealing, Bidding, Card Playing, scoring
	4 - Game chaining for tournament and matches
	5 - Statistics module for tournament and matches
	6 - Special mode for Bidding Training (does only bidding on playback recorded deal)
	7 - Strategic elements. Hands evaluation, winning and loosing tricks
	8 - Viewer
	9 - Information Flow manager. Connecting, sending and receivng information. File opening and recording
	10 - Communication with background program to Compute Best mutual Score (PAR)
	11 - Man Machine interface
	12 - Overall management. menu choices and settings
	13 - graphics layout - A separate script holds many of them
	14 - building cards and launching the program
	Bon courage!
	}
	improvement: {possible improvements are: 	translate in any other langage by creating a file similar to language strings english.r and joining it to the folder}
]
version: 1.7.3
Modification-date: 20/08/2006
Deep-Finesse-path: %"/c/Bridge/Deep Finesse 26-Nov-99/"
;======================================
; dernires modifs faites
;======================================
; reprise  partir de la version BM16 v1.6.12; amlioration cosmtique
;indication de la vulnrabilit par la couleur du nom
;18/6/06: masquer bouton-suivante en match lorsque qu'il est sollicit
;cacher making-array en match-retour sans immediate second round
;27/07/06 modification des couleurs et fond transparent pour les symboles.
; remplacement des leetres de la couleur par leur symbole
; caractres plus gros
; sauvegarde double centralise des rsultats.
; plus grane flexibilit dans la gestion du retour immdiat: on peut le mettre ou le retirer plus tardivement
; adaptation du nouveau solveur qui devient priritaire sur l'ancien
; ajout de l'entame du match-aller
;========================================================================================================================
; First section: Definition of Global Variables shared by all procedures
; ========================================================================================================================
;======================================
; system parameter definition
;======================================
Debug?: to-logic false	;only used when needed for debugging prupose
debug: 1
Print?: to-logic false		;flip-flop flag controlled thru CTRL-P
system/options/args: "-s"	;to escape authorization procedure to access files
set 'app-dir what-dir 
Nom-Ordinateur: system/network/host
Rpertoire: what-dir
Dbut-Crochet: "["		; string to avoid imbedding confusion in syntax checks by editing text processor
Fin-crochet: "]"			; id
attente-fin-Leve: to-integer 1 ; wait time in seconds at 
Donnes-dir: %"/C/Bridge/Donnes/" ;Default directory for the deal, overwritten by the parameter file
Tournoi-auto?: false
Pause-game?: true
Pause-auction?: false
Continuer-match?: true
Mode-Pause: copy "Toujours"
Quitter?: false
Etude?: true
IRMAS?: false
Affichage-10?: true
Alpha-trace: "Fantme"		;management of played alphanumeric card
Noff: none
Soff: none
Woff: none
Eoff: none
Aoff: none
Toff: none
Poff: Foff: none
alert-transmit?: true
auto-connect?: false
;======================================
; Default language String definition
;======================================
New-language: func[L [string!]][
	either L = "Franais"[
		do %strings.r
		CartonPasse: %Couleurs/Passe.bmp
		card-folder: "Cards/"
		][
		language-file: to-file rejoin["Language strings " L ".r"]
		CartonPasse: %Couleurs/Pass.bmp
		do Language-file
		card-folder: "English Cards/"
	]
]
either exists? %BM_ini.txt[
	param: read/lines %BM_ini.txt
	forall param [
		P: first param
		if found? find P  "Langue"[parse P [thru "Langue: " copy Language to fin-Crochet]]
		if found? find P  "Arrt Fin jeu"[Pause-game?: found? find P "Vrai"]
		if found? find P  "Arrt Fin Enchres"[Pause-auction?: found? find P "Vrai"]
		if found? find P  "IRMAS"[IRMAS?: found? find P "Vrai"]
		If Found? find P "Nord: "[Noff: to-pair second parse P none]
		If Found? find P "Sud: "[Soff: to-pair second parse P none]
		If Found? find P "Ouest: "[Woff: to-pair second parse P none]
		If Found? find P "East: "[Eoff: to-pair second parse P none]
		If Found? find P "Enchres: "[Aoff: to-pair second parse P none]
		If Found? find P "Leves: "[Toff: to-pair second parse P none]
		If Found? find P "PAR-loc: "[Poff: to-pair second parse P none]
		If Found? find P "Faisab-loc: "[Foff: to-pair second parse P none]
		if found? find P  "Passer Les alertes"[alert-transmit?: found? find P "Vrai"]
		if  P = "Emulation WBridge5 requise"[auto-connect?: true remove param]
	]
	if auto-connect?[write/lines %BM_ini.txt param: head param]
	][
	files: load %./
	Langues-disponibles: copy ["Franais"]
	foreach f files[
		if found? find f "Language strings"[
			if found? find f ".r"[
				if not found? find f ".r~"[
					parse f [thru "Language strings " copy L to ".r"]
					append Langues-disponibles L
				]
			]
		]
	]
	language: "english"
	inform/title layout/size[
			across
			backdrop rebolor
			vh1 "Please, select your language" return
			choix-language: text-list data Langues-disponibles[language: first face/picked]
			button "Ok" center [hide-popup]
	]360x300  "Bridge Moniteur First Installation"
	P: copy rejoin ["[Joueurs:" newline "Grard"]
	append P Rejoin ["]" newline "[Hosts:" ]
	append p join newline "LocalHost"
	append P Rejoin ["]" newline "[Ports:" ]
	append p join newline "2000"
	append p "]"
	append p rejoin[newline Dbut-Crochet "Connexions 1"  fin-Crochet]
	append p rejoin[newline Dbut-Crochet "Langue: " Language fin-Crochet]
	append p rejoin[newline Dbut-Crochet "Dpart Tournoi Faux"  fin-Crochet]
	append p rejoin[newline Dbut-Crochet "Pause Toujours"  fin-Crochet]
	append p rejoin[newline Dbut-Crochet "Affichage Vrai"  fin-Crochet]
	append p rejoin[newline Dbut-Crochet "Arrt Fin Enchres Faux"  fin-Crochet]
	append p rejoin[newline Dbut-Crochet "Arrt Fin Jeu Faux"  fin-Crochet]
	write %BM_ini.txt param: p
]
new-language Language
;======================================
;Communication parameters
;======================================
BlueChip-Version: 17		;Blue Chip 1er Juillet 2003
Version17: to-integer 0	;mask for version 17 clients
Version18: to-integer 0	;mask for version 18 clients
Input-message: ""			;message reu sur les ports
Clients: copy []			; Full name seat of Client according to their enrollment order
Trainees: copy []			;short name seat of Client according to their enrollment order
Client-ports: copy []	;series of ports in connecting order
Players-ready?: to-logic false	; flag stating that remote player are ready to receive a new Bid/played card
Client-Number: to-integer 4	; default value of remote clients number -overwritten by parameter file
Client-num:				; keeps accounting processed Clients
Client-Place: ""			; Client Seat coding around table
Noms-Trainees: copy ["Franoise"];default names for Clients (or trainees) -overwritten by parameter file
Noms-Hosts: copy["LocalHost"]	; default name for server -overwritten by parameter file
Noms-Ports: copy["2000"]	; default name for communication port -overwritten by parameter file
Nom-Joueur: "Franoise"		;default input name for connexion request
Connect?: to-logic false	; flag set when all expected connexions are made
training?: to-logic false	; dedicated mode for single distant player, allowing to swap when dummy
Communication-log: copy []
Disconnected-Noms: ["" "" "" ""]
PAR-comment: none			;if Best mutual score has been found as a comment in the pbn file
Feasability-array: copy ""
Wbridge5-path: none
Backup-path: none
Alert-offset: none
; =====================================
; Display parameters
; =====================================
ssize: system/view/screen-face/size		; dimensions en pixels de l'cran (ex: 800x600)
lo-res:  ssize = 800x600
	xmax: to-integer (1 * ssize/1) 		; largeur choisie pour la fentre principale
	ymax: to-integer (.95 * ssize/2)		; hauteur choisie pour la fentre principale
xbar: to-integer (0.2 * ssize/1)        ; largeur choisie pour chacune des 4 znes d'une barre d'tat
table-height: to-integer ( ymax   ) 		;( (ymax - 56) / 3 )
either lo-res[table-width: XMax - 202][table-width: 822]
tableX0: 0
tableY0: 0
couleur-tapis: %Couleurs/Tapis.JPG
Couleur-com: %Couleurs/fineburlap.gif 
affichage: true
Cartes-Popup: true
Lettres?: false
TM-Lettres?: false
param: read/lines %BM_ini.txt
foreach P param [
	if found? find P  "Alerte Pos"[Alert-offset: to-pair replace find copy skip P 12 fin-crochet ""]
	if found? find P  "Affichage"[affichage: not (found? find P "Vrai")]
	if found? find P  "WBridge5"[Wbridge5-path: to-file copy skip P 11 remove find wbridge5-path fin-crochet ]
	if found? find P  "Backup"[Backup-path: to-file copy skip P 11 remove find Backup-path fin-crochet ]
	if found? Find P (join Dbut-crochet "Attente")[Attente-Fin-Leve: second load P]
	if found? find P (join Dbut-Crochet "Popup") [Cartes-Popup: found? find P "Vrai"]
	if found? find P (join Dbut-Crochet "AlphaNum") [TM-Lettres?: found? find P "Vrai"]
	if found? find P (join Dbut-Crochet "Display 10") [Affichage-10?: found? find P "Vrai"]
	if found? Find P (join Dbut-crochet "Carte Joue")[
		parse P [thru "Carte Joue " copy Alpha-trace to fin-crochet]
		if alpha-trace = "none"[alpha-trace: none]
	]
	if found? find P (join Dbut-Crochet "Donnes") [
		parse P [thru "Donnes " copy Donnes-dir to Fin-Crochet]
		Donnes-Dir: to-file Donnes-dir
	]
	if found? find P  "Dpart Tournoi"[Tournoi-auto?: (found? find P "Vrai")]
	if found? find P  "Pause"[parse P [thru "Pause " copy Mode-Pause to Fin-Crochet]]
]
image-carte: load to-file join card-folder "SA.bmp"
either affichage[
	card-height: to-integer (table-width / 6)			;( (ymax - 56) / 3 )
	card-width:	to-integer (table-width * 2 / 15)
	][
	card-width:	image-carte/size/1 
	card-height: image-carte/size/2
]
Carte-pope: to-logic true
pane-height: card-height 
pane-width: Table-width - (2 * Card-Height)
Htaille-Carte: to-pair compose [ (card-height) (card-width)] 
Vtaille-Carte: to-pair compose [ (card-width) (card-height)] 
			;hands Displaying parameters
largeur-alpha-carte: either lo-res[25][29]
Npane: Epane: Spane: Wpane: 0x0
Npane/x: Spane/X: pane-height			
Wpane/Y: Epane/Y: Npane/Y + pane-height
Epane/X: table-width - pane-height				;to-integer ( (xmax - 4) - pane-width )
Spane/Y: tableY0 + Table-height - pane-height
Hand-places: copy reduce[Spane Wpane Npane Epane]
Deck-Place: to-pair compose [(table-width) (160)]
dx: to-integer ((pane-width - card-width) / 12)
dx2: to-integer ((ymax -(2 * card-height) - card-width) / 12)
			;bids Displaying parameters
De: to-integer (Pane-width / 5)			; offset for the bids
Bid-offsets: to-block (to-pair compose [(de)  -53 ]) 
append Bid-offsets to-pair compose [(Pane-Height + 5) (de)] 
append Bid-offsets to-pair compose [(de) (Pane-height + 5 )] 
append Bid-offsets to-pair compose [-53 (de)] 
Bid-offsets0: copy Bid-offsets
			;connected players Displaying parameters
Client-Lights: copy []
S-Connect-offset: to-pair compose [(Spane/X ) (Spane/Y - 4 )] 
W-Connect-offset: to-pair compose [(Wpane/X + Pane-Height ) (Wpane/Y  )] 
N-Connect-offset: to-pair compose [(Npane/X ) (Npane/Y + Pane-height )] 
E-Connect-offset: to-pair compose [(Epane/X - 4) (Epane/Y  )] 
Light-height: SPane/Y - Wpane/Y
			;connected player name Displaying parameters
SName-offset: to-pair compose [(Spane/X + to-integer(pane-width * 0.5)) (Spane/Y - 20 )] 
WName-offset: to-pair compose [(Wpane/X ) (Wpane/Y - 37 )] 
NName-offset: to-pair compose [(Npane/X + to-integer(pane-width * 0.5)) (Npane/Y + Pane-height + 5)] 
EName-offset: to-pair compose [(Epane/X ) (Epane/Y - 37 )] 
			;played cards Displaying parameters
Table-Center: to-pair compose [(to-integer (table-width  / 2)) (to-integer (table-height / 2))]
Delta: To-integer (Pane-width / 2) - Card-width
Delta2: Delta + Card-Width
Beta: to-integer(Card-Height * 0.2)
Beta2: Beta + Card-Height
Play-Places: reduce [ to-pair compose [(Delta2) (- Card-Height - Beta)]]
append Play-Places to-pair compose [ (Beta2) (Delta2)]
append Play-Places to-pair compose[(Delta) (Beta2)]
append Play-Places to-pair compose [ (- Beta2) (Delta)]
Play-Places-init: copy Play-Places			
Memo-auction-display?: false
Memo-trick-display?: false
save-text: copy ""
; ===================================
; Arrows pointing active player
; ===================================
Pane-Size: to-integer (table-width * 0.347)
Pane-shape: to-pair compose [(Pane-size) (Pane-size)] 
Pane-Loc: table-center - (Pane-shape / 2)
ArrSouth: to-image load %Couleurs/ArrowsSud.JPG
ArrWest: to-image load %Couleurs/ArrowsOuest.JPG
ArrNorth: to-image load %Couleurs/ArrowsNord.JPG
ArrEast: to-image load %Couleurs/ArrowsEst.JPG
ArrOff: to-image load %Couleurs/ArrowsOff.JPG
ArrOn: Arroff
Save-Light: none
Save-Seat: none
; =================================
; Global variables definition
; =================================
PlayBack-tempo: none
Retour-timer: none
Dbut-calcul: none	;start time of companion
; =================================
; Card managing
; =================================
Jeu: copy[]
cards-names: copy ["A" "K" "Q" "J" "T" "9" "8" "7" "6" "5" "4" "3" "2"]
strcardsnames: copy "AKQJT98765432"
Indice-crois: [1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 40 41 42 43 44 45 46 47 48 49 50 51 52 27 28 29 30 31 32 33 34 35 36 37 38 39]
colors: copy "SHCD"			; colors display ranking
PBN-colors: "SHDC"			; PBN color ranking
cartes-sorties: copy []
alpha-cartes: copy []		;alphanumeric card set
; =================================
; Deal managing
; =================================
DonneRef: %deal.pbn			; current deal record file
Donne-Initiale: ""			; block of lines containing the deal 
Donne: ""						;string containing the deal
Donne-ToPlay: ""				; string containing the deal for optionnal card replay (study mode)
NumDonne: to-integer 0			; random deal number
nom-complet-fichier: ""			;with directory path
Fichier-Pbn: ""				;without directory
File-to-save: none	;
NDonnes: to-integer 1			; multi-pbn deal count
Rception-Rfrence?: false		;flag while reference file reception
Rception-match-sheet?: false ;flag while match sheet reception
Waiting-Ready-for-Deal?: false
All-Ready-for-Deal: to-integer 0
Ready-for-Deal: to-integer 0
ready-for-Cards?: 0
Frquence?: false				;true if frequency data and results are available
Frquences: copy []			;block of result data
Score-explain?: none		;flag for score-explaining feature if enabled
vul-squence: copy [{"None"}{"NS"}{"EW"}{"All"}{"NS"}{"EW"}{"All"}{"None"}{"EW"}{"All"}{"None"}{"NS"}{"All"}{"None"}{"NS"}{"EW"}]
; =================================
; hand managing
; =================================
strhands: none				; PBN standard hands
hands: copy [[][][][]]			; set of cards (object!) allocated to each player
Points: copy [[][][][]]			; hand evaluation for optionnal display
Joueurs: copy ["S" "W" "N" "E"]
Noms: to-block ["Coach" "Coach" "Coach" "Coach"] 	;Player Names for the PBN Deal
Computer-Seat: to-integer 4					;To respond to calls for bidding and playing
Dummy-Seat: 4				; Place du mort initialise au coach
Dealer-name: ""
Valeur-main: make object! [
	PH: 0
	PL: 0
	PMV: 0
]
Mains-lettres: copy [["" "" "" ""]["" "" "" ""]["" "" "" ""]["" "" "" ""]]
alpha-hands: copy []
; =================================
; Bid managing
; =================================
V-case: ""		;vulnerable coding
Bids-suit: copy []
Contract: none	
Peut-Contrer?: to-logic false
Peut-Surcontrer?: to-logic false
Alert?: to-logic false
Alert-info: copy ""
Alert-list: copy []
Alert-count: 0
if none? alert-offset[alert-offset: Spane - 0x160]
Dcompte: to-integer 0
NS-alert-messages: copy []
EW-alert-messages: copy []
Enchres-lues: copy[]
Enchres-connues: none
Comp?: false
very-comp?: false
illegal-bid?: false
; =================================
; game managing
; =================================
Couleur-demande: none
Atout: ""
tricks-suit: copy []
Trick: copy []
Trick-pointer: 0
Leader-Seat: 0	; first trick leader
Next-Player-Seat: 0
DummyUnveiled?: to-logic false
Trick-Count: to-integer 1
IMP-points: copy [0 20 50 90 130 170 220 270 320 370 430 500 600 750 900 1100 1300 1500 1750 2000 2250 2500 3000 3500 4000]
Pause-Leve?: to-logic false
Permanent-Pause-Leve?: to-logic false
alpha-card-suit: copy []
illegal-card?: false
Card-to-dispatch?: false
Joueur-en-suspens: 0
Trick-to-lead?: false
; =================================
; chaining game managing (tournament, match, gauge)
; =================================
Match?: to-logic false		; default value : not Gauge mode
Fichiers-Jauge: to-block []	;list of all testing files
pointeurs: copy []			;deal pointer list
Fichier-pbn: none		; current deal for the Gauge
MonoDonne?: to-logic true
NS-wait?: EW-wait?: to-logic false	; enable time counting	
NS-elapsed: 0
EW-elapsed: 0
NS-Previous: 0
EW-previous: 0
match-retour?: false
Dbut-attente: now/time
Match: copy []			; contains games result
report-sheet: copy []	;contains statistical report
NS-Total: 0				; totalized IMP 
EW-Total: 0
tabulations: copy[4 10 17 22 28 35 45 48 53 62 70 77]
Random-IRMAS?: false
Stats?: false		; if statistics module not available
Sauter-donne?: false	;flag if deal skipping is required
first-round-contract: contract
donne-aller: none
image-lead: none
; =================================
; Bid trainig management
; =================================
Mode-Enchres?: false	;flag for bidding training mode
Enchres-Rfrence: copy []	; Bidding suit during bidding training
Visionneuse?: false		;flag for viewer mode
Num-aide: to-integer 1		; next help item
Sauve-com-zone: none		; save current pane before help
Sauve-setup: none			;save current Setup menu
; =================================
; Remote Display management
; =================================
remote-Displays: copy []	;sockets of remote displays in order of connexion
Main-Buffer: copy []			; log of curent game ready for any new remte-display comer
Teams: copy ""					;greeting message for new comers
Compan?: exists? %Compan.exe
; =================================
; FunBridge management
; =================================
Mode-Fun?: false			;flag if mode Fun is activated
Fun-port: none			; specific port ident
Fun-hand: copy []		;block of selected card to send
Main-Saisie: ""			;Name of hand to be returned
seat-saisi: 0
Composeur-main: none
; ==============================================================================================================
;			Second section: GENERAL PURPOSE MODULES
; ==============================================================================================================
either exists? %extras.r[extras?: true do %extras.r][extras?: false]
Lire-autres-Ports: func[
"due to port/awake bizarre behaviour look for other port pending incoming message"
	id [integer!]
	][
	foreach CP Client-Ports [
		if CP/port-id <> id[
if Print? [Prin rejoin ["<" CP/port-id " "]]
			append Communication-log rejoin ["<" CP/port-id " "]
			if not error? char: try [first CP] [Bon-Port: CP break]
		]
	]
	if error? char[exit]
	I: COPY to-string char
	while [newline <> char: first Bon-port] [append I char]
	if Print? [Prin I]
	append last Communication-log I
	append Bon-port/user-data I
	input-message: copy I
	Gestion-Tches Bon-Port
	if Print?[Print rejoin [tab Bon-port/port-id ">"]]
	append Communication-log rejoin [tab Bon-port/port-id ">"]
	if (length? Communication-log) > 100 [remove Communication-log]
	return I
]

List-debug: does[foreach Crd Jeu[Prin join Crd/todo " " Crd/todo: "select"] Print " "]

Translate-PAR: func[PAR [string!]/local a b c d P][
	P: copy either found? find Par "{" [find PAR "{"][PAR]
	replace P "{" ""
	replace P "}" ""
	replace P "PAR of the deal: " ""
	either found? find P "X"[d: copy "X" replace P "X" ""][d: copy ""]
	a: parse P none
	b: to-string first first a
	c: remove first a
	either found? find first a "NT"[
		append b "NT"
		symbole-couleur/show?: false
	][
		insert d "     "
		append d " "
		symbole-couleur/image: switch c[
			"S" [Pique]
			"H" [Coeur]
			"D" [Carreau]
			"C" [Trefle]
		]
		symbole-couleur/show?: true
	]
	append b rejoin[d " " second a played-by]
	append b pick Noms-seats (index? find ["" "south" "west" "north" "east"] replace fifth a ":" "")
	append b find P ":"
]
rounded-time: func[T /local tt][
tt: to-string to-time T
if found? find tt "."[tt: head clear find tt "."]
tt
]
; find card in stack from name
find-card: func[Crd [string!]][pick Jeu (index? find strcardsnames second crd) + (13 * ((index? find colors first crd) - 1))]

Field-rotate: func[Champ Le-block [Block!]][		; Change field content to previous Block item
	k: index? find Le-Block Champ/text
	champ/text: either k = 1[copy last Le-Block][copy(pick Le-Block (k - 1))]
	le-block: head Le-block
	show champ
]
Gestion-Nom: func[Champ Le-Block [Block!]][		; change field content, add if necessary and sort Block
	if found? find Le-Block Champ/text[remove find Le-Block Champ/text]
	append Le-Block copy Champ/text
	le-block: head Le-block
]
Retire-Nom: func[Champ Le-Block [Block!]][
; face "field" does not react to right click!
	if found? find Le-Block Champ/text[remove find Le-Block Champ/text]
	le-block: head Le-block
	Champ/text: last Le-Block
	show champ
]
Attente-rponse: func[Message-attendu [string!]][
" Wait for every client answering a given message. if done, clear all buffers and return true"
	if Client-num <> Client-number [return false]
	foreach Client-port Client-ports [
		either (Client-port/user-data = []) [return false][
			b: first Client-port/user-data
			If not found? find b Message-attendu [return false]
		]
	]
; every expected Client have answered: clear port buffer
	foreach Client-port Client-ports [remove Client-port/user-data]
	return true
]
Stop-Dcompte: does[			;Alert timeout management
	Com-zone/text: copy ""
	com-zone/action: none
	com-zone/blinker: none
	com-zone/font/size: 16
	Alert?: false
	Call-Bid Best-call next-player-seat Peut-Contrer? Peut-Surcontrer?
]
Tronquer: func[ X  D [integer!]/local s exposant][	;rounds a decimal to a limited number of digits
	s: to-string X
	either found? find s #"E"[
		either 0.01 >= absolute x [
			clear find s #"E"
			replace s "." ""
			s: either X > 0 [join ".0" copy/part s 2][join "-.0" copy/part skip s 1 2] 
			][
			s: join first s find s #"E"
		]
		][
		if found? find s "."[head clear skip find s "." (D + 1)]
	]
	s
]
Dispatch-message: does[
" dispatch message without akcnoledgment"
	if print?[prin rejoin [">>" output-message]]
	append Communication-log join ">>" output-message
	if (length? Communication-log) > 100 [remove Communication-log]
	foreach Client-port Client-ports [insert Client-port output-message]
]
; ================================
; Finding General Name of the Player due to his seat
; ================================
Joueur-id: func [
{Finding place of the Player due to his seat (0==> South to 3==> East, clockwise, 4 being 5th chair}
	S [integer!]
	][
	either S > 3 [
		"Coach"
		][
		first skip Joueurs S
	]
]
; ========================
; Test if seat occupied by Trainee
; ========================
Trainee?: func [Rank [integer!]][found? find Trainees (Joueur-id Rank)]	
; ========================
; Test if present computer acts as a Table Manager
; ========================
TM?: does[computer-seat = 4]
; =======================
; Remove Dummy from Trainees and hide if necessary
; =======================
Remove-Dummy: does [
	Main-du-mort: pick Hands (dummy-seat + 1)
	forall main-du-mort[hide first Main-du-mort]
	if Declarer-seat = computer-seat [remove find Trainees Dummy]
	either Dummy-seat = computer-seat[remove find Trainees declarer][
	]
]
;==========================
; List slider management 
;==========================
fix-slider: func [faces [object! block!]][
	foreach list to-block faces [
		list/sn: 0
		list/sld/data: 0
		either 0 = length? list/data [
			list/sld/redrag 1
		][
			list/sld/redrag list/lc / length? list/data
		]
	]
]
;==========================
; get the ip address of this computer 
;==========================
get-ip: does[
either error? try[page: read http://www.whatismyip.com][
	IP-address: join "Internet: " dconnect
	][
	tags: copy [] ; list of tags included in the page
	ttext: copy []; text between tags
; 2 alternate parsing rules separated by |
	html: [
	copy tag ["<" thru ">" ](append tags tag) |
	copy str to "<" (append ttext str)
	]
;process page
	parse page [to "<" some html]
	forall  ttext [if found? find first ttext "IP is" [parse first ttext [thru "Is " copy IP-address to end]break]]
]
	com-zone/text: IP-address
	show com-zone
]
;==========================
; column alignment for match sheet
;==========================
Cale-Text: func[
	T	[String!] ;Text to be cosntructed and aligned
	K	[integer!] ;alignment of added item
	S	[string!]  ;item to add
	][
	x: K - (length? T) - length? S
	for N 1 X 1[append T " "]
	append T S
]
accepter: does[hide-popup]
; =====================================
; removing input message from buffer and signalling Protocol deviation if any
; =====================================
Remove-message: func[Client-port [port!]][
	if input-message <> first client-port/user-data[
		Client: first parse input-message none
		if print? [print join "Protocol deviation of " first client-port/user-data]
		com-zone/text: join Client cart-BCB
		append Communication-log join "Protocol deviation of " first client-port/user-data
		show com-zone
	]
	remove find Client-port/user-data input-message
]
; =====================================
; Dispatching to remote displays
; =====================================
Dispatch-to-remote: does[
; special procedure to handle new comers in middle of af game
; just add the message to the buffer and send to already connected remote displays
	append/only Main-Buffer output-message
	Foreach RD Remote-displays[
		if RD <> Fun-port[
			append/only RD/user-data output-message
			foreach R RD/user-Data[	insert RD R]
			clear head RD/user-data
		]
	]
]
;======================================
; score explaining
;======================================
score-explain: func[
	K [integer!]
	][
	if none? Score-explain?[
		if Score-explain?: exists? %ScoreExplic.r[do %ScoreExplic.r]
	]
	if Score-explain?[
		entre: pick frquences K
		if found? find entre "%"[exit]
		if found? find entre "Pass"[exit]
		Score--trouver/text: second parse entre none
		ns-rad/data: not ew-rad/data: ( #" " = pick entre 8)
		ns-Chk/data: false
		EW-Chk/data: false
		switch V-case[
			"Both" [ns-Chk/data: EW-Chk/data: true]
			"N/S"	[ns-Chk/data: true]
			"E/W"	[EW-Chk/data: true]
		]
;set the inform window
		Res-offset: com-zone/offset + to-pair compose [4 (80 + to-integer(k * 17))] 
		Cherche-contrats
	]
]
Faisabilit: func[F [string!] /local A b c K I][
	a: skip parse F none 1
	K: 11
	forall a [
		I: to-integer first a
		c: either I > 6[I - 6]["-"]
		b: pick making-array/pane K 
		b/text: c 
		K: K + 1
	]
show making-array
]
; =====================================
; task management based on timer
; =====================================
scrute: does[
	either none? retour-timer [
		tempo/color: 150.150.150
		][
		either tempo/color = red [tempo/color: 0.160.0][tempo/color: red]
; remote display reconnexion timeout management
		if computer-seat = 5[
			if retour-timer = "Remote display"[
				either Dcompte > 0[
					Dcompte: Dcompte - 1
					][
					Dcompte: 60
					Remote-reconnect
				]
			exit
			]
		]
		if TM?[if Alert? or illegal-card? or illegal-bid? [
			either statusbar3/color = red[statusbar3/color: pewter][statusbar3/color: red]
		]]
		Arrows-Blink
		if Mode-Continu [PlayBack-tempo: Playback-tempo - 1
			if Playback-tempo = 0[
				Montrer-Pli
				Playback-tempo: 2
			]
		]
		if Match? [
			temps-coul: now/time/precise - Dbut-attente
			if Temps-coul < 0:00:00 [temps-coul: temps-coul + 24:00:00]
			either NS-wait? [NS-elapsed-partial: NS-elapsed + temps-coul][NS-elapsed-partial: NS-elapsed]
			either EW-wait? [EW-elapsed-partial: EW-elapsed + temps-coul][EW-elapsed-partial: EW-elapsed]
				either Match-retour? or IRMAS?[
					Com-zone/text: rejoin ["NS: " rounded-time to-time NS-elapsed-partial tab "IMP: " either IRMAS?[NS-Total][EW-Total]
					newline "EW: " rounded-time to-time EW-elapsed-partial tab "IMP: " either IRMAS?[EW-Total][NS-Total]]
					][
					Com-zone/text: rejoin ["NS: " rounded-time to-time NS-elapsed-partial newline "EW: " rounded-time to-time EW-elapsed-partial]
				]
				if Stats? [append Com-Zone/text rejoin [newline "trend: " st-trend "  " st-estimate "  (R=" R2 "%)"]]
				output-message: join Com-zone/text newline
				Dispatch-to-remote
		]
		if Alert? [
			Dcompte: Dcompte - 1
			if Dcompte < 1 [Stop-Dcompte]
		]
		if extras?[Job1]; look for extras options if present
	]
	show mainWin
]
; ====================================
; Task management related to message reception
;=====================================
Gestion-Tches: func[CP [port!]][
if debug?[probe CP/user-data]
	; processing remote-displays information
	if found? find Remote-displays CP[
		if found? find input-message "PAR of the Deal:"[
			if not none? dbut-calcul[
				Dure-calcul: rounded-time now/time/precise - dbut-calcul
				Dure-calcul: copy next find dure-calcul ":"
				replace Dure-calcul ":" "'"
				Append Dure-calcul {"}
			]
			remove find CP/user-data input-message
			output-message: copy join input-message newline
			dispatch-to-remote
			If CP <> fun-port [
				insert find Donne "[auction" PAR-Comment: rejoin["{" input-message "}" newline]
				insert find Donne "[auction" rejoin["{PAR computation time: " Dure-calcul "}" newline]
				if match?[
					if not IRMAS?[
						dbut-donne: pick pointeurs Numdonne
						F: skip Fichiers-Jauge dbut-donne
						forall f [
							if found? find first F "[auction"[I: index? F break]
							if  "" = trim/all copy first F[I: index? F break]
						]
						insert skip fichiers-jauge I Par-comment
						P: at pointeurs NumDonne
						forall p[q: first p remove p insert p q + 1]
					]
				]
			]
			Par-text/text: copy translate-PAR input-message
			append Par-text/text rejoin[" (" Dure-calcul ")"]
;			show match-aller
			exit
		]
	]
;for remote displays
	if found? find input-message "PAR of the Deal:"[
		remove find CP/user-data input-message
		contrat-aller/text: copy translate-PAR input-message
		exit
	]
	if found? find input-message "match-sheet: "[
		remove find CP/user-data input-message
		Rception-match-sheet?: true
		match: copy []
		exit
	]
	if Rception-match-sheet? [
		remove find CP/user-data input-message
		either Input-message = "End match-sheet"[
			Rception-match-sheet?: false
			if not found? find head CHelp/data "Match sheet"[append CHelp/data "Match sheet"]
			][
			append/only match join input-message newline
		]
		exit
	]
	if Rception-Rfrence? [
		either Input-message = "Fin Rfrence"[
			remove find CP/user-data input-message
			Rception-Rfrence?: false
			if TM? [Trick-remove load-deal exit] 		;launch standard file processing
			if Mode-Enchres?[Rsultats-Enchres]
			exit
			][
			if found? find input-message "&" [
				remove find CP/user-data input-message


				remove input-message
				append/only Donne-Initiale Input-message 
				if found? find input-message "Board"[
					Nom-Donne: copy find input-message {"}
					replace/all Nom-Donne {"}{}
					replace Nom-Donne fin-crochet ""
					statusbar1/text: Nom-Donne
					show statusbar1
				]
				exit
			]
		]
	]
	If found? find Input-message "Rfrence:" [
		remove find CP/user-data input-message
		if TM? [Trainee-port: CP]
		Rception-Rfrence?: true
		statusbar1/text: none
		Donne-Initiale: copy []
		exit
	]
	if found? find input-message "Main saisie: "[
		remove find CP/user-data input-message
		replace input-message "Main Saisie: " ""
		insert fun-port join input-message newline
		receive-hand CP
		exit
	]
	If found? find Input-message "received dummy" [remove find CP/user-data input-message exit]
	If found? find Input-message "Seated" [remove find CP/user-data input-message  Seated-Respond exit]
	If found? find Input-message "ready for teams" [
		if "" <> (form copy disconnected-noms)[remove-message CP]
		if Connect?[
			if (attente-rponse "ready for teams") [
				Envoi-quipes
				if Compan? [call reduce[%compan.exe num-port Foff]]
				exit
			]
			for K 1 4 1[
				C: pick disconnected-Noms K
				if C <> ""[
					clear enchres-lues
					Sige: pick Joueurs K
					Client-port: pick client-ports (index? find Trainees Sige)
					Teams: copy rejoin [{Teams : N/S : "} NS-Team {" E/W : "} EW-Team {"} newline]
					Foreach RD Remote-Displays[insert RD Teams]
					if Print? [Prin Teams]
					append Communication-log Teams
					insert Client-port Teams
				]
			]
		]
		exit
	]
	If found? find Input-message "Teams :" [
		remove find CP/user-data input-message
		Asseoir 
		if computer-seat < 4[Insert CP rejoin [Client-place " ready to start" newline]]
		exit
	]
	If found? find Input-message " ready to start" [
		if "" <> (form copy disconnected-noms)[remove-message CP]
		if Connect?[
			if (attente-rponse " ready to start") [
				if strhands <> none [Dbut-jeu exit]
				if Match? [Prochain-jeu exit]
				exit
			]
			if "" <> (form copy disconnected-noms)[
				Disconnected-Noms: copy ["" "" "" ""]
				if strhands <> none [Dbut-jeu exit]
				if Match? [Prochain-jeu exit]
			]
		]
		exit
	]
	If found? find Input-message "Start of Board" [
		remove-message CP
		reset-display
		either computer-seat = 4[
			Mode-fun?: true		;entering mode Fun
			Fun-port: CP
			clear Client-Ports
			append Client-ports CP
			Emulation
			][
			if computer-seat < 4[Insert CP rejoin [Client-place " ready for deal" newline]]
		]
		exit
	]
	If found? find Input-message "'s bid" [Bid-ready exit]
	If found? find Input-message " ready for deal" [
		flag: to-integer (2 ** ((index? find client-ports CP) - 1))
		Ready-for-Deal: ready-for-Deal or flag		;set the flag
		either Waiting-ready-for-deal?[
			if Ready-for-Deal = All-Ready-for-Deal [send-deal]	
			][ 
			Client: first parse input-message none
			Com-zone/text: rejoin [Client trop-tt1 "Ready for Deal" newline trop-tt2]
			show com-zone
		]
		exit
	]
	If found? find Input-message " ready for cards" [
		flag: to-integer (2 ** ((index? find client-ports CP) - 1))
		Ready-for-Cards?: Ready-for-Cards? or flag		;set the flag
		send-hands
		exit
	]
	If found? find Input-message "Dealer" [Receive-Deal CP exit]
	If found? find Input-message "Dummy's Cards" [Receive-Dummy CP exit]
	If found? find Input-message "'s Cards" [remove find CP/user-data input-message Receive-Hand CP exit]
	If found? find Input-message "bids" [Receive-Bid CP exit]
	If found? find Input-message "passes" [Receive-Bid CP exit]
	If found? find Input-message " doubles" [Receive-Bid CP exit]
	If found? find Input-message "redoubles" [Receive-bid CP exit]
	If found? find Input-message "plays" [
		if mode-fun?[com-zone/text: none show com-zone]
		Receive-card CP
		exit
	]
	If found? find Input-message "to lead" [
		remove find CP/user-data input-message 
		Call-Card Couleur-demande Next-player-seat
		retour-timer: "attente carte"
		 exit
	]
	If found? find Input-message "to trick" [Card-ready  exit]
	If found? find Input-message "ready for dummy" [Dummy-ready  exit]
	If found? find Input-message "End of session" [remove find CP/user-data input-message Quitter?: true Dconnexion  exit]
	If found? find Input-message "Votre place est " [remove find CP/user-data input-message Receive-Place  exit]
	If found? find Input-message "Quitter" [Clore exit]
	If found? find Input-message "Dconnexion" [
		K: index? find Client-ports CP
		remove find system/ports/wait-list CP
		close CP
		remove find Client-ports CP
		Client: pick Clients K
		remove find Clients Client
		if ((length? Clients) = 0) [clear statusbar3/text show statusBar3]
		trainee: to-string first Client
		remove find Trainees trainee
		exit
	]
	If found? find Input-message "Distribuer" [remove find CP/user-data input-message Make-deal  exit]
	If found? find Input-message "Rejouer" [
		remove find CP/user-data input-message 
   	if DummyUnveiled? [
   		remove-Dummy 
   		DummyUnveiled?: to-logic false
   	]
		part-Trick-remove
		load-deal
		exit
	]
	If found? find Input-message "Envoyer rfrence"[
		remove find CP/user-data input-message
		insert CP join "Rfrence:" newline
		foreach L (parse/all Donne to-string newline)[insert CP rejoin["&" L newline]]
		insert CP join "Fin Rfrence" newline
		exit		
	]
	if found? find Input-message "Mode Entranement Enchres Possible" [
		remove find CP/user-data input-message
		CDonnes/data: head CDonnes/data
		append clear CDonnes/data copy Jouer2
		Com-zone/text: Entrainement-Enchres-possible
		Com-zone/action: [Mode-enchres]
		show com-zone
		exit
	]
	if found? find Input-message "Demande Entranement Enchres" [
		remove find CP/user-data input-message
		output-message: join "Entranement Enchres demand" newline
		dispatch-message
		Mode-Enchres?: true
		wait 1
		insert CP join "Ok Entranement Enchres" newline
		exit
	]
	if found? find Input-message "Entranement Enchres demand" [
		remove find CP/user-data input-message
		Mode-Enchres?: true
		statusbar3/text: st-Entranement-Enchres
		show statusbar3
		auction-display/offset: trick-display/offset
		exit
	]
	if found? find Input-message "Ok Entranement Enchres" [
		remove find CP/user-data input-message
		Choix-fichier-initial
		exit
	]
	if found? find Input-message "Mauvaise enchre" [
		remove find CP/user-data input-message
		Bid-result: third parse input-message none
		com-zone/text: rejoin[enchre-attendue newline
			switch/default Bid-result [
				"PASS" [st-Passe]
				"Pass" [st-Passe]
				"X"	[Contre]
				"XX"	[Surcontre]
			]
			[join first Bid-result
			switch second Bid-result [
				#"S" [join " " first noms-couleurs]
				#"H" [join " " second noms-couleurs] 
				#"D" [join " " third noms-couleurs]
				#"C" [join " " fourth noms-couleurs]
				#"N" [join " " last noms-couleurs]
			]]
		]
		show com-zone
		wait 2
		append enchres-lues Bid-result
		Lire-enchre
		exit
	]
	if found? find Input-message Enchre-correcte [
		remove find CP/user-data input-message
		com-zone/text: input-message
		show com-zone
		wait 1
		append enchres-lues Bid-result
		Lire-enchre
		exit
	]
	if found? find Input-message "Donne inapproprie" [
		remove find CP/user-data input-message
		com-zone/text: Donne-inapproprie
		show com-zone
		exit
	]
	if found? find Input-message "Connected" [
		remove find CP/user-data input-message
		Connect?: true
		StatusBar3/text: Connect
		show StatusBar3
		exit
	]
	if found? find Input-message "NS:" [
		remove find CP/user-data input-message
		com-zone/text: join input-message newline
		exit
	]
	if found? find Input-message "EW:" [
		remove find CP/user-data input-message
		append com-zone/text join input-message newline
		show com-zone
		exit
	]
	if found? find Input-message "trend:" [
		remove find CP/user-data input-message
		append com-zone/text input-message
		show com-zone
		exit
	]
	if found? find Input-message "Match-aller:" [
		remove find CP/user-data input-message
		replace Input-message "Match-aller: " ""
		Contrat-aller/text: rejoin [First-round ": " input-message]
		show match-aller
		exit
	]
	if found? find Input-message "Match-aller" [
		remove find CP/user-data input-message
		hide match-aller
		exit
	]
	if found? find Input-message "PAR request" [
		remove find CP/user-data input-message
		exit
	]
	if found? find Input-message "timing" [
		remove find CP/user-data input-message
		exit
	]
	if found? find input-message "Report time"[
		remove find CP/user-data input-message
		switch last parse input-message none[
			"EW" [insert CP rejoin ["Elapsed time by EW" EW-elapsed]newline]
			"NS" [insert CP rejoin ["Elapsed time by NS" NS-elapsed]newline]
		]
		exit
	]
	if found? find input-message "Feasability: "[
		remove find CP/user-data input-message
		feasability-array: copy input-message
		if TM?[
			output-message: join input-message newline
			Dispatch-to-remote
			if not Mode-Fun?[
				insert find Donne "[auction" rejoin["{" feasability-array "}" newline]
				if match?[
					if not IRMAS?[
						dbut-donne: pick pointeurs Numdonne
						F: skip Fichiers-Jauge dbut-donne
						forall f [
							if found? find first F "[auction"[I: index? F break]
							if  "" = trim/all copy first F[I: index? F break]
						]
						insert skip fichiers-jauge I rejoin["{" feasability-array "}"]
						P: at pointeurs NumDonne
						forall p[q: first p remove p insert p q + 1]
					]
				]
			]
		]
		Faisabilit feasability-array
		exit
	]
	if found? find input-message "WB5: "[
		remove find CP/user-data input-message
		com-zone/text: input-message
		show com-zone
		output-message: join input-message newline
		dispatch-to-remote
		exit
	]
	if found? find input-message "suivre: "[
		remove find CP/user-data input-message
		fileBin: replace input-message "suivre: " ""
		fileBin: to-file replace fileBin "C:" "/C"
		h: read/binary fileBin
		write/binary/append %/c/recordX.bin to-char length? h
		write/binary/append %/c/recordX.bin h
		exit
	]
	if found? find input-message "Saisie Main"[		;remote display emulation transfer
		remove find CP/user-data input-message
		Main-saisie: third parse input-message none
		Seat-saisi: to-integer last parse input-message none
		if seat-saisi > 0 [if not Mode-fun?[Paver-Composeur retirer-jetons pick Hands 1]]
		Mode-fun?: true
		Compose-hand
		exit
	]
	if found? find input-message "auto-connect-WB5"[		
		remove find CP/user-data input-message
		auto-connect-WB5
		while[Client-number > length? clients][auto-connect-WB5 wait 1]
		if Client-number = 4[unview MainWin]
		exit
	]
	if extras?[Trouv?: false Job2 if Trouv?[exit]]; look for extras if present
; every recognized message generates an exit. if it gets here, the message was not serviced
; alert and discard message
	either TM?[
		Client: pick Clients (index? find Client-ports CP)
		print rejoin ["Unrecognized message from " CP/port-id " (" Client ") : " input-message]
		][
		Com-zone/text: input-message
		show com-zone
	]
	remove-message CP
]

; ===============================================================================================================
;			Third section - Brigde game management: MONITORING THE AUCTION AND THE PLAY
; ===============================================================================================================
; ================================
; Manual Entry of a hand
; ================================
Emulation: does[
;look for a second remote display. If found transfers the emulation task to it
	foreach RD remote-displays[	if RD <> Fun-Port[
		insert RD join "Start of Board" newline
		insert RD join "Saisie Main South 0" newline
		exit]
	]
	clear Main-buffer
	output-message: join "Start of Board" newline ;to update main-buffer
	dispatch-to-remote
	Main-saisie: "South"
	Seat-saisi: 0
	Compose-Hand
]
Compose-hand: does[
	if not found? find mainwin/pane composeur-main[append mainwin/pane composeur-main]
	composeur-main/offset: south-alpha/offset
	if seat-saisi = 0[clear statusbar3/text]
	com-zone/text: "Emulation WBridge5"
	either seat-saisi = 0[
		paver-composeur
		][
		foreach Crd Jeu [Crd/todo: "select"]
	]
	clear Fun-hand
	lettres?: true	; for small card-token to be responsive
	com-zone/pane: none
	Un-pas/action: [Stacker]		;Playback control panel reprogramming
	Marche-arrt/action: [Envoi-Main]
	Dbut/image: Sans-bouton
	Dbut/action: none
	show mainWin
]
Paver-composeur: does[
	clear alpha-cartes
	Crer-alpha-cartes
	Mains-lettres: copy [["" "" "" ""]["" "" "" ""]["" "" "" ""]["" "" "" ""]]
	dcalage: either lo-res[21x-3][27x-3]
	Step-x: as-pair (largeur-alpha-carte + 1) 0
	Step-y: either lo-res[29][0x35]
	foreach Crd Jeu [
		rang-carte: CRD/user-data
		Crd/todo: "select"
		jeton: get in pick alpha-cartes rang-carte 'face
		jeton/offset: dcalage
		jeton/pane/1/font/color: white
		jeton/pane/1/font/shadow: 1x1
		append Composeur-main/pane/2/pane jeton
		dcalage: dcalage + Step-x
		if (rang-carte // 13) = 0[dcalage/x: either lo-res[21][27]	
			switch rang-carte[
			13 [dcalage: dcalage + Step-y]
			26 [dcalage: dcalage + (Step-y * 2)]
			39 [dcalage: dcalage - Step-y]
			]
		]
	]
]
Card-select: func[f][
	either none? Rang: F/parent-face/user-data[
		rang: f/user-data
		crd: pick jeu rang
		crd/todo: none
		f/pane/1/font/color: crd/couleur
		f/pane/1/font/shadow: none
		][
		crd: pick jeu rang
		f/parent-face/pane/1/font/color: crd/couleur
		f/parent-face/pane/1/font/shadow: none
		crd/todo: "unselect"
	]
	append Fun-hand crd
	com-zone/pane: either 13 = length? fun-Hand[ Playback-Control-panneau][none]
	show com-zone
] 
Card-unselect: func[f][
	Rang: F/parent-face/user-data
	crd: pick jeu rang
			f/parent-face/pane/1/font/color: white
			f/parent-face/pane/1/font/shadow: 1x1
		remove find Fun-hand crd 
		crd/todo: "Select" 
	com-zone/pane: either 13 = length? fun-Hand[ Playback-Control-panneau][none]
	show com-zone
]
hide-card: func[c [string!] /local carte1 carte2 ][
; in emulation mode hide played cards before dummy setup.
	foreach j skip composeur-main/pane/2/pane 4[
		Carte2: Pick jeu j/user-data
		if Carte2/data = c[
			either next-player-seat = dummy-seat[
				either Carte2/todo = "select" [Card-select j][hide j]
				][
				hide j
			]
			show composeur-main
			break
		]
	]
]
Envoi-Main: does[
	Com-Zone/pane: none
	show com-zone
;now ordering according to pbn colors
	B: copy []
	A: copy []
	foreach Col PBN-colors [
		C: copy ""
		Foreach H strCardsnames[	;sorting cards
			foreach Crd fun-hand[
				Crd/seat: Seat-saisi
				if Col = first Crd/data[
					if H = second Crd/data[
						append A Crd
						rang-carte: Crd/user-data
						jeton: get in pick alpha-cartes rang-carte 'face
						Remove find Composeur-main/pane/2/pane jeton
						rang-carte: rang-carte // 13
						if rang-carte = 0[rang-carte: 13]
						append C pick symboles-cartes rang-carte
					]
				]
			]
		]
		append/only B C
	]
	poke Mains-lettres (seat-saisi + 1) B
	poke hands (Seat-Saisi + 1) A
	fun-hand: a
	Evaluer-points Fun-hand Seat-saisi
	either TM?[
		insert fun-port/user-data Main-Saisie 
		send-hands
		][
		insert trainee-port join "Main Saisie: " hand-makes Main-saisie
		com-zone/pane: none
	]
	Lettres?: TM-lettres?
	if seat-saisi <> 0[clear skip composeur-main/pane/2/pane 4]
	remove find MainWin/pane composeur-main
	display-hand fun-hand
	if computer-seat = 5[if enchres-lues = [] [Dveloppement-enchres]]
	foreach crd jeu [crd/todo: none]; passiver les cartes
]
Retirer-jetons: func[F
	][
	foreach Crd F[
		rang-carte: Crd/user-data
		jeton: get in pick alpha-cartes rang-carte 'face
		Remove find Composeur-main/pane/2/pane jeton
	]
]
Stacker: does[
	Dbut/image: Bouton-Dbut
	Dbut/action: [Compose-hand]
	show com-zone
	remove-each j skip composeur-main/pane/2/pane 4[j/pane/1/font/color = 255.255.255]
	dcalage: 25x-3
	Step: as-pair (largeur-alpha-carte + 1) 29
	foreach j skip composeur-main/pane/2/pane 4[
		either J/offset/y = dcalage/y[
			J/offset: dcalage
			dcalage/x: dcalage/x + Step/x
			][
			dcalage: as-pair 25  J/offset/y
			J/offset: dcalage
			dcalage/x: dcalage/x + Step/x
		]
	]
	show composeur-main
]
; ================================
; Make a random deal
; ================================
make-Deal: does [
	Lettres?: TM-Lettres?
	if Lettres?[crer-alpha-cartes set-alpha] 
	reset-to-initial-display
	statusbar4/text: none
	show statusbar4
	NumDonne: NumDonne + 1
	either connect?[append clear head CDonnes/data copy Jouer4][append clear head CDonnes/data copy Jouer2]
	statusbar1/text: rejoin [Random-deal " " to-string NumDonne]
	show statusbar1
	Deal-Event: copy Random-deal
	random/seed now
	Hands-todeal: to-block []
	Cards-names: head cards-names
	Card-Deck: copy []
	forall Jeu[append Card-Deck get in first jeu 'data]
	Jeu: head Jeu
	Colors: head colors
	Nb-Cards: 52
	Clear Hands-todeal
	While [Nb-Cards > 0][
		Card-name: Pick Card-Deck random Nb-Cards
		append Hands-todeal Card-Name
		remove find Card-Deck card-name
		Nb-Cards: Nb-Cards - 1
	]
	Dealer: pick Joueurs ((NumDonne + 1) and 3) + 1
	strhands: copy Dealer 
	append strhands ":"
	for Hd 0 3 1 [
		Main-Joueur: copy/part Hands-todeal 13
		remove/part Hands-todeal 13
		sort/reverse Main-Joueur
		forall PBN-Colors [
			mask: copy "             "
			forall Main-Joueur[
				Card-name: first Main-Joueur
				either (first Card-name) = first PBN-Colors [
					a: second Card-name
					poke mask (index? find strcardsnames a) a
					][
					break
				]
			]
			
			append strhands replace/all mask " " ""
			append strhands either tail? next PBN-Colors [" "]["."]
		]
		PBN-colors: head PBN-Colors
	]
	remove back tail strhands						 
	Vulnerable: pick Vul-squence (((NumDonne - 1) and 15 ) + 1)
	Dealer: mold Dealer ;switch Dealer["N" [{"North"}] "S" [{"South"}] "W" [{"West"}] "E" [{"East"}]]
;============================================
; creating record for current game
;============================================
	Donne-Initiale: Copy [{% PBN 2.0}  "% Import" ]
	append Donne-Initiale rejoin[{[Event } Deal-Event {]}]
	append Donne-Initiale rejoin [{[Date  "} now/date  {"]}]
	append Donne-Initiale rejoin [{[Board "} NumDonne {"]}]
	append Donne-Initiale rejoin [ {[Dealer } dealer {]}]
	append Donne-Initiale rejoin [{[Vulnerable } vulnerable  {]}]
	append Donne-Initiale rejoin[ {[West "} second Noms {"]}]
	append Donne-Initiale rejoin [{[North "} third Noms {"]}]
	append Donne-Initiale rejoin[{[East "} last Noms {"]}]
	append Donne-Initiale rejoin [{[South "} first Noms {"]}]
	append Donne-Initiale rejoin[{[Deal "} strhands {"]}] 
	append Donne-Initiale {[Scoring "IMP"]}
	append Donne-Initiale {[Declarer ""]}
	append Donne-Initiale {[Contract ""]}
	append Donne-Initiale {[Result ""]}
	append Donne-Initiale rejoin[{[Auction "} second dealer {"]}]
	append Donne-Initiale {+}
	launch-deal
]

; ================================
; Auction processing
; ================================
init-Enchres: does[
	Visionneuse?: false
	Hide Freq-display
	Hide color-contract
	hide Alerte-display
	hide Infos-display
	Alert-list: copy []
	Alert-count: 0
	Alert?: false
	if not match?[Com-Zone/text: Evaluer]
	if computer-seat < 4 [Trainees: to-block mold first Trainees]
	retour-Timer: none
	tempo/rate: none
	Part-trick-remove
	Enchres-lues: copy []
	Enchres-connues: to-block []
	Reset-to-initial-display
	Save-seat: none
	statusbar4/text: none
	statusbar3/text:  Attente-enchre
	hide bid-row
	Com-Zone/pane: either match?[bouton-pause][ none]
	clear Bids-suit
	if 2 < length? Trick-Display/pane[clear skip Trick-Display/pane 2]
	hide vision-Enchres
	hide vision-tricks
	hide Trick-Display
	show auction-display
	names-places: head names-places
	Cartes-connues:[]			; en vue du debug
	Cartes-lues:[]			; en vue du debug
	if (length? Dealer) > 1 [Dealer: to-string pick Dealer 2]
	Dealer-Seat: (index? find Joueurs (Dealer)) - 1
	next-player-seat: to-integer Dealer-Seat
	Best-call: "Pass"
	Peut-Contrer?: to-logic false
	Peut-Surcontrer?: to-logic false
	Best-Seat: to-integer 0
	Com-Zone/action: [Evaluation]
	Arrows Dealer-seat
	Arrows-Blink
	retour-timer: "Attente-Enchre"
	tempo/rate: 00:00:01
	Bid-to-Dispatch?: to-logic false
	either Match? [
		append clear head CDonnes/data copy Jouer6
		CDonnes/text: first Jouer6
		Mode-pause-Coup: copy Mode-pause
		][
		Mode-Pause-Coup: copy "Aucune"
	]
]
Dveloppement-Enchres: does [
;this procedure will play and record a new game. formatting Donne prior to start.
	init-enchres
	either connect?[if not match?[append clear head CDonnes/data copy Jouer4]][append clear head CDonnes/data copy Jouer2]
	if DummyUnveiled? [
		restore-Hands
		remove-Dummy 
	]
	DummyUnveiled?: to-logic false
	Contract: none
	if extras?[Job5]
	Atout: copy ""
	Donne: copy ""
	if TM? and (not mode-Fun?)[
		foreach C Donne-initiale[temp: copy C replace temp tab "" if "" <> trim/all copy temp [append Donne join C newline]]
;first erase any previous record
		if not None? start: find Donne "[West " [until[remove start if start = "" [break] (first start) = #"["]]
		if not None? start: find Donne "[North " [until[remove start if start = "" [break] (first start) = #"["]]
		if not None? start: find Donne "[East " [until[remove start if start = "" [break] (first start) = #"["]]
		if not None? start: find Donne "[South " [until[remove start if start = "" [break] (first start) = #"["]]
		if not None? start: find Donne "[Auction " [until[remove start if start = "" [break] (first start) = #"["]]
		if not none? start: find Donne "[Declarer " [until[remove start if start = "" [break] (first start) = #"["]]
		if not none? start: find Donne "[Contract " [until[remove start if start = "" [break] (first start) = #"["]]
		if not none? start: find Donne "[Play " [until[remove start if start = "" [break] (first start) = #"["]]
		if not none? start: find Donne "[Result " [until[remove start if start = "" [break] (first start) = #"["]]
;then set new entries
		append Donne rejoin [Dbut-Crochet {South "} first Noms {"} Fin-Crochet newline ]
		append Donne rejoin [Dbut-Crochet {West "} second Noms {"} Fin-Crochet newline ]
		append Donne rejoin [Dbut-Crochet {North "} third Noms {"} Fin-Crochet newline ]
		append Donne rejoin [Dbut-Crochet {East "} fourth Noms {"} Fin-Crochet newline ]
		append Donne rejoin [Dbut-Crochet {Declarer ""} Fin-Crochet newline ]
		append Donne rejoin [Dbut-Crochet {Contract ""} Fin-Crochet newline ]
		append Donne rejoin [Dbut-Crochet {Result ""} Fin-Crochet newline ]
		if not none? PAR-comment[append Donne join PAR-Comment newline]
		if not none? feasability-array[append Donne rejoin ["{" feasability-array "}" newline]]
		append Donne rejoin [Dbut-Crochet {Auction "} Dealer {"} Fin-Crochet newline "+"]
		write DonneRef Donne
	]
	Lire-Enchre
]
Lire-Enchre: does [
	Caller-Rank: 0
	Enchres-connues: head Enchres-connues
	if enchres-lues <> [][
		if enchres-lues <> enchres-connues[
			Enchre: copy last Enchres-lues
			Caller: ((Length? enchres-lues) + Dealer-Seat - 1) // 4
			Affiche Enchre			; Display the new bid on the board
			append Enchres-connues Enchre
			if computer-seat >= 4 [
				Bid-to-Dispatch?: to-logic true
				Either Alert?[
					statusBar3/text: rejoin [Enchre "   " st-Alert]
					statusBar3/color: red
					tempo/rate: 0.5
					][
					statusBar3/color: pewter
					tempo/rate: 1
				]
				show statusbar3
			]				
			either TM? [
				If enchre <> "Pass"[
					switch Mode-Pause-Coup[
						"Aucune" [Alert?: false]	;[]
						"Toujours" [
							either Alert?[
								Traite-alerte
								][
								switch/default Enchre[
									"X" [Traite-alerte]
									"XX" [Traite-alerte]
								]
								[either (to-integer to-string first Enchre) > 1[
									Traite-Alerte
									][
									If Enchre = "1NT"[
										if best-Call <> "Pass"[if odd? (Best-Seat - Caller)[Traite-Alerte]]]
									]
								]	
							]
						]
						"Alerte" [if Alert?[Traite-Alerte]]
					]
				]
				][
				either Alert?[
					Dcompte: to-integer 10
					Com-Zone/text: copy st-Alert
					Com-Zone/action: [Stop-Dcompte]
					com-zone/font/size: 40
					][
					Com-Zone/text: copy ""
					Com-Zone/action: none
					com-zone/font/size: 16
				]
				show MainWin
			]
			if Enchre <> "Pass" [
				either Enchre = "X" [
					Contre?: to-logic true
					SurContre?: to-logic false
					][
					Contre?: to-logic false
					SurContre?: to-logic false
				]
				if Enchre = "XX" [
					Contre?: to-logic false
					SurContre?: to-logic true
				]
				if (not Contre?) and (Not SurContre?) [
					if best-Call <> "Pass"[if odd? (Best-Seat - Caller)[comp?: true]]	;flag for competitive bidding
					Best-call: Enchre
					Best-Seat: Caller
					Best-Caller: Joueur-id Best-Seat
				]
			]  		; fin d'une enchre autre que Passe
		]				;fin de traitement d'une nouvelle enchre
		If Play? [Fin-Enchres Exit]
		next-player-seat: (Caller + 1) // 4
	]
	if Best-call <> "Pass" [			;gestion des autorisation de contre et surcontre
		Equipe: (next-player-seat - Best-Seat) // 2
		either Equipe = 0 [
			Peut-Contrer?: to-logic false
			Peut-Surcontrer?: to-logic Contre?
			][
			Peut-Contrer?: to-logic ((not Contre?) and (not SurContre?))
			Peut-Surcontrer?: to-logic false
		]
	]
	if Bid-to-Dispatch? [Bid-dispatch Enchre Caller]
	StatusBar3/color: pewter
	StatusBar3/text: attente-enchre
	Call-Bid Best-call next-player-seat Peut-Contrer? Peut-Surcontrer?
	retour-timer: "attente-enchre"
	show mainwin
]

; ========================
; Define now the final Contract and the Declarer
; ========================
Fin-Enchres: does [
	Com-Zone/text: ""
	Com-Zone/action: none
	ArrOn: ArrOff
	if not lettres?[show Fle]
	either Best-call = "Pass" [
		Contrat: "Pass"
		Contract: copy "Pass"
		StatusBar3/text: Tout-passe
		score: 0
		if TM? and (not mode-fun?)[
			k: index? find Donne "[Contract"
			insert find (skip Donne k) {"]} Contrat 
			remove back tail donne		; supprimer le "+"
			append Donne newline
			write DonneRef Donne
		]
		wait 1
		][
		Color: to-string Best-call
		Color: join "?" (remove Color)
		Contract: to-string first (skip tail Enchres-connues -4)		; 3 Pass at the end
		if (Contract = "X") [Contract: join Best-call Contract]		; contract has been doubled
		if (Contract = "XX") [Contract: join Best-call Contract]		; contract has been redoubled
		Rank: 0
		enchres-lues: head enchres-lues
		foreach enchre Enchres-lues [
			Declarer-seat: (Rank + Dealer-Seat) // 4
			if Enchre <> "Pass" [
				if (Declarer-Seat - Best-Seat) // 2 = 0 [if found? find/any Enchre Color [Break]]]		
			Rank: Rank + 1
		]
		Declarer: Joueur-id Declarer-Seat
		Afficher-Contrat
; Put the result of auction in the PBN deal
		P: pick Names-places (Dummy-seat + 1)
		P/text: main-mort
		show P
		Light: pick Lights (Dummy-seat + 1)
		poke Light/effect 2 'yellow 
		show light
		if TM? and (not mode-fun?)[
			either Mode-Enchres?[
				][
				remove back tail donne		; supprimer le "+"
				if alert-count > 0[foreach l Alert-list[append Donne join newline L]]
				either error? try[k: index? find Donne "[Declarer"][
					append donne rejoin[Dbut-Crochet {Declarer "} Declarer {"} fin-crochet newline] 
					][
					insert find (skip Donne k) {"]} Declarer
				]
				either error? try[k: index? find Donne "[Contract"][
					append donne rejoin[Dbut-Crochet {Contract "} Contract {"} fin-crochet newline] 
					][
					insert find (skip Donne k) {"]} Contract
				] 
				append Donne {
[Play "}
				append Donne Joueur-id Leader-Seat
				append Donne {"]
+}
				replace/all Donne rejoin [newline newline] newline
				write DonneRef Donne
				Donne-ToPlay: Donne	;Remind Game ready to play
				if Match?[
; find if bidding has been pushed higher to prevent bonus score
					Rank: index? find copy enchres-lues best-call
					either Rank > 3[
						if niveau-manche? (pick enchres-lues (rank - 1))[very-comp?: true]
						if niveau-manche? (pick enchres-lues (rank - 3))[very-comp?: true]
					][
						switch rank[
							2 [if niveau-manche? (first enchres-lues) [very-comp?: true]]
							3 [if niveau-manche? (second enchres-lues) [very-comp?: true]]	
						]
					]
					if pause-Auction?[
   					Bouton-suivante/text: Jeu-Carte
   					Bouton-suivante/action: [Bid-dispatch Enchre Caller Play]
   					Bouton-revoir/text: st-suivante
   					Bouton-revoir/action: [com-zone/pane: none suivante]
   					Bouton-rejouer/show?: true
   					Bouton-prev/show?: false
   					com-zone/pane: Suite-Box
   					show com-zone 
   					exit
					]
				]
			]
		]
	]
	if Bid-to-Dispatch? [Bid-dispatch Enchre Caller]
	either Mode-Enchres? [
		if not TM?[insert trainee-port join "Envoyer Rfrence" newline]
		][
		Play
	]
	if TM?[
		if mode-fun?[
			if contract = "Pass" [exit]
			either Declarer-seat = 2[
				Main-saisie: "North"
				Seat-saisi: 2
				][
				Seat-saisi: (Declarer-seat + 2) and 3
				Main-saisie: Pick["West" "North" "East"] Seat-saisi 
			]
;look for a second remote display. If found transfers the emulation task to it
			pas-trouv?: true
			foreach RD remote-displays[	if RD <> Fun-Port[
				insert RD rejoin ["Saisie Main " Main-saisie " " Seat-saisi newline]
				pas-trouv?: false
				break]
			]
			if pas-trouv?[Compose-Hand]
		]
	]
]
Rsultats-enchres: does[
	Bouton-revoir/show?: false
	Bouton-rejouer/show?: false
	Bouton-revoir/text: Voir
	Bouton-suivante/show?: Bouton-rejouer/show?: (0 < length? fichiers-Jauge)
	foreach X donne-initiale[
		if found? find X "Contract" [Atout: to-string second (second parse x none)]
		if found? find X "Result" [Result: to-integer (second parse x none)]
		if found? find X "Play" [Bouton-revoir/show?: true]
	]
	if Atout = "N" [Atout: ""]
	Afficher-marque
	com-zone/pane: Suite-Box
	show com-zone 
]
niveau-manche?: func [E[string!]][
	switch/default E [
		"pass" [return false]
		"X"	[return false]
		"XX"	[return false]
	][either "3NT" = first e [return true][if 3 < to-integer to-string first E[return true]]]
	return false
]
;=========================
; Contract Display
;=========================
Afficher-Contrat: does[
	Contrat: to-string Contract
	Mess: copy to-string First Contract
	either found? find Contract "NT" [
		append Mess rejoin [" " skip Replace Contrat "NT" last couleurs 1]
		color-contract/show?: false
		][
		append Mess "      "
		If Found? find Contract "X"[append Mess "X" if found? find Contract "XX"[append Mess "X"]]
		color-contract/image: switch second Contract[
			#"S" [pique]
			#"H" [coeur]
			#"D" [carreau]
			#"C" [trefle]
		]
		color-contract/show?: true
	]
	append Mess switch Declarer-seat [
		0 [rejoin [played-by second Noms-seats]]
		1 [rejoin [played-by third Noms-seats]]
		2 [rejoin [played-by fourth Noms-seats]]
		3 [rejoin [played-by last Noms-seats]]
	]
	StatusBar3/text: Mess
	show statusbar3
	Leader-Seat: (Declarer-Seat + 1) // 4 
	Dummy-Seat:  (Declarer-Seat + 2) // 4
	Dummy: pick joueurs (Dummy-seat + 1)
]


; ========================
; End of Auction?
; ========================
Play?: does [
	Count: to-integer 0
	A: copy next Enchres-connues 	; skip any first "pass" 
	Foreach Enchre A [
		either Enchre = "Pass" [
			Count: Count + 1
			if count = 3 [return true]
			][ 
			Count: to-integer 0
		]
	]
	return false
]

;==================================
; Card Playing
;==================================
Play: does [
	if Contrat = "Pass" [Fin-jeu exit]
	if TM?[if not Match?[if not mode-Fun?[DF-file]]]
	foreach C jeu[C/todo: none]
	foreach C alpha-cartes[C/todo: none]
	Com-Zone/action: none
	Com-Zone/pane: either match?[bouton-pause][ none]
	Com-Zone/text: ""
	either computer-seat > 3 [			;Coach and remote display
		trick-display/size/y: 60
		show trick-display
		If TM?[
			if Permanent-Pause-Leve?[Pause-Leve?: true]
			either connect?[
				either Match?[
					append clear head CDonnes/data copy Jouer7
					CDonnes/text: first Jouer7
					][
					append clear head CDonnes/data copy Jouer5
				]
				][
				append clear head CDonnes/data copy Jouer2
			]
		]
		; when connected only start again at beginning is possible using Blue Chip Protocol
		][
		show vision-Enchres
		show vision-tricks
		append clear head CDonnes/data copy Jouer4	;menu du joueur distant
	]
	if extras? [Job3]
	CDonnes/text: Jeu-carte
	show CDonnes
	Couleur-demande: none
	clear Tricks-suit
	Trick-Count: to-integer 1
	either found? find Contract "NT" [
		Atout: copy ""
		][
		Atout: to-string pick Contract 2
	]
	If DummyUnveiled? [
		Restore-Hands
		Part-Trick-Remove		; in case of replay
	]
	Clear Trick
	Next-Player-Seat:  Leader-Seat
	Trick-First-Player: Leader-Seat
	Arrows Leader-Seat
	either Trainee? Dummy-seat[
;special mode for single distant player
		if (client-number = 1) or Training? [
			if not trainee? Declarer-seat [
				N: pick Names-places (Declarer-seat + 1)
				P: pick Noms (Dummy-seat + 1)
				N/text: either P = "Coach" [pick Noms-seats Dummy-seat + 2][copy P]
				Append trainees (Pick Joueurs Declarer-seat + 1)
				s: dummy-seat
				dummy-seat: declarer-seat
				declarer-seat: s
			]
		]
		][
		if trainee? Declarer-Seat [Append trainees (Pick Joueurs Dummy-Seat + 1)]
	]
	if TM? [if trainee? trick-first-player [Trick-Leader]]
	DummyUnveiled?: to-logic false
	Cartes-Connues: copy []
	Cartes-lues: copy []
	Ns-Tricks: to-integer 0
	EW-Tricks: to-integer 0
	Display-Trick-Count
	Lire-Carte
]
Lire-Carte: does [
	retour-timer: none	;disarm timer action
	if cartes-lues <> [] [
		if Cartes-lues <> Cartes-connues [
			Carte-lue: last Cartes-lues
				if none? Couleur-demande [
				If Trick-Count > 1 [Trick-remove] 	;premire carte leve: enlve prcdentes
				Couleur-demande: to-string Pick Carte-lue 1
			]
			Append Cartes-Connues Carte-lue
			either TM-lettres?[
				alpha-Card-Display Carte-lue Next-Player-Seat
				][
				Card-Display Carte-lue Next-Player-Seat
			]
			if not DummyUnveiled? [
				DummyUnveiled?: to-logic true

				Effacer-Bids
				If Not TM?[		; acting as TM: this feature is not offered
					if declarer-seat = computer-seat[
						Com-Zone/text: Evaluer
						Com-Zone/action: [Evaluer-coup]
						show Com-zone
					]
				]
			]
			Cartes-Joues: length? cartes-connues
			Joueur-en-suspens: next-player-seat
			either ((length? Trick) = 4) [		;la leve est complte: Trick winner?
				Trick-Winner: Win-Trick ;trick/cards Trick/seats
				Either even? Trick-Winner [NS-Tricks: NS-Tricks + 1][EW-Tricks: Ew-Tricks + 1]
				a: pick trick-display/pane ((memo-length: length? trick-display/pane) - 3 + ((Trick-Winner - Trick-First-player + 4) // 4))
				a/pane/1/color: 255.200.0
				show a
				if odd? trick-winner - declarer-seat[
          O: to-pair compose [0  ((20 * Trick-count) + 3)]
					insert skip trick-display/pane (memo-length - 4 )layout/offset/size[backdrop orange] O 197x14
				]
				Display-Trick-Count
				Trick-First-Player: Trick-Winner
				Next-Player-Seat: Trick-Winner
				if TM? [Card-Dispatch Carte-lue Joueur-en-suspens]	;for remote players
				Couleur-demande: none
				Trick-Count: Trick-Count + 1
				Either Trick-Count = 14 [Fin-jeu Exit][
					if trainee? trick-first-player [
						if TM? [
							either Pause-Leve?[
								com-zone/pane: Playback-Control-panneau
								show com-zone
								][
								Trick-Leader
							]
						]
					]
					if extras? [Job4]
				]
				if trick-count < 14[trick-display/size/y: 20 + (trick-count * 20)]
				][						; Fin de traitement d'une leve
				Next-Player-Seat: (Next-Player-Seat + 1 ) // 4
				if TM? [Card-Dispatch Carte-lue Joueur-en-suspens]	;for remote players
			]
		]						; fin de traitement d'un nouvelle carte joue
	]
	if Next-player-seat = trick-first-player [
		if computer-seat = next-player-seat [if computer-seat <> dummy-seat [exit]]
		if ((dummy-seat = trick-first-player) and (computer-seat = declarer-seat))[
			exit
		]
	]
	Call-card Couleur-demande Next-Player-Seat
	tempo/rate: 1
	retour-timer: "attente-carte"
]
;================================
; end of game processing
;================================		
Fin-Jeu: does[
	if extras?[Job12]
	either Contrat = "Pass"[
		score: 0
		][
		Afficher-marque
		if Dummy-seat < length? Client-Lights [	;switch off dummy light
			L: pick lights (Dummy-seat + 1)
			L/effect: copy (pick Client-Lights (Dummy-seat + 1))
		]
		if (client-number = 1) or training?[
			s: Dummy-seat
			Dummy-seat: declarer-seat
			Declarer-seat: s
		]
	]
	DummyUnveiled?: to-logic false
	if computer-seat = 5 [if not mode-fun?[hide match-aller exit]]
	if (found? find CDonnes/data Advice) [remove find CDonnes/data Advice]
	retour-timer: none
	tempo/rate: none
	Fle/image: ArrOff
	either lettres?[
		if not none? Save-seat[
			a: pick alpha-hands save-seat
			a/Pane/3/effect: Save-Light
			a/pane/1/show?: true 
			show a
		]
		][
		show Fle
	]
	Com-Zone/action: none
	strhands: none		; effacer la main pour indiquer aucune donne prsente.
	either TM? [
		if lettres? [hide North-alpha Hide South-alpha Hide East-alpha hide West-alpha]
		if not mode-fun?[
			if Contrat <> "Pass" [
				remove back tail donne		; supprimer le "+"
				either error? try[k: index? find Donne "[Result"][
					append donne rejoin[Dbut-Crochet {Result "} Result {"} fin-crochet newline] 
					][
					insert find (skip Donne k) {"]} Result
				]
				append Donne newline
				write DonneRef Donne
			]
			save-auto
			Donne-aller: parse/all donne "^/"
		]
		If not found? find CDOnnes/data Save-Deal [append CDonnes/data Save-deal]
		if not Mode-fun?[
			either connect? [
				if not Match?[
					if 0 <> length? fichiers-jauge [
						Bouton-revoir/text: st-Revoir
						com-zone/pane: Suite-Box
						show Suite-Box
						show com-zone
					]
				]
				][
				Bouton-revoir/text: st-Revoir com-zone/pane: Suite-Box show Suite-Box
				show com-zone
			]
		]
		][
; if present computer is not TM (LocalHost) then save the game for optional late review.
		if Computer-seat < 4 [
			wait 1
			insert Trainee-Port join "Envoyer rfrence" newline
			if 0 <> length? fichiers-jauge [Bouton-revoir/text: st-Revoir com-zone/pane: Suite-Box show Suite-Box
				show com-zone ]
			if found? find statusbar1/text random-deal [
				numDonne: to-integer replace last parse statusbar1/text none "#" ""
				Bouton-revoir/text: st-Revoir com-zone/pane: Suite-Box show Suite-Box
				show com-zone ]
		]
	]
	either Match? [
		Trick-remove
; version 18 time report
		NS-time: copy next find rounded-time  (NS-elapsed - NS-previous) ":"
		EW-time: copy next find rounded-time  (EW-elapsed - EW-previous) ":"
		NS-previous: NS-elapsed
		EW-previous: EW-elapsed
		output-message: rejoin[
			"Timing - N/S : this board  " NS-time
			",  total  " rounded-time NS-elapsed
			".  E/W : this board  " EW-time
			",  total  " rounded-time EW-elapsed
			newline
		]
		if version18 <> 0[wait 1]
		for K 1 4 1[
			flag: to-integer 2 ** (K - 1)
			if 0 < (Flag and Version18) [insert pick Client-ports K output-message]
		]
		Match-record
		if Match-retour? or IRMAS?[
			Com-zone/text: rejoin ["NS: " rounded-time to-time NS-elapsed tab "IMP: " either IRMAS?[NS-Total][EW-Total]
			newline "EW: " rounded-time to-time EW-elapsed tab "IMP: " either IRMAS?[EW-Total][NS-Total]]
			if Stats? [append Com-Zone/text rejoin [newline "trend: " st-trend "  " st-estimate "  (R2=" R2 "%)"]]
			output-message: join Com-zone/text newline
			Dispatch-to-remote
		]
		][
		Com-Zone/text: ""
		wait 3
		Trick-remove
; end of game
	]
	either TM? [
;reset dummy to it's original
		Trainees: copy []
		foreach C Clients [ append Trainees (to-string first C)] 
		][
		tempo/rate: 1
	]
	if extras?[Job5]
	show MainWin
]
; ===============================
; Restore to PBN standard
; ===============================
Restore-PBN: does [
" Rearrange the trick order to conform PBN standard for file saving"
	replace/all Donne rejoin [newline newline] newline	; remove empty lines if any
	Donne-Asauver: copy Donne
	if Contrat <> "Pass" [
		Trick-First-Player: Leader-Seat
		Start: index? find Donne "Play "
		clear find (skip Donne-Asauver Start) newline
		Append Donne-Asauver newline
		Cartes: copy cartes-connues
		For Trick-Count 1 13 1[
			Trick-Cards: copy/part cartes 4
			if Trick-Count > 1 [
				while [((get in (find-card first Trick-cards) 'seat) <> Leader-Seat)][
					append trick-cards (first trick-cards)
					remove trick-cards
				]
			]
			forall Trick-cards [
				append Donne-ASauver first Trick-Cards
				append Donne-Asauver (either (tail? next Trick-cards) [Newline][tab])
			]
			clear Head Trick-cards
			remove/part cartes 4
		]
	]
	replace/all Donne-Asauver tab " "
	append Donne-Asauver newline
]
;================================
; automatic saving in log file
;================================
Save-auto: does[
	Restore-PBN
	either Match?[
		write/append Nom-Fichier-Asauver Donne-Asauver
		if not none? Backup-path[write/lines join Backup-path Nom-Fichier-Asauver Donne-Asauver]
		][
		Write/append to-file "Bridge Moniteur log.pbn" Donne-Asauver
	]
]
;================================
; manual requested game saving
;================================
Sauver: does[
	Restore-PBN
	Fichier-Asauver: none
	while [none? Fichier-Asauver]
		 [Fichier-Asauver:  request-file/title/only/filter/save st-Sauvegarder st-Save "*.pbn"
		if None? Fichier-ASauver[inform save-file]
	]
	If Fichier-Asauver = 0 [exit]
	If not found? find Fichier-Asauver ".pbn" [append Fichier-Asauver ".pbn"]
	Write/append Fichier-Asauver Donne-Asauver
]
; ===============================
; Trick winner determination
; ===============================
Win-Trick: does [
	Trick-Player: trick-first-player
	Best-Value: 13
	Best-Trump: 14
	foreach C Trick [
		Couleur-Fournie: to-string first (get in C 'data)
		Valeur: (((get in C 'user-data) - 1) // 13) + 1
		either Couleur-Fournie = Atout [
			if Best-Trump > Valeur [
				Best-Trump: Valeur
				Trick-Winner: Trick-Player
			]		
			][
			if Best-Trump = 14 [				;il n'y a pas eu d'atout de jou
				if Couleur-Fournie = Couleur-demande [
					If Best-Value > Valeur [
						Best-Value: Valeur
						Trick-Winner: Trick-Player
					]
				]
			]
		]
		Trick-Player: (Trick-player + 1) // 4
	]
	return Trick-Winner		
]
; ==========================
; Scoring
; ==========================
Afficher-marque: does[
	if not (Mode-Enchres? or Visionneuse?)[either declarer-Seat // 2 = 0 [result: NS-Tricks][Result: EW-Tricks]]
	Contract-Level: to-integer (to-string (first Contract))
	Rel-Result: Result - 6 - Contract-level
	score: marque
	if Rel-Result = 0 [StatusBar4/text: join Juste-Fait to-string score]
	if Rel-Result > 0 [StatusBar4/text: rejoin [Plus to-string Rel-Result "   " to-string score]]
	if Rel-Result < 0 [StatusBar4/text: rejoin [(to-string (- Rel-Result)) chute  to-string score]]
	show StatusBar4
]
Marque: does [
; first determine if the declarer is vulnerable
	V-Decl?: to-logic False
	replace Vulnerable "/" ""
	Switch Vulnerable [
		{"All"}	[V-Decl?: to-logic true]
		{"Both"}	[V-Decl?: to-logic true]
		{"EW"}	[if (Declarer-seat // 2 = 1) [V-Decl?: to-logic true]]
		{"NS"}	[if (Declarer-seat // 2 = 0) [V-Decl?: to-logic true]]
		"All"		[V-Decl?: to-logic true]
		"Both"	[V-Decl?: to-logic true]
		"EW"		[if (Declarer-seat // 2 = 1) [V-Decl?: to-logic true]]
		"NS"		[if (Declarer-seat // 2 = 0) [V-Decl?: to-logic true]]
	]
	Contre?: Surcontre?: to-logic false
	if (last Contract) = #"X" [contre?: to-logic true]
	if ((skip tail contract -2) = "XX") [Surcontre?: to-logic true]
	Col: to-string second Contract
	Contract-level: to-integer to-string first Contract
	N0: Contract-level * (switch Col ["C" 20 "D" 20 "H" 30 "S" 30 "N" 30])
	if Col = "N" [N0: N0 + 10]
	If contre? [N0: N0 * 2 if surcontre? [N0: N0 * 2]]
	either Rel-Result >= 0 [		; successful contract
		either N0 < 100 [Prime: 50][either V-Decl? [Prime: 500][Prime: 300]]
		Prime-Chelem: 0
		If Contract-level = 6 [Prime-Chelem: either V-Decl? [750][500]]
		If Contract-level = 7 [Prime-Chelem: either V-Decl? [1500][1000]]
		M: N0 + Prime + Prime-Chelem
		eitHer Contre? [
			M: M + 50 + (Rel-Result * 100)
			if V-Decl? [M: M + (Rel-Result * 100)]
			if Surcontre? [
				M: M + 50 + (Rel-result * 100)
				if V-Decl? [M: M + (Rel-Result * 100)]
			]
			][
			M: M + (Rel-Result * (switch Col ["C" 20 "D" 20 "H" 30 "S" 30 "N" 30]))
		]
		][				; contrat chuts
		M: rel-Result * Either V-decl? [100][50]
		if Contre? [
			M: M * 2 + ((Rel-Result + 1) * 100)
			if Rel-Result < -3 [if not V-Decl? [M: M + ((Rel-Result + 3) * 100)]]
		]
		If SurContre? [M: M * 2]
	]
	return M	 
]
;==========================
; IMP scoring
;==========================
IMP: func[
; compute the imp for a given score diference
	D [integer!]
	][
	if D > 3990 [return 24]
	imp-points: head imp-points 
	forall imp-points [if D < first imp-Points [return (index? imp-points) - 2]]
]
; ===============================
; reprise de la donne au dbut des enchres
; ===============================
Reprise-Donne: does [			;Coach ask for restarting game at auction
	Part-trick-remove
  	if DummyUnveiled? [
  		remove-Dummy 
  		DummyUnveiled?: to-logic false
  	]
	if lettres?[crer-alpha-cartes]
	either connect? [
		If not TM? [		; Client requests to play a specified deal
			Output-message: rejoin ["Rejouer" newline]
			insert trainee-port output-message
			exit
		]
		foreach CLient-Port client-ports[while [Client-port/user-data <> []][remove Client-port/user-data]]
		Enchres-lues: copy []
		Effacer-Bids
		load-deal 
		][
		load-hands Donne-initiale
		Dveloppement-Enchres
	]
]
; ===============================
; Reprise de la donne en cours au jeu de la carte
; ===============================
Reprise-Play: does [			;Coach ask for restarting game at play of cards
; cannot work! was based on file change monitoring
	Donne: Donne-ToPlay
	write DonneRef Donne-ToPlay
	Part-trick-remove
	Play
]

;==============================================================================================================
;		Fourth section - Automatic Game chaining
;==============================================================================================================
;=============================
; Formatting match sheet
;=============================
Match-Setup: does[
	match-retour?: false
	numDonne: 1
	if not random-IRMAS?[NumDonne: 0]
	clear match
	append match rejoin["Event: " Deal-Event]
	g: join either IRMAS?["Team 1  NS: "]["Round 1  NS: "] NS-Team
	cale-text g 45 "IMP: 0"
	cale-text g 68 "Total Time: 0"
	append match g
	g: join either IRMAS?["Team 2  EW: "]["Round 2  NS: "] EW-Team
	cale-text g 45 "IMP: 0"
	cale-text g 68 "Total Time: 0"
	append match g
	team1: copy/part NS-team 7
	team2: copy/part EW-team 7
	while [7 > length? team1][append team1 " "]
	while [7 > length? team2][append team2 " "]
	append match "BOARD VULN.  CONTR  BY RESULT NS-Score| CONTR BY RESULT NS-Score|Team 1|Team 2|"
	write/lines Match-sheet match
	if not found? find head CHelp/data "Match sheet"[append CHelp/data "Match sheet"]
	If stats?[Report-Setup]
]
;=====================================
; Match context: a previous unfinished match has been detected: should go on?
;=====================================
Poursuivre?: does[
	Rep: none
	inform/offset Veut-Poursuivre? to-pair Compose[(table-width) 20]
	return rep
]
;=====================================
; Match context: saving match information file if desired
;=====================================
Sauver-Fichier: func [F][
	inform layout [
		backdrop Couleur-Com effect[tile]
		vh2 existe-dj
		vh2 Voulez-sauver
		across
		Button Oui 52x26 [
			hide-popup 
			File-to-save: none
			While [none? File-To-save][
				File-to-save:  request-file/title/only/filter/file Sauve-rsultats st-Save "*.pbn" copy F
				if None? File-to-save[
					inform layout[
						backdrop Couleur-Com effect[tile]
						vh2 aucun-fichier
						vh2 recommencer
						across button Oui [Hide-popup] button Non [File-to-save = 0 Hide-popup]
					]
				]
			]
			if File-to-save = 0 [match-setup hide-popup exit]
			If not found? find File-to-save ".pbn" [append File-to-save ".pbn"]
			rename F second split-path File-to-save
 		]
	Button Non 52x26 [ delete F hide-popup]
	]
	match-setup
]
Reprer-donnes: does[
"indexes pbn deals in a text"
	ND: Copy []
	K: 0
	LigneVide?: to-logic true
	foreach C texte [
		K: K + 1
		D: copy C
		D: replace/all D " " ""
		D: replace/all D {tab} ""
		either D = "" [
			LigneVide?: to-logic true
			][
			if LigneVide? [LigneVide?: to-logic False append ND K]
		]
	]
	return ND
]
;====================================================
; tournament managing section
;====================================================
Jauge: does [
{Ask for picking a file in a folder and will proceed to implicitely treat all specified files}
	Match?: to-logic true
	if IRMAS?[
		random-IRMAS?: true
		Standard?: false 
		INFORM/title choix-alatoire "Deal sourcing"
		if standard?[
			change-prefs
			chk4/data: false
			chang?: true
			tournoi-auto?: false
			change-dir Rpertoire
			view/title MainWin join "Bridge Moniteur version " version
			exit
		]
		if exists? %stats.r [Stats?: true do %stats.r]
	]
	either random-IRMAS?[
		NumDonne: 0
		make-deal
		statusbar1/text: rejoin [Etui NumDonne]
		fichiers-Jauge: copy donne-initiale
		monodonne?: true
		][
		Choix-fichier-rpertoire
		if nom-complet-fichier = 0 [exit]
	]
; if many deals are in this file then follow BCB_TM way of handling
	clear head CDonnes/data		; no play menu available in this mode
	lettres?: TM-lettres?
	if lettres?[Set-alpha]
	NS-elapsed: EW-elapsed: 0
	NS-wait?: EW-wait?: to-logic false
	either MonoDonne?[
		either random-IRMAS?[
			Deal-Event: Random-deal
			][
			Deal-Event: last parse/all Donnes-dir "/"
		]
		][
		either found? find fichier-pbn "." [Deal-Event: copy head clear find copy fichier-pbn "."][Deal-Event: fichier-pbn]
	]
	if found? find Deal-Event " "[Deal-Event: head clear find Deal-Event " "]
	if found? find Deal-Event "-"[Deal-Event: head clear find Deal-Event "-"]
	Matre
	rad4/data: true
	hide t1
	hide t2
	hide t3
	hide rad1
	hide rad2
	hide	rad3
	if Tournoi-auto?[
		prepare-connect
		com-zone/text: join "Port: " Maitre-Port/text
	]
	show com-zone
]
Prochain-jeu: does[
"Executes the next test"
	if not random-IRMAS?[if match?[if not (IRMAS? and match-retour?)[if NumDonne >= NDonnes[fin-match exit]]]]
	if (not IRMAS?) and (not match-retour?)[
		if numDonne >= length? pointeurs[
	  		com-zone/text: Fin-donnes
 	 		if found? find head CHelp/data "Match sheet"[remove find head CHelp/data "Match sheet"]
	  		if found? find head CHelp/data "Report"[remove find head CHelp/data "Report"]
	  		show com-zone
			CDonnes/data: copy Jouer1
			CDonnes/text: first Jouer1
			exit
		]
	]
	retour-Timer: none
	if Match?[
		lab-IRMAS/show?: false	;change will not be possible once launched
		chk7/show?: false
		if not found? find head CHelp/data "Match sheet"[append CHelp/data "Match sheet"]
; check if pause is requested at the end of each game
		if Pause-game?[
			either Continuer-match?[
				Continuer-match?: false
				][
				Bouton-suivante/text: st-suivante
				Bouton-suivante/action: [com-zone/pane none suivante]
				Bouton-revoir/text: st-revoir
				Bouton-revoir/action: [com-zone/pane none Revoir]
				bouton-rejouer/show?: false
   			Bouton-prev/show?: false
   			Bouton-suivante/show?: true
				com-zone/pane: suite-box
				show com-zone
				exit
			]
		]
	]
	either (IRMAS? and match-retour?)[	; get a new deal
		launch-deal
		][
		either random-IRMAS?[
			make-deal
			statusbar1/text: rejoin [Etui NumDonne]
			fichiers-Jauge: copy donne-initiale
			monodonne?: true
			][
			NumDonne: NumDonne + 1
			Donne-initiale: fetch-deal NumDonne Fichiers-jauge
			launch-deal
		]
	]	
	either Match?[
		if not MonoDonne?[statusbar1/text: rejoin [Etui NumDonne sur Ndonnes]]
		either match-retour?[
			g: pick match (NumDonne + 4)
			R: parse g none
			Contract: pick R 3
			contrat: copy contract
			either Contract = "Pass"[
				Contrat-aller/text: rejoin [Tout-passe]
				][
				replace Contrat "S" "P"
				replace Contrat "C" "T"
				replace Contrat "D" "K"
				replace Contrat "H" "C"
				replace Contrat "NT" "SA"			
				either found? find Contract "NT"[
					Contrat-aller/text: rejoin[Contract st-par pick R 4 "  " pick R 5]
					symbole-contrat/show?: false
				][
					symbole-contrat/show?: true
					either found? find Contract "X"[d: copy skip Contract 2][d: copy ""]
					Contrat-aller/text: copy rejoin[first Contract "     " d st-par pick R 4 "  " pick R 5]
					I: index? find colors to-string second Contract
					symbole-contrat/image: pick reduce[Pique Coeur Trefle Carreau ] I
				]
			]
			either IRMAS? [
			][ 
					Donne-aller: retrouver-deal NumDonne texte-aller
			]
		if Contract <> "Pass"[
			Foreach C donne-aller[if found? find C  "[Play "[K: 1 + index? find donne-aller C break]]
			Lead: first parse pick Donne-aller K none
			switch first Lead[
				#"S" [bild: Pique lead-card-color: black]
				#"h" [bild: Coeur lead-card-color: 191.32.38]
				#"d" [bild: Carreau lead-card-color: papaya]
				#"c" [bild: Trefle lead-card-color: gray]
			]
			K: index? find  strcardsnames second lead
			Lead-card: pick Symboles-Cartes K
			if affichage-10?[if K = 5 [Lead-card: copy "I0"]]
			insert back tail match-aller/pane image-lead: layout/offset[
				backdrop effect[gradient 0x1 150.150.150]
				at 18x0 h1 lead-card lead-card-color; font-size 15
				at -3x2 box 25x20 bild
			]162x0
		]
			OutPut-message: rejoin["Match-aller: " Contrat st-par pick R 4 "  " pick R 5 newline]
			Dispatch-to-remote
			show match-aller
			][
			if found? find match-aller/pane image-lead[remove find match-aller/pane image-lead]
		]
		][
		if 0 <> length? fichiers-jauge[statusbar1/text: rejoin [Etui NumDonne sur Ndonnes]]
	]
]
retrouver-deal: func[N [Integer!]T[Block!]][
	either N >= length? pointeurs-aller[
		Dbut-donne: (last pointeurs-aller ) - 1
		return copy skip T dbut-donne
		][
		Dbut-donne: (pick pointeurs-aller N) - 1
		longueur: ((pick pointeurs-aller (N + 1)) - Dbut-donne) - 1
		return copy/Part skip T dbut-donne longueur
	]
]
fetch-deal: Func[Num [integer!] F[Block!]/local Fichier-pbn Dbut-donne longueur][
	either Monodonne?[
		Fichier-pbn: pick F pick pointeurs Num
		Nom-Donne: to-string head clear find copy Fichier-pbn ".pbn"
		return read/lines join Donnes-dir Fichier-pbn
		][
		either Num >= length? pointeurs[
			Dbut-donne: (last pointeurs ) - 1
			return copy skip F dbut-donne
			][
			Dbut-donne: (pick pointeurs Num) - 1
			longueur: ((pick pointeurs (Num + 1)) - Dbut-donne) - 1
			return copy/Part skip F dbut-donne longueur
		]
	]
]
Match-record: does[
	either contract = "Pass"[
		Contrat: "Pass" Declarer: " All" Rel-result: 0 Score: 0
		][
		score: either ((Declarer-seat // 2) = 0) [score][-  score]
	]
	either match-retour? or IRMAS?[
		g: pick match (NumDonne + 4)
		either none? g[			;if g is none IRMAS mode
			first-round-record
			if IRMAS? [write/append match-sheet g]
			match-retour?: true
			swap-deal
			Prochain-jeu
			exit
			][
			second-round-record
			if 0 < length? Remote-displays[	;sending match sheet to remote displays
				foreach RD remote-displays [
					insert RD join "match-sheet: " newline
					foreach m match[insert RD join m newline]
					insert RD rejoin[ "end match-sheet" newline]
				]
			]
			if IRMAS? [
				write/Lines/append match-sheet skip g ((pick tabulations 7) - 6)
				match-retour?: false
			]
		]
		][
		first-round-record
	]
	if not IRMAS? [write/lines Match-sheet head match ]
	if not none? Backup-path[write/lines join Backup-path match-sheet Match]
	Prochain-jeu
]
fin-match: does[
	if IRMAS?[
		write/lines match-sheet match
		if stats?[write/lines %report.txt report-sheet]
	]
	if not none? Backup-path[write/lines join Backup-path match-sheet Match]
	output-message: join "End of session" newline
	Dispatch-to-remote
	clear head Main-Buffer
	dispatch-message output-message
	forall Client-Ports [close first Client-Ports]
	if lettres?[forall alpha-hands[remove find MainWin/pane first alpha-hands] alpha-hands: head alpha-hands]
	Client-Ports: copy []
	Clients: Copy []
	Client-num: 0
	Noms: copy ["Coach" "Coach" "Coach" "Coach"]
	foreach L Lights[hide L]
	Match?: to-logic false
	CInit/data: head CInit/data
	append clear CInit/data copy setup1
	if not IRMAS?[
		if Not Match-retour?[
; get ready for second round if players of the same team use the same protocol version (ambiguous if not)
			if found? find [0 5 10 15]version17[
				switch version17 [ 5 [version17: 10] 10 [version17: 5]]
				Match?: true
				Deal-Event: head clear back tail first parse Nom-fichier-Asauver none
				NumDonne: 0
				statusBar1/text: ready-second-round
				Continuer-match?: true
				show statusBar1
				hide Making-array
				server-port/awake: func[ port ][
					Get-Client  ; Fonction grant les nouvelles connexions
					false
				]
				wait 3
				statusBar3/text: st-attente
				show statusBar3
			]
		]
	]
]
swap-deal: does[
;swapping the deal
	foreach line Donne-initiale[
		if found? find line "Vuln"[
			switch second parse line none[
				"NS" [replace Line "NS" "EW"]
				"EW" [replace Line "EW" "NS"]
			]
		]
		if found? find line "dealer"[
			switch second parse line none[
				"N" [replace Line {"N"} {"E"}]
				"E" [replace Line {"E"} {"S"}]
				"S" [replace Line {"S"} {"W"}]
				"W" [replace Line {"W"} {"N"}]
			]
		]
		if found? find line "deal "[
			switch to-string first second parse line none[
				"N" [replace Line {N:} {E:}]
				"E" [replace Line {E:} {S:}]
				"S" [replace Line {S:} {W:}]
				"W" [replace Line {W:} {N:}]
			]
		]
	]
	if not none? PAR-comment[
		replace PAR-Comment newline ""
		replace Par-Comment " :" ":"
		a: parse Par-Comment none
		P: pick a (index? find a "by") + 1
		k: index? find ["south:" "west:" "north:" "east:"] P
		replace PAR-comment P pick ["west:" "north:" "east:" "south:"] K
		append Donne-initiale PAR-Comment
	]
	if not none? feasability-array [
		a: parse feasability-array none
		d: copy skip a 16
		clear skip a 16
		insert skip a 1 d
		append Donne-initiale rejoin ["{" feasability-array: form a "}"]
		Faisabilit feasability-array
	]
]
first-round-record: does[
	first-round-contract: copy contract
	P: head clear find second match "Total Time:"
	cale-text P 55 ""
	append P rejoin["Total time: " rounded-time to-time NS-elapsed]
	poke match 2 P
	P: head clear find third match "Total Time:"
	cale-text P 55 ""
	append P rejoin["Total time: " rounded-time to-time EW-elapsed]
	g: copy ""
	either IRMAS?[
		cale-text g (pick tabulations 1) to-string NumDonne
		][
		either MonoDonne?[
			a: copy Nom-Donne
			while [error? n: try[to-integer a]][if (length? a) = 0 [break]remove a]
			if (length? a) = 0 [N: copy skip Nom-Donne (length? Nom-Donne) - 4]
			cale-text g (pick tabulations 1)  to-string N
			][
			cale-text g (pick tabulations 1) to-string NumDonne
		]
	]
	cale-text g (pick tabulations 2) (either V-case = "Neither"["None"][V-case])
	append g "|"
	cale-text g (pick tabulations 3) Contract
	cale-text g (pick tabulations 4) Declarer
	cale-text g (pick tabulations 5) (either Rel-result < 0 [
		to-string Rel-result
		][
		either rel-result > 0 [join "+" rel-result][" ="]
	])
	cale-text g (pick tabulations 6) either score < 0 [(to-string score)][join " " (to-string score)]
	z: copy either comp?[either very-Comp?["   +"]["   ?"]]["   |"]
	if alert-count > 0[poke z 3 #"!"]
	append g z
	append match g
	if stats?[stats1]
	Comp?: false
	very-Comp?: false
]
second-round-record: does[
	fin-g: copy ""
	if 39 < length? g[
		if found? find skip g 39 "SKIP"[exit]
		if found? find g "SKIP"[fin-g: copy skip g 65]
		G: copy/part g 39 poke match (NumDonne + 4) g
	]
	either fin-g =""[
		R: parse g none
		diff: (to-integer pick R 6) + either IRMAS? [score][- score]
		either diff > 0 [
			NS-IMP: IMP diff
			contrat-aller/text: rejoin[either IRMAS?["   NS: "][ "   EW: "]NS-IMP " IMP"]
			EW-IMP: 0
			][
			EW-IMP: IMP (- diff)
			contrat-aller/text: rejoin[either IRMAS?["   EW: "][ "   NS: "]EW-IMP " IMP"]
			NS-IMP: 0
		]
		if found? find match-aller/pane image-lead[remove find match-aller/pane image-lead]
;		remove at match-aller/pane 4
		][
		R: parse fin-g none
		NS-IMP: to-integer first R
		EW-IMP: to-integer third R
	]
	hide symbole-contrat
	show contrat-aller
	NS-Total: NS-Total + NS-IMP
	EW-Total: EW-Total + EW-IMP
	Synthse-match
	P: head clear find second match "IMP:"
	cale-text P 40 ""
	append P rejoin["IMP: " NS-Total ]
	cale-text P 55 ""
	append P rejoin["Total time: " to-time either IRMAS?[rounded-time NS-elapsed][rounded-time EW-elapsed]]
	poke match 2 P
	P: head clear find third match "IMP:"
	cale-text P 40 ""
	append P rejoin["IMP: " EW-Total ]
	cale-text P 55 ""
	append P rejoin["Total time: " to-time either IRMAS?[rounded-time EW-elapsed][rounded-time NS-elapsed]]
	poke match 3 P
	cale-text g (pick tabulations 7) Contract
	cale-text g (pick tabulations 8) Declarer
	cale-text g (pick tabulations 9) (either Rel-result < 0 [
		to-string Rel-result
		][
		either rel-result > 0 [join "+" rel-result][" ="]
	])
	cale-text g (pick tabulations 10) either score < 0 [(to-string score)][join " " (to-string score)]
	z: copy either comp?[either very-Comp?["   +"]["   ?"]]["   |"]
	if alert-count > 0[poke z 3 #"!"]
	append g z
	cale-text g (pick tabulations 11) to-string NS-IMP
	append g " |"
	cale-text g (pick tabulations 12) to-string EW-IMP
	append g " |"
	comp?: false
	very-comp?: false
]
Synthse-match: does[
	if stats?[Stats]
	P: head clear find second match "IMP:"
	cale-text P 40 ""
	append P rejoin["IMP: " NS-Total ]
	cale-text P 55 ""
	append P rejoin["Total time: " to-time either IRMAS?[rounded-time NS-elapsed][rounded-time EW-elapsed]]
	poke match 2 P
	P: head clear find third match "IMP:"
	cale-text P 40 ""
	append P rejoin["IMP: " EW-Total ]
	cale-text P 55 ""
	append P rejoin["Total time: " to-time either IRMAS?[rounded-time EW-elapsed][rounded-time NS-elapsed]]
]
;=============================
; returning to an interrupted match
;=============================
reprendre-match: does[
	if match-retour? and not IRMAS?[	Nom-Fichier-Asauver: Nom-Fichier-retour]
	match: read/lines match-sheet
   	either match-retour?[
		EW-elapsed: to-integer to-time second find parse second match none "time:"
		NS-elapsed: to-integer to-time second find parse third match none "time:"
		][
    NS-elapsed: to-integer to-time second find parse second match none "time:"
 		EW-elapsed: to-integer to-time second find parse third match none "time:"
	]
	NS-total: 0
	EW-Total: 0
	foreach g (skip match 4)[
		g1: parse g none
		if (length? g1) < 15 [Break]
		NS-Total: NS-Total + to-integer pick g1 13
		EW-Total: EW-Total + to-integer pick g1 15
	]
	if not found? find head CHelp/data "Match sheet"[append CHelp/data "Match sheet"]
	If stats?[if not found? find CHelp/data "Report"[append CHelp/data "Report"]]
; check if a player was unable to play - mention and skip the deal
	either not random-IRMAS?[	; feature not useful in random
		inform/offset deal-skip to-pair Compose[(table-width) 20]
		if sauter-Donne?[
			team1-req/text: copy NS-team
			team2-req/text: copy EW-team
			inform pnalit
			either match-retour?[
				either IRMAS? [][req-NS/data: not req-Ns/data NumDonne: NumDonne + 1]
				g: pick skip match 4 numdonne
				if 39 < length? g[G: copy/part g 39 poke match (NumDonne + 4) g]
				append g "  SKIP"
				either req-NS/data[
					cale-text g (pick tabulations 8) either IRMAS? ["NS"]["EW"]
					cale-text g (pick tabulations 9) "-"
					cale-text g (pick tabulations 10) "-"
					cale-text g (pick tabulations 11) "|    0"
					append g " |"
					cale-text g (pick tabulations 12) montant-pnalit/text
					append g " |"
					EW-Total: EW-Total + to-integer montant-pnalit/text
					write/append/lines nom-fichier-Asauver skip-Log "NS" montant-pnalit/text
					][
					cale-text g (pick tabulations 8) either IRMAS? ["EW"]["NS"]
					cale-text g (pick tabulations 9) "-"
					cale-text g (pick tabulations 10) "-"
					append g "  |"
					cale-text g (pick tabulations 11) montant-pnalit/text
					append g " |    0 |"
					NS-Total: NS-Total + to-integer montant-pnalit/text
					write/append/lines nom-fichier-Asauver skip-Log "EW" montant-pnalit/text
				]
				if NumDonne >= NDonnes [Synthse-match]
				write/lines match-sheet match
				if IRMAS? [Match-retour?: false]
				][
				NumDonne: NumDonne + 1
				g: copy ""
				cale-text g (pick tabulations 1)to-string NumDonne
				cale-text g (pick tabulations 3) "|  SKIP"
				either req-NS/data[
					T: "NS"
					cale-text g (pick tabulations 4) "NS"
					cale-text g (pick tabulations 5) "-"
					cale-text g (pick tabulations 6) "-"
					cale-text g (pick tabulations 7) "|     -"
					cale-text g (pick tabulations 8) "-"
					cale-text g (pick tabulations 9) "-"
					cale-text g (pick tabulations 10) "-"
					cale-text g (pick tabulations 11) "|   0"
					append g " |"
					cale-text g (pick tabulations 12) montant-pnalit/text T montant-pnalit/text
					append g " |"
					EW-Total: EW-Total + to-integer montant-pnalit/text
					][
					T: "EW"
					cale-text g (pick tabulations 4) "EW"
					cale-text g (pick tabulations 5) "-"
					cale-text g (pick tabulations 6) "-"
					cale-text g (pick tabulations 7) "|     -"
					cale-text g (pick tabulations 8) "-"
					cale-text g (pick tabulations 9) "-"
					cale-text g (pick tabulations 10) "-"
					append g "  |"
					cale-text g (pick tabulations 11) montant-pnalit/text
					append g " |    0 |"
					NS-Total: NS-Total + to-integer montant-pnalit/text
				]
				append match g
				write/lines match-sheet match
				write/append/lines nom-fichier-Asauver skip-Log T montant-pnalit/text
				if IRMAS? [Donne-initiale: fetch-deal NumDonne Fichiers-jauge Match-retour?: true]
			]
		]
		][
	]
	get-in-match
]
skip-log: func[
"create a specific log record for skipped deal in order to manage occasional further interruption"
	Camp [string!]
	P [string!]
	][
	Donne-initiale: fetch-deal NumDonne Fichiers-jauge
	forall Donne-initiale[if "" = trim/all copy first Donne-initiale[break]]
	insert donne-initiale rejoin["{skip by " Camp  " penalty " P "}"]
	if "" <> trim/all copy last Donne-initiale [append Donne-initiale ""]
	head donne-initiale
]
;========================================================================================================================
; 		Fith section - Statistics module for tournament and matches (transferred to independent module)
;========================================================================================================================
;========================================================================================================================
; 		Sixth section - Bidding training
;========================================================================================================================
;if one or two players are connected, a choice in the menu can lead to this section
Entranement-Enchres: does[
	init-enchres
	either TM?[
		Donne: form copy Donne-initiale
		if not found? find Donne "Pass"[
			com-zone/text: Donne-inapproprie
			show com-zone
			insert trainee-port join "Donne inapproprie" newline
			exit
		]
		Enchres-Rfrence: copy skip (parse (copy find Donne "Auction") none )3
		clear find Enchres-Rfrence join Dbut-Crochet "Play"
		Enchres-Rfrence: head Enchres-Rfrence
		][
		Donne: copy ""
	]
	Lire-enchre
]
; =====================================================================================================================
; 		7th section - Viewer
; =====================================================================================================================
; display donne-initiale game
Visionner: does[
	c: form copy donne-initiale
	either Frquence?[
		append clear Freqs/data copy Frquences
		fix-slider freqs
		show freq-display
		][ 
		hide freq-display 
	]
	if not MonoDonne? [com-zone/Text: st-suivante com-zone/action: [suivante] show com-zone]
	if not found? find c "Auction"[exit]
	Alert-count: 0
	A: copy skip (parse (copy find c "Auction") none )3
	if not found? find A "Pass" [
		com-zone/text: pas-enchres
		show com-zone
		exit
	]
	Enchres-lues: copy []
	effacer-bids
	Enchres-Rfrence: copy []
	show auction-display
	foreach ench a[
		if found? find Ench Dbut-Crochet  [break]
		if found? find Ench "("  [break]
		if found? find Ench "{"  [break]
		if "" = trim/all Ench [break]
		either found? find ench "="[Alert-count: alert-count + 1 append last Enchres-Rfrence "!"][append Enchres-Rfrence ench]
	]
	b: parse c none
	Dealer: select b "[Dealer"
	Contract: select b "[Contract"
	result: none
	if not none? c: select b "[Result" [Result: to-integer c]
	if not none? c: select b "[South"[SName/text: c]
	if not none? c: select b "[West"[WName/text: c]
	if not none? c: select b "[North"[NName/text: c]
	if not none? c: select b "[East"[EName/text: c]
	either alert-count > 0[
		clear infos-display/pane/2/text
		c: 0
		while [alert-count > 0][
			c: index? find skip b c "[Note"
			append infos-display/pane/2/text join pick b (c + 1) newline
			alert-count: alert-count - 1
		]
		show infos-display
	][
		hide infos-display
	]
	Enchres-Rfrence: head Enchres-Rfrence
	next-player-seat: (index? find Joueurs dealer ) - 1
	enchres-lues: copy []
	Bids-suit: copy []
	foreach E enchres-rfrence[
		append enchres-lues E
		either E = "+" [break][Affiche E next-player-seat: (next-player-seat + 1) // 4]
		Alert?: false
	]
	Bids-suit: head Bids-suit
	if Not MonoDonne?[
		if NumDonne = 1 [Bouton-prev/text: none Bouton-prev/action: none]
	]
	bouton-revoir/show?: false
	com-zone/pane: Suite-Box
	show com-zone 
	if contract <> "" [
		Atout: to-string second Contract
		if Atout = "A" [statusbar3/text: Tout-passe show statusbar3 exit]
		foreach X donne-initiale[if found? find X "Declarer" [Declarer: to-string (second parse x none) break]]
		Declarer-seat: (index? find Joueurs Declarer) - 1
		Afficher-contrat
		either (Declarer-seat // 2) = 0[NS-Tricks: Result][EW-Tricks: Result]
		if Atout = "N" [Atout: ""]
		Afficher-marque
		bouton-revoir/text: st-Visionner
		bouton-revoir/show?: true
	]
	if none? PAR-comment[hide match-aller]
	if computer-seat = 4[DF-file]
	Visionneuse?: true
	show com-zone
]
; =====================================================================================================================
; 		8th section - Elements of strategy
; =====================================================================================================================
Evaluer-Coup: does [Com-Zone/action: none either Atout = "" [Evaluer-gagnantes][Evaluer-Perdantes]]
Evaluer-Gagnantes: does[
	Hand: pick Hands (Declarer-Seat + 1)
	main-Joueur: copy Hand
	Hand: pick Hands ((Declarer-seat + 2) // 4 + 1)
	Dummy: copy Hand
	texte-aide: copy ""
	Leves-certaines: 0
	foreach Col PBN-colors [
		Couleur: switch col [
			#"S" [first noms-couleurs]
			#"H" [second noms-couleurs]
			#"D" [third noms-couleurs]
			#"C" [fourth noms-couleurs]
		]
		mains: copy ""
		k: 0 foreach Crd main-Joueur [If col = pick Crd/data 1 [K: K + 1 append Mains Crd/data]]
		J: 0 foreach Crd Dummy [If col = pick Crd/data 1 [J: J + 1 append Mains Crd/data]]
		Leves-max-couleur: max J  K 
		Leves-Couleur: 0
		foreach hauteur strcardsnames [
			either found? find Mains Hauteur[
				Leves-Couleur: Leves-Couleur + 1
				if leves-couleur = leves-max-couleur [break]
				][
				break
			]
		]
		if leves-couleur = 1 [append texte-aide rejoin [leves-couleur leve Couleur newline]]
		if leves-couleur > 1 [append texte-aide rejoin [leves-couleur leves Couleur newline]]
		Leves-certaines: leves-certaines + leves-couleur
	]
	append texte-aide rejoin [certaines leves-certaines]
	Com-Zone/text: texte-aide
]
Evaluer-Perdantes: does[
	Hand: pick Hands (Declarer-Seat + 1)
	main-Joueur: copy Hand
	k: 0 foreach Crd main-Joueur [If atout = To-string (pick Crd/data 1) [K: K + 1]]
	Hand: pick Hands ((Declarer-seat + 2) // 4 + 1)

	Dummy: copy Hand
	J: 0 foreach Crd Dummy [If atout = To-string (pick Crd/data 1) [J: J + 1]]
	Main-dcompte: either k >= J [Main-Joueur][Dummy]
	texte-aide: copy Perdantes
	append texte-aide join newline  "main de base: "
	Perdantes: 0
	foreach Col PBN-colors [
		mains: copy ""
		k: 0 foreach Crd Main-dcompte [If col = pick Crd/data 1 [K: K + 1]]
		foreach Crd main-Joueur	[If col = pick Crd/data 1 [append Mains Crd/data]]
		foreach Crd Dummy		[If col = pick Crd/data 1 [append Mains Crd/data]]
		Perdantes-max-couleur: K 
		Leves-Couleur: Trouves: 0
		Perdantes-Immdiates-Couleur: Perdantes-Couleur: 0
		foreach hauteur strcardsnames [
			either found? find Mains Hauteur[
				Trouves: Trouves + 1
				if Trouves > (Perdantes-couleur + Leves-Couleur) [Leves-Couleur: Leves-Couleur + 1]
				][
				if Trouves = 0 [Perdantes-Immdiates-Couleur: Perdantes-Immdiates-Couleur + 1]
				Perdantes-Couleur: Perdantes-Couleur + 1
			]
			if (Perdantes-couleur + Leves-Couleur = Perdantes-max-Couleur) [Break]
		]
		Couleur: join (switch col [
				#"S" [first noms-couleurs]
				#"H" [second noms-couleurs]
				#"D" [third noms-couleurs]
				#"C" [fourth noms-couleurs]]) ": "
		If Perdantes-couleur > 0 [
			append texte-aide rejoin [newline Couleur Perdantes-couleur]
			If Perdantes-Immdiates-Couleur > 0 [
				append texte-aide rejoin [dont Perdantes-Immdiates-Couleur immd]
			]
		]
		Perdantes: Perdantes + Perdantes-couleur
	]
	append texte-aide rejoin [newline Total-perdantes Perdantes]
	Com-Zone/text: texte-aide
]
Evaluer-Points: func [
	Main-Joueur [block!]
	S	[integer!]
	][
	Points-H: 0 
	Points-L: 0
	Plus-Moins-Values: 0
	foreach Col PBN-Colors [
		Nb-Couleur: to-integer 0
		Pts-Couleur: to-integer 0
		forall Main-Joueur [
			Crd-name: get in first Main-Joueur 'data
			either col = pick crd-name 1 [
				Nb-Couleur: Nb-Couleur + 1		;compte les cartes dans la couleur
				Pts-Carte: get in first Main-joueur 'PH
				if not none? Pts-Carte [Pts-Couleur: Pts-Couleur + Pts-Carte];value la couleur en points H
				if Pts-Carte = 0 [Plus-Moins-Values: Plus-Moins-Values  + 1]; Plus-value pour un dix
			][break]
		]
		If Pts-Couleur > 1 [if Nb-Couleur > 4 [Points-L: Points-L + (Nb-Couleur - 4)]]; Points de longueur
		If Nb-Couleur = 1 [										; moins-value pour singleton
			If Pts-Couleur = 0 [Plus-Moins-Values: Plus-Moins-Values - 1]
			If Pts-Couleur > 0 [Plus-Moins-Values: Plus-Moins-Values - 2]

		]
		Points-H: Points-H + Pts-Couleur
	]
	Main-Joueur: head main-Joueur
	Pts: make valeur-main[
		PH: Points-H
		PL: Points-L
		PMV: Plus-Moins-Values
	]
	poke Points (s + 1) Pts
]
; =============================================================================================================
;			9th section - INFORMATION FLOW MANAGER
; =============================================================================================================
;Connexions
; ==========================
; Opening a server port
; ==========================
Matre: does [
"TM configuration parameters"
;Initializing field inputs. Look for existing default connexion parameters
	Noms-Ports: copy["2000"]
	Client-number: 1
	if exists? %BM_ini.txt [
		Contenu: read %BM_ini.txt
		if found? find Contenu "ports" [parse Contenu [Thru "Ports:" copy n to "]"]
			Noms-Ports: parse n none
		]
		if found? find Contenu "Connexions "[
			parse Contenu [thru "Connexions " copy C to fin-crochet]
			Client-number: to-integer C
		]
	]
	Maitre-Port/text:  copy last Noms-Ports
	either (length? Noms-Ports) > 1[Retirer/show?: true][Retirer/show?: false]
	rad1/data: Client-number = 1
	rad2/data: Client-number = 2
	rad3/data: Client-number = 3
	rad4/data: Client-number = 4
	Computer-Seat: to-integer 4	;TM computer identification
	if Match? [Client-NumBer: 4 ][Client-NumBer: 1]
	Statusbar3/text: Nombre-Joueurs
	show statusbar3
	com-zone/text: none
	Visionneuse?: false
	Com-zone/pane: Matre-box
	show Com-zone
]
Prepare-connect: does[
; first update Block of param: the last ones will become default
	Gestion-Nom Maitre-Port Noms-Ports
; then update param file
	either exists? %BM_ini.txt [
		Contenu: read %BM_ini.txt
		parse contenu [copy p Thru "Ports:"]
		forall Noms-Ports[append p join newline first Noms-Ports]
		Noms-Ports: head Noms-Ports
 		parse contenu [to  "Ports" to Fin-crochet copy Fin-param to end]
		contenu: join P Fin-Param
		either found? find contenu "Connexions "[
			k: (index? find contenu "Connexions ") + 11
			Poke contenu k to-char (to-string Client-number)
			][
			append contenu rejoin[newline Dbut-Crochet "Connexions " to-string client-number fin-Crochet]
		]
		][
		P: copy "[Joueurs:" 
		forall Noms-Trainees [append p join newline first Noms-Trainees]
		append P Rejoin ["]" newline "[Hosts:" ]
		forall Noms-Hosts [append p join newline first Noms-Hosts]
		append P Rejoin ["]" newline "[Ports:" ]
		forall Noms-Ports [append p join newline first Noms-Ports]
		append p "]"
		append p rejoin[newline Dbut-Crochet "Connexions " to-string client-number fin-Crochet]
		contenu: copy p
	]
	write %BM_ini.txt contenu
;	get-ip		;can be reactivated if common usage but add a small delay
	com-zone/pane: none
	if Match? [Client-Number: 4]
	connect-enable
	cInit/data: head CInit/data
	append clear CInit/data copy setup2
	if Tournoi-auto?[change-prefs	com-zone/text: join "Port: " Maitre-Port/text]
	Lettres?: TM-Lettres?
	if TM-lettres?[set-alpha]
	Etude?: false
	Unview MainWin
	View/title MainWin rejoin [Moniteur-Bridge sur Nom-Ordinateur " (" system/network/host-address ")"]
]
Connect-enable: does[
"enables the server to listen at connexion requests"
	num-port: copy Maitre-Port/text
	if error? try [ server-port: open to-url join "tcp://:" num-port ]
	[ com-zone/text: impossible-server show com-zone return 1 ]
	server-port/awake: func[ port ][
		Get-Client  ; Fonction grant les nouvelles connexions
		false
	]
	append system/ports/wait-list server-port
	Client-Num: 0
	Connect?: to-logic false
	if Client-number > 0 [
		statusbar3/text: rejoin [
			st-Attente Client-number st-connexion (either Client-number  > 1 ["s"][""])]
		show statusbar3
	]
	either exists? %compan.exe[
		If not exists? %compan.ini[inform layout[h2 inform-Bo1 h2 inform-Bo2 h2 inform-Bo3 button "OK" [hide-Popup]]]
	][
		if exists? %Auxil.exe[call reduce[%Auxil.exe num-port]]
	]
]
; ===============================
; Client Connexion (Trainee or lve)
; ===============================
Elve: does [
"Client connexion parameters"
;Initializing field inputs. Look for existing default connexion parameters

	if exists? %BM_ini.txt [
		Contenu: read %BM_ini.txt
		parse Contenu [Thru "Joueurs:" copy n to Fin-crochet]
		Noms-Trainees: parse n none
		parse Contenu [Thru "Hosts:" copy n to Fin-crochet]
		Noms-Hosts: parse n none
		if found? find Contenu "Ports:" [
			parse Contenu [Thru "Ports:" copy n to Fin-crochet]
			Noms-Ports: parse n none
		]
	]
	In-Nom/text: copy last Noms-Trainees
	In-Seat/text: first Noms-seats
	In-Host/text: copy last Noms-Hosts
	In-Port/text: copy last Noms-Ports
	either (length? Noms-Ports) > 1[Retirer4/show?: true][Retirer4/show?: false]
	either (length? Noms-Hosts) > 1[Retirer3/show?: true][Retirer3/show?: false]
	either (length? Noms-Trainees) > 1[Retirer2/show?: true][Retirer2/show?: false]
	statusbar3/text: Connexion-serveur
	show statusbar3
	cran/show?: false
	com-zone/text: none
	Com-zone/pane: trainee-box
]

Trainee-Connect: does[
; first update Block of param: the last ones will become default
	Gestion-Nom In-Nom Noms-Trainees
	Gestion-Nom In-Host Noms-Hosts
	Gestion-Nom In-Port Noms-Ports
; then update param file
	either exists? %BM_ini.txt [
		Contenu: read %BM_ini.txt
		parse Contenu [copy p Thru "Joueurs:"]
		forall Noms-Trainees [append p join newline first Noms-Trainees]
		Noms-Trainees: head Noms-Trainees
 		parse contenu [to  "Joueurs" to Fin-crochet copy Fin-param to end]
		contenu: join P Fin-Param
		parse contenu [copy p Thru "Hosts:"]
		forall Noms-Hosts [append p join newline first Noms-Hosts ]
		Noms-Hosts: head Noms-Hosts
 		parse contenu [to  "Hosts" to Fin-crochet copy Fin-param to end]
		contenu: join P Fin-Param
		parse contenu [copy p Thru "Ports:"]
		forall Noms-Ports[append p join newline first Noms-Ports]
		Noms-Ports: head Noms-Ports
 		parse contenu [to  "Ports" to Fin-crochet copy Fin-param to end]
		contenu: join P Fin-Param
		][
		P: copy "[Joueurs:" 
		forall Noms-Trainees [append p join newline first Noms-Trainees]
		append P Rejoin ["]" newline "[Hosts:" ]
		forall Noms-Hosts [append p join newline first Noms-Hosts]
		append P Rejoin ["]" newline "[Ports:" ]
		forall Noms-Ports [append p join newline first Noms-Ports]
		append p "]"
		contenu: copy p
	]
	write %BM_ini.txt contenu
	switch In-Seat/text reduce[
		first noms-seats [Place: "Anypl" computer-seat: 0]
		second noms-seats [Place: "South" computer-seat: 0]
		third noms-seats [Place: "West" computer-seat: 1]
		fourth noms-seats [Place: "North" computer-seat: 2]
		last noms-seats [Place: "East"computer-seat: 3]
	]
	com-zone/pane: none
	show com-zone
; if connecting timeout is too long : to be modified here
	if error? try [Trainee-port: open to-url rejoin["tcp://" In-Host/text ":" In-Port/text]]
	[ com-zone/text: impossible-connecter show com-zone return 1 ]
	Trainee-port/user-data: copy []
	Trainee-port/timeout: 10
	Trainee-port/awake: func[port /local data][
		either error? char: TRY [first port][
			error: disarm char
			if error/id = 'past-end [Dconnexion exit]
			Print Erreur-communications
			halt
			][
			data: COPY to-string char
			while [newline <> char: first port] [append data char]
			if Print? [Print data]
			append port/user-data data
			input-message: copy data
			Gestion-Tches port
		]
		false
	]
	append system/ports/wait-list Trainee-port
 	Nom-Joueur: in-Nom/text
	Msg: rejoin [{Connecting "} Nom-Joueur {" as } Place { using protocol version 18} newline]
	if Print? [Print Msg]
	insert Trainee-Port Msg
	if TM-Lettres?[set-alpha]
	Etude?: false
	if auto-connect?[insert trainee-port join "auto-connect-WB5" newline]
	Unview MainWin
	View/title MainWin join Nom-Joueur entranement
]
;=================================
; Successfull connexion processing Blue Chip Bridge protocol
;=================================
Seated-Respond: does [
	Client-Place: First (parse input-message none)
	Seat: to-string first Client-Place
	Computer-Seat: (index? find Joueurs Seat) - 1
	Light: pick Lights (Computer-seat + 1)
	poke Light/effect 2 orange
	show Light
	P: pick Names-Places (Computer-seat + 1)
	P/text: Nom-Joueur
	show P
	append trainees Seat
	append Clients Client-Place
	Output-message: rejoin [Client-Place " Ready for Teams" newline]
	Insert Trainee-Port output-message
	Connect?: to-logic true
	CInit/data: head CInit/data
	append clear CInit/data copy Setup3
	statusbar3/text: Connect
	show statusbar3
]
Remote-display-request: does[
"Client connexion parameters"
;Initializing field inputs. Look for existing default connexion parameters
	computer-seat: 5
	if exists? %BM_ini.txt [
		Contenu: read %BM_ini.txt
		parse Contenu [Thru "Joueurs:" copy n to Fin-crochet]
		Noms-Trainees: parse n none
		parse Contenu [Thru "Hosts:" copy n to Fin-crochet]
		Noms-Hosts: parse n none
		if found? find Contenu "Ports:" [
			parse Contenu [Thru "Ports:" copy n to Fin-crochet]
			Noms-Ports: parse n none
		]
	]
	In-Nom/text: copy last Noms-Trainees
	In-Seat/text: first Noms-seats
	In-Host/text: copy last Noms-Hosts
	In-Port/text: copy last Noms-Ports
	either (length? Noms-Ports) > 1[Retirer4/show?: true][Retirer4/show?: false]
	either (length? Noms-Hosts) > 1[Retirer3/show?: true][Retirer3/show?: false]
	either (length? Noms-Trainees) > 1[Retirer2/show?: true][Retirer2/show?: false]
	statusbar3/text: Connexion-serveur
	show statusbar3
	Button-connect/action: [Remote-display-connect]
	com-zone/text: none
	cran/show?: true
	Com-zone/pane: trainee-box
	show com-zone
	show mainwin
]
Remote-display-connect: does[
; first update Block of param: the last ones will become default
	Gestion-Nom In-Host Noms-Hosts
	Gestion-Nom In-Port Noms-Ports
; then update param file
	either exists? %BM_ini.txt [
		Contenu: read %BM_ini.txt
		parse contenu [copy p Thru "Hosts:"]
		forall Noms-Hosts [append p join newline first Noms-Hosts ]
		Noms-Hosts: head Noms-Hosts
 		parse contenu [to  "Hosts" to Fin-crochet copy Fin-param to end]
		contenu: join P Fin-Param
		parse contenu [copy p Thru "Ports:"]
		forall Noms-Ports[append p join newline first Noms-Ports]
		Noms-Ports: head Noms-Ports
 		parse contenu [to  "Ports" to Fin-crochet copy Fin-param to end]
		contenu: join P Fin-Param
		][
		P: copy "[Joueurs:" 
		forall Noms-Trainees [append p join newline first Noms-Trainees]
		append P Rejoin ["]" newline "[Hosts:" ]
		forall Noms-Hosts [append p join newline first Noms-Hosts]
		append P Rejoin ["]" newline "[Ports:" ]
		forall Noms-Ports [append p join newline first Noms-Ports]
		append p "]"
		contenu: copy p
	]
	write %BM_ini.txt contenu
	Lettres?: TM-Lettres?
	if Lettres? [set-alpha Crer-alpha-cartes]
	clear head CDonnes/data		; no play menu available in this mode
	append clear CInit/data copy setup2
	com-zone/pane: none
	show com-zone
; if connecting timeout is too long : to be modified here
	if error? try [Trainee-port: open to-url rejoin["tcp://" In-Host/text ":" In-Port/text]]
	[ com-zone/text: impossible-connecter show com-zone return 1 ]
	remote-connect
]
remote-connect: does[
	Trainee-port/user-data: copy []
	Trainee-port/timeout: 10
	Trainee-port/awake: func[port /local data][
		either error? char: TRY [first port][
			error: disarm char
			either error/id = 'past-end [
				close Trainee-port
				Connect?: false
				remove find system/ports/wait-list Trainee-port
				Dbut-attente: now/time
				Dcompte: 60
				retour-timer: "Remote display"
				tempo/rate: 1
				statusBar3/text: Dconnect 
				com-zone/text: auto-reconnect
				show MainWin
				][	
				Print Erreur-communications
				halt
			]
			][
			data: COPY to-string char
			while [newline <> char: first port] [append data char]
			if Print? [Print data]
			append port/user-data data
			input-message: copy data
			Gestion-Tches port
		]
		false
	]
	append system/ports/wait-list Trainee-port
	Msg: rejoin [{Connecting remote display} newline]
	if Print? [Print Msg]
	insert Trainee-Port Msg
]
; when disconnected will try for the next hour to reconnect every 10 seconds
Remote-reconnect: does[
	either 1:00 < (Now/time - Dbut-attente) [quit][
		com-zone/text: "connexion..."
		show com-zone
		either error? try [Trainee-port: open to-url rejoin["tcp://" In-Host/text ":" In-Port/text]][
			com-zone/text: "Attente de reconnexion automatique"
			show com-zone
			][
			remote-connect
			Connect?: true
			retour-timer: none
			if found? find head CHelp/data "Match sheet"[remove find head Chelp/data "Match sheet"]
		]
	]
]
Get-Client: Does [
; expecting a client message of type... Connecting "Name" as "Seat" using Protocol version [BlueChip-Version]
	Client-Port: first server-port
	input-message: copy ""
	while[newline <> char: first Client-port][append input-message char]
	if not found? find input-message "Connecting" [print "message?" exit]
	if Found? find Input-message "Remote Display" [
		append remote-displays	Client-port
		Client-port/user-data: copy []
		Client-port/timeout: 10
		Client-port/awake: func[port /local data][
		if Print? [Prin rejoin["<" port/port-id  tab]]
			either error? char: TRY [first port][
				error: disarm char
				either error/id = 'past-end [
					Disconnected-Client port 
					][
					Lire-autres-ports port/port-id
				]
			][
			data: COPY to-string char
			while [newline <> char: first port] [append data char]
			if Print? [Prin data]
			append Communication-log data
			append port/user-data data
			input-message: copy data
			Gestion-Tches port
			if Print?[Print rejoin [tab port/port-id ">"]]
			]
			false
		]
		append system/ports/wait-list Client-port
		either (Client-number = length? Clients) or mode-fun?[
			insert Client-Port Teams
			append Client-Port/user-data Main-Buffer
			foreach info Client-port/user-data[insert Client-port info]
			clear head Client-port/user-data
			][
			insert Client-port join "Connected" newline
		]
		exit
	]
	If Client-Num >= Client-number[close Client-port exit]
	parse input-message [thru "Connecting " COPY team-name to " as"]
	replace/all team-name {"} ""
	either found? find input-message "using" [
		parse input-message [thru "as " COPY Sige to " using"]
		][
		parse input-message [thru "as " COPY Sige to end]
	]
	Protocol-VERSION: last parse input-message none
	either ((found? find Sige "Any") or ((length? sige) > 5)) [
		Seat: 1			; give first vacant seat
		Foreach N Noms [if N = "Coach" [Break] Seat: Seat + 1]
		Sige: pick ["South" "West" "North" "East"] Seat
		S: pick Joueurs Seat
		][
		S: to-string first Sige
		Seat: (index? find Joueurs S)
	]
	either (PICK Noms Seat) = "Coach" [
		;seat is vacant, go on
		Poke Noms Seat team-name
		Client-port/user: seat - 1	
		append Client-ports Client-port
		port-setup
		append Trainees to-string S
		append Clients Sige
		flag: to-integer 2 ** Client-Num
		All-Ready-for-Deal: All-ready-for-Deal or flag		;set of flags for accepting "Ready for deal" at any time
		if Protocol-version = "17" [version17: version17 or flag ]
		if Protocol-version = "18" [version17: version17 or flag version18: version18 or flag ]
		Output-Message: rejoin [Sige " " team-name " seated" newline]
		Light: pick Lights seat
		either seat = 2[light/effect: [colorize orange rotate 90 fit]][poke Light/effect 2 orange]
		show Light
		Name-Place: pick Names-places seat
		Name-Place/text: team-name
		show Name-Place
		if Print? [Print Output-message]
		append Communication-log Output-message
		if (length? Communication-log) > 100 [remove Communication-log]
		insert Client-Port Output-message
		if lettres? [
			temp: pick alpha-hands seat
			if not found? find MainWin/pane temp[append MainWin/pane temp temp/show?: true]
			either none? strhands[
				if 4 < length? temp/pane/2/pane[clear skip temp/pane/2/pane 4] 
				a: last temp/pane
				clear a/text
				show temp
				][
				display-hand pick Hands seat
			]
			show mainwin
		]
		(length? trainees) = Client-Number
		][
		output-message: "Log-on rejected"
		Print output-message
		Insert Client-Port Output-message
		close Client-port
		false
	]
	Client-Num: Client-Num + 1
	If Client-num < Client-Number [ exit]	; le nombre de clients attendus n'est pas atteint
	Connect?: to-logic true
; if a game has been interrupted by a disconnect, then on reconnecting restore hands
	if DummyUnveiled?[
		part-trick-remove
		Load-hands Donne-initiale
		Remove-Dummy
		DummyUnveiled?: false
	]
	CInit/data: head Cinit/data
	append clear CInit/data copy Setup2
	statusbar3/text: Connect
	show statusbar3
	Client-Lights: copy []
	for K 1 4 1[
		L: pick Lights K
	 	append/only Client-Lights copy L/effect
	]
;When every client will have been asking for teams the process will start with Team sending
]
Disconnected-Client: func[Client-port [port!]][
	if found? find remote-displays Client-port[
		remove find remote-displays Client-port
		remove find system/ports/wait-list Client-port
		exit
	]
	Client: index? find Client-ports Client-port

	Output-message: rejoin["lost connection...  " client-port/port-id ">"]
	if print?[print Output-message]
	append Communication-log join Output-message newline
	if (length? Communication-log) > 100 [remove Communication-log]
	Client-num: Client-num - 1
	remove find client-ports Client-port
	Sige: pick trainees Client
	seat: (index? find ["S" "W" "N" "E"] Sige )
	remove skip Clients (Client - 1)
	remove skip Trainees (Client - 1)
	light: pick lights seat
	hide light
	Nom-Client: pick Noms seat
	poke Noms seat "Coach" 
	remove find system/ports/wait-list Client-port
	close Client-port
	server-port/awake: func[ port ][
		Get-Client  ; Fonction grant les nouvelles connexions
		false
	]
	flag: to-integer 2 ** Client-num
	All-Ready-for-Deal: All-ready-for-Deal xor flag		;reset of flags for accepting "Ready for deal" at any time
	either connect? [
		poke Disconnected-Noms seat Sige
		Connect?: false
		][
		if ""  <> (form copy Disconnected-noms)[ poke Disconnected-Noms seat Nom-Client ]
	]
	if (Length? Clients) = 0 [Disconnected-noms: copy ["" "" "" ""]if Quitter? [quit]]
	Show mainwin
]
port-setup: does[
		Client-port/user-data: copy []
		Client-port/timeout: 1
		Client-port/awake: func[port /local data][
			if Print? [Prin rejoin["<" port/port-id  tab]]
			append Communication-log rejoin["<" port/port-id  tab]
			either error? char: TRY [first port][
				error: disarm char
				either error/id = 'past-end [
					Disconnected-Client port 
					][
					Lire-autres-ports port/port-id
				]
				][
				data: COPY to-string char
				while [newline <> char: first port] [append data char]
				if Print? [Prin data]
				append Communication-log data
				append port/user-data data
				input-message: copy data
				Gestion-Tches port
				if Print?[Print rejoin [tab port/port-id ">"]]
				either (last (last Communication-log)) = newline[
					append Communication-log rejoin[tab port/port-id ">"]
					][
					append last Communication-log rejoin[tab port/port-id ">"]
				]
				if (length? Communication-log) > 100 [remove Communication-log] 
			]
			false
		]
		append system/ports/wait-list Client-port
]
;===================================
; team sending Blue Chip Bridge protocol
;==================================
Envoi-quipes: does [
;once the name of players are known, the game to be played; any interrupted match could be returned
	NS-Team: (either (First Noms) = (Third Noms) [copy First Noms][rejoin [(Third Noms) "/" (First Noms)]])
	EW-Team: (either (second Noms) = (last Noms) [ copy second Noms][rejoin [(last Noms) "/" (second Noms)]])
	if Match?[
		match-retour?: to-logic false
		match: copy []
;getting back both record files if interrupted or creating new ones
		NS-T: copy (either (First Noms) = (Third Noms) [
			First Noms
			][
			either (First Noms) < (Third Noms)[
				rejoin [(First Noms) "/" (Third Noms)]
				][
				rejoin [(Third Noms) "/" (First Noms)]
			]
		])
		EW-T: copy (either (second Noms) = (last Noms) [
			second Noms
			][
			either (second Noms) < (last Noms)[
				rejoin [(second Noms) "/" (last Noms)]
				][
				rejoin [(last Noms) "/" (second Noms)]
			]
		])
		NS-alert-File: to-file rejoin["List " NS-T ".txt"]
		EW-alert-File: to-file rejoin["List " EW-T ".txt"]
		if exists? NS-alert-File[NS-alert-messages: read/lines NS-alert-file] 
		if exists? EW-alert-File[EW-alert-messages: read/lines EW-alert-file] 
		Nom-Fichier-Asauver: to-file rejoin [Deal-Event "- " NS-T " v " EW-T ".pbn"]
		replace Nom-Fichier-Asauver "/" "_"
		Nom-Fichier-Retour: to-file rejoin [Deal-Event "- " EW-T " v " NS-T ".pbn"]
		replace Nom-Fichier-Retour"/" "_"
		Match-sheet: to-file rejoin ["Match sheet " Nom-Fichier-Asauver ]
		replace Match-sheet ".pbn" ".txt"
;ckecks if a similar file exists
		either (exists? Nom-Fichier-Asauver) or (exists? Nom-Fichier-retour) [
			texte-aller: copy texte: read/lines either exists? Nom-Fichier-Asauver[Nom-Fichier-Asauver][Nom-Fichier-retour]
			Pointeurs-aller: copy reprer-donnes
			;NumDonne: length? reprer-Donnes
			NumDonne: length? Pointeurs-aller
			either IRMAS?[
;if present match mode is random then file has also been generated in random mode because of the name! 
				if not random-IRMAS?[
					if MonoDonne?[NDonnes: length? pointeurs]
					if (NDonnes * 2) = NumDonne[abandon-match exit]		;match has been completed
				]
				either Poursuivre?[
;in IRMAS mode, players should seat at the same place in order to resume the same data stucture
					either not exists? Nom-Fichier-Asauver[
						inform erreur-place
						Dconnexion
						exit
						][
						reprendre-IRMAS
					]
					][
					abandon-match
					exit
				]
				][
				if MonoDonne?[NDonnes: length? pointeurs]
				if (NDonnes * 2) = NumDonne[abandon-match exit]		;match has been completed
				If NumDonne > NDonnes [		; checks for initiated secound round
					fichiers-jauge: copy/Part texte-aller	((pick pointeurs-aller (Ndonnes + 1)) - 1);to recover PAR of the deal
					pointeurs: copy/part pointeurs-aller NDonnes
					Match-sheet: to-file rejoin ["Match sheet " Nom-Fichier-retour]
					replace Match-sheet ".pbn" ".txt"
					NumDonne: NumDonne - NDonnes
					match-retour?: to-logic true
					]
				either NumDonne < Ndonnes[		;match interrupted
					either Poursuivre?[reprendre-match][abandon-match exit]  
					][	;no unusual interruption
					either exists? Nom-Fichier-retour[
						NumDonne: 0
						inform/offset second-round to-pair Compose[(table-width) 20]
						][
						match-retour?: false
						abandon-match
					]
				]
			]
			][		;file did not exist
			Match-setup
		]
	]
	get-in-match
]
abandon-match: does[
	match-setup
		either exists? Nom-Fichier-Asauver[
			Sauver-Fichier Nom-Fichier-Asauver
			][
			Sauver-Fichier Nom-Fichier-retour
		]
	get-in-match
]
;===========================
; verifications are terminated: the match can go on (new or returned)
;===========================
get-in-match: does[
	replace/all NS-team {"} ""
	replace/all EW-team {"} ""
	Teams: copy rejoin [{Teams : N/S : "} NS-Team {" E/W : "} EW-Team {"} newline]
	Foreach RD Remote-Displays[insert RD Teams]
	if Print? [Prin Teams]
	append Communication-log Teams
	Output-Message: Teams
	Dispatch-message
	if Client-Number < 3 [
		output-message: rejoin["Mode Entranement Enchres Possible" newline]
		Dispatch-message
	]
]
is-IRMAS?: does[
;Checks if log file as a IRMAS structure (in immediate return mode the second deal has the same hands)
	donne: copy ""
	Foreach L Texte[
		either donne = ""[
			if found? find L "Deal "[donne: copy skip second parse L None 2]
			][
			if found? find L "Deal "[return found? find L donne]
		]
	]
	false
]
reprendre-IRMAS: does[
;checks if the IRMAS was random. If so just go on
	Match-sheet: to-file rejoin ["Match sheet " Nom-Fichier-Asauver ]
	replace Match-sheet ".pbn" ".txt"
	match: read/lines Match-sheet
	Njoues: NumDonne
;check if stats module is present. If so, in a first simplified procedure
	If stats?[Report-Setup NumDonne: 1 excuter-stats texte ]
	NumDonne: to-integer (NJoues / 2)
	either random-IRMAS?[
; reset all variables
; remove any uncompleted deal
		if odd? NJoues[
			remove back tail match
			while ["" = trim/ALL last texte][remove Back tail texte]
			while ["" <> trim/all last texte][remove Back tail texte if texte =[] [break]]
			NJoues: NJoues - 1
			write/lines Match-sheet match
			write/lines Nom-Fichier-Asauver texte		
		]
		NumDonne: NumDonne + 1
		statusbar1/text: rejoin [Etui NumDonne]
		show statusbar1		
		][
;source was not random; recover pointer and interrupted deal if necessary.
		either odd? NJoues[
			Donne-aller: retrouver-deal NJoues texte-aller
			match-retour?: true
			NumDonne: NumDonne + 1
			Donne-initiale: fetch-deal NumDonne Fichiers-jauge
			swap-deal
			][
			match-retour?: false
		]
	]
	reprendre-match
]
Asseoir: does[
"Teams just received. Display names on the mat"
	if Computer-seat = 5[connect?: true]
	parse input-message [thru {"} copy NS-Team to {"} skip {E/W} thru {"} copy EW-team to{"}]
	replace Ns-team ":" ""
	replace EW-team ":" ""
	Either found? find NS-Team "/"[
		NName/text: trim first parse NS-team "/"
		SName/text: trim second parse NS-team "/"
		][
		NName/text: trim NS-team 
		SName/text: trim NS-team 
	]
	Either found? find EW-Team "/"[
		EName/text: trim first parse EW-team "/"
		WName/text: trim second parse EW-team "/"
		
		][
		EName/text: trim EW-team 
		WName/text: trim EW-team 
	]
	poke Noms 1 copy SName/text
	poke Noms 2 copy WName/text
	poke Noms 3 copy NName/text
	poke Noms 4 copy EName/text
	Client-Lights: copy []
	for K 1 4 1[
		L: pick Lights K
		if (k - 1) <> Computer-seat [poke L/effect 2 navy]
	 	append/only Client-Lights copy L/effect
		show L
	]
	;checks now if distant players bear the same name("Coach"): if yes then playing in training mode
	k: 0
	Count: 0
	foreach N Names-Places [if k <> computer-seat [if N/text = (Pick Noms-seats K + 2)[count: Count + 1]]k: k + 1]
	either Count = 3 [Training?: to-logic true][training?: to-logic false]
	show MainWin
]
Receive-Deal: func[CP [port!]][
	B: input-message
	remove find CP/user-data B
	if computer-seat = 4[
		mode-Fun?: true
		output-message: join B newline
		dispatch-to-remote
	]
	parse B [thru "Board " copy Nom-Donne to "."
		thru "Dealer " copy Dealer-name to "." 
		Thru ". " copy Vulnerable to " vulnerable"
	]
	Enchres-lues: copy []
	Effacer-Bids
	Part-Trick-remove
	forall Jeu[hide first jeu]
	jeu: head Jeu
	Statusbar3/text: Attente-enchre
	Dealer: to-string first Dealer-Name
	Dealer-Seat: (index? find Joueurs Dealer) - 1
	Affiche-deal Nom-Donne Dealer Vulnerable
	output-message: rejoin[Client-place " ready for cards" newline]
	if Computer-seat < 4 [insert trainee-port output-message]
]
Affiche-Deal: func [N D V][
	V2: st-Vulnrables
	Vul: vulnerable
	switch V ["Neither" [V2: st-Vuln Vul: Personne ] "N/S" [Vul: NS] "E/W" [Vul: EO] "Both" [Vul: Tous] "All" [Vul: Tous]]
	D: switch Dealer ["S" [second noms-seats] "W" [third noms-seats] "N" [fourth noms-seats] "E" [last noms-seats]]
	statusbar1/text: N
	statusbar2/text: rejoin [Donneur D "  " Vul V2]
]
Receive-Hand: func[CP [port!]][
	B: input-message
	either computer-seat >= 4[		;remote display? and mode-fun?
		seat: (index? find Joueurs to-string first b) - 1
		][
		seat: Computer-seat
	]
 	parse b [thru ": " copy M to end]
	M: rejoin parse M none
	Main-Acharger: Copy []
	Blk1: parse/all (Join M ".") "."
	foreach Couleur-Joueur Blk1 [
		if Couleur-Joueur = last blk1 [break]
		Coul: to-string first Couleur-Joueur
		remove Couleur-joueur	;remove color name from string
		foreach Crd Couleur-Joueur [
			if Crd = #"-" [break]
			Card: find-Card (join Coul Crd)
			Card/seat: seat
			Card/todo: none
			append Main-Acharger Card
		]
	]
	poke Hands (seat + 1) Main-Acharger
	Evaluer-Points Main-Acharger seat
; translate Mains-lettres if not english
		either language <> "english"[
			B: copy[]
			foreach Col Blk1[
				replace Col "-" ""
				D: copy ""
				foreach C Col[append D pick symboles-cartes (index? find cards-names to-string C)]
				append B D
			]
			blk1: copy b
			][
			foreach Col Blk1[replace Col "-" ""]
		]
		Poke mains-lettres (seat + 1) blk1
	; Mettre  jour l'cran graphique
	display-Hand Main-Acharger
	show MainWin
	either Mode-Enchres?[
		Entranement-Enchres
		][
		either computer-seat = 5[		;remote display
			either none? enchres-connues[
				DummyUnveiled?: false Dveloppement-enchres
				][
				if 0 < Length? enchres-connues[DummyUnveiled?: false Dveloppement-enchres]
			]
			][
			if enchres-lues = [][Dveloppement-enchres]
		]
	]
]
Receive-Dummy: func[CP [port!]][
	B: input-message
	remove find CP/user-data B
 	parse b [thru ": " copy Main-Joueur to end]
	Main-Joueur: rejoin parse Main-joueur none
	Main-Acharger: copy []
	Blk1: parse/all (Join Main-Joueur ".") "."
	foreach Couleur-Joueur Blk1 [
		if Couleur-Joueur = last blk1 [break]
		Coul: to-string first Couleur-Joueur
		remove Couleur-joueur	;remove color name from string
		foreach Crd Couleur-Joueur [
			if Crd = #"-" [break]
			Card: find-card (join Coul Crd)
			Card/seat: Dummy-seat
			Card/todo: none
			append Main-Acharger Card
		]
	]
	poke Hands (Dummy-seat + 1) Main-Acharger
	Evaluer-Points Main-Acharger Dummy-seat
; translate Mains-lettres if not english
		if language <> "english"[
			B: copy[]
			foreach Col Blk1[
				replace Col "-" ""
				D: copy ""
				foreach C Col[append D pick symboles-cartes (index? find cards-names to-string C)]
				append B D
			]
			blk1: copy b
		]
		Poke mains-lettres (Dummy-seat + 1) blk1
	display-Hand Main-Acharger
	if extras? [Job6]
	Lire-Carte
]
Receive-bid: func[CP [port!]][
	B: input-message
	remove-message CP
	if mode-fun?[com-zone/text: none show com-zone]
	output-message: join input-message newline
	Dispatch-to-remote
	either found? find b " Alert."[
		parse b [to " Alert." copy Alert-info to end]
		clear find b " Alert"
		Alert?: to-logic true
		][
		either found? find b " Infos."[
			parse b [to " Infos." copy Alert-info to end]
			clear find b " Infos"
			Infos?: to-logic true
		][
			Alert-info: copy ""
			Alert?: to-logic false
			Infos?: to-logic false
		]
	]
	if found? find b " passes" [Bid-result: copy "Pass" ]
	if found? find b " doubles" [Bid-result: copy "X" ]
	if found? find b " redoubles" [Bid-result: copy "XX" ]
	if found? find b " bids" [Bid-result: third parse b none]
	either TM? [
		if illegal-bid?: illegal-bid [
			insert CP join "Illegal bid" newline
			statusbar3/text: enchre-illicite
			exit
		]
		if Mode-enchres?[
			either Bid-result = first Enchres-rfrence [
				insert CP join "Enchre correcte" newline
				][
				Bid-result: first Enchres-rfrence
				insert CP rejoin ["Mauvaise enchre " Bid-result newline]
			]
			remove Enchres-rfrence
		]
		append enchres-lues Bid-result
			temps-coul: now/time/precise - Dbut-attente
			if Temps-coul < 0:00:00 [temps-coul: temps-coul + 24:00:00]
			if EW-Wait?[	EW-elapsed: EW-elapsed + temps-coul]
			if NS-Wait?[	NS-elapsed: NS-elapsed + temps-coul]
		NS-wait?: EW-wait?: to-logic false
		if (not Mode-enchres?) and (not mode-fun?) [Item-record Bid-result "Auction "]
		bid-ready
		if players-ready? [Lire-Enchre]
		][
		append enchres-lues Bid-result
		Lire-Enchre
	]
]
illegal-bid: does[
	if Bid-result = "Pass" [return false]
	if Bid-result = "X"[either Peut-Contrer?[return false][return true]]
	if Bid-result = "XX"[either Peut-SurContrer?[return false][return true]]
	if Best-call = "Pass" [return false]
	if (first bid-result) > (First Best-Call)[return false]
	if (first bid-result) < (First Best-Call)[return true]
	if (second bid-result) = #"N"[either (second Best-call) = #"N"[return true][return false]]
	if (index? find pbn-colors second bid-result) = (index? find pbn-colors second Best-Call)[return true]
	return false
]
Receive-Card: func[CP [port!]][
	B: copy input-message
	remove-message CP
	C: last (parse b none)
	C: join last C first C
	if TM? [
		if illegal-card?: illegal-card[
			insert CP join "Illegal card" newline
			statusbar4/text: carte-illicite
			exit
		]
	]
	statusbar4/color: pewter
	append cartes-lues C
	either TM? [
		temps-coul: now/time/precise - Dbut-attente
		if Temps-coul < 0:00:00 [temps-coul: temps-coul + 24:00:00]
		if EW-Wait?[	EW-elapsed: EW-elapsed + temps-coul]
		if NS-Wait?[	NS-elapsed: NS-elapsed + temps-coul]
		NS-wait?: EW-wait?: to-logic false
		either mode-fun?[
			Card: find-card C
			Card/seat: Next-player-seat
				if found? find Mainwin/pane composeur-main[Hide-card Card/data]
				lire-Carte
			][
			Item-record C "Play "
		]
		Card-ready		; to check if players (if any) are ready.
		][
		Card: find-card C
		Card/seat: Next-player-seat
		if Computer-seat = 5[
			if found? find Mainwin/pane composeur-main[Hide-card Card/data]
			lire-Carte exit
		]
		either DummyUnveiled? [
			Lire-Carte
			][
			either computer-seat = dummy-seat[
				lire-carte
				][
				output-message: rejoin [Client-place " ready for Dummy" newline]
				insert trainee-port output-message
			]
		]
	]
]
illegal-card: does[
	if mode-fun?[return false]	;no test is made in this mode where cards are not all known
	Card: find-card C
	if Card/todo = "remove" [return True]				; card has already been played!
	if Card/seat <> next-player-seat [return true]	;Card does not belong to that player
	if none? Couleur-demande[return false]
	Color: to-string Pick C 1
	if Color = Couleur-demande[return false]
	Main-Joueur: pick Hands (next-player-Seat + 1)
	if Remains-Color? [return true]						;wrong color produced when it remains some
	return false
]
;=====================================
; Blue Chip Bridge protocol: every player has to send "ready for .." when not his turn
; Table manager is waiting them to go on
;=====================================
Dummy-ready: does[
	players-ready?: to-logic false
	k: 1
	foreach C Clients[
		S: (index? Find Joueurs (to-string first C)) - 1		; find place of Player
		If S <> dummy-seat [
			CP: pick Client-ports k
			if CP/user-data = [] [return false]
			Trouv?: false
			foreach B CP/user-data[if (found? find B "ready for Dummy") [Trouv?: true break]]
			if not Trouv? [return false]
		]
		k: k + 1
	]
; all remote players (except dummy) have answered to be ready
	Dummy-dispatch
]
Card-ready: does[
	players-ready?: to-logic false
	k: 1
	foreach C Clients[
		S: (index? Find Joueurs (to-string first C)) - 1		; find place of Player
		NPS: Next-Player-seat
		if dummy-seat = next-player-seat [NPS: Declarer-seat]
		If S <> NPS [
			CP: pick Client-ports k
			if CP/user-data = [] [return false]
			Trouv?: false
			foreach B CP/user-data[if (found? find B "To trick") [Trouv?: true break]]
			if not Trouv? [return false]
		]
		k: k + 1
	]
; all remote players (except next-player-seat) have answered to be ready
	Players-ready?: to-logic true
; checks if a card is pending to be treated and sent
	if ((length? cartes-lues) <> (length? cartes-connues))  [Players-ready?: to-logic false Lire-Carte ]
]
Bid-ready: does[
	players-ready?: to-logic false

	k: 1
	foreach C Clients[
		S: (index? Find Joueurs (to-string first C)) - 1		; find place of Player
		If S <> next-player-seat [
			CP: pick Client-ports k
			if CP/user-data = [] [return false]
			Trouv?: false
			foreach B CP/user-data[if (found? find B "'s bid") [Trouv?: true break]]
			if not Trouv? [return false]
		]
		k: k + 1
	]
; all remote players (except next-player seat have answered to be ready
	Players-ready?: to-logic true
; checks if a card is pending to be treated and sent
	if ((length? enchres-lues) - (length? enchres-connues)) > 0 [Lire-Enchre Players-ready?: to-logic false]
]
;==========================================
; single distant player special mode. (Not Blue Chip)
; TM may decide the place of distant player around the table, south being the default declarer
;==========================================
Placer-Joueur: does[
; with recorded deal name ending by "w" Trainee is playing defense as leader, ending by "e" playing defense
; and receives lead card.
	Noms: copy ["Coach" "Coach" "Coach" "Coach"] 	;Player Names for the PBN Deal
	either (found? find Nom-Donne Random-deal) [
		Poke Noms 1 Nom-Joueur
		Trainees: copy ["S"]
		Clients: copy ["South"]
		][
		either found? find Nom-Donne ".pbn" [parse Nom-Donne [copy Root to ".pbn"]][Root: copy Nom-Donne]
		Place: to-string (last Root)
		either Place = "e" [
			Poke Noms 4 Nom-Joueur
			Trainees: copy ["E"]
			Clients: copy ["East"]
			][
			either Place = "w" [
				Poke Noms 2 Nom-Joueur
				Trainees: copy ["W"]
				Clients: copy ["West"]
				][
				Poke Noms 1 Nom-Joueur
				Trainees: copy ["S"]
				Clients: copy ["South"]
			]
		]
	]
	Output-message: rejoin ["Votre place est " first trainees newline]
	insert first Client-ports output-message
]
Receive-place: does[
	switch last (parse input-message none)[
		"S" [poke Trainees 1 "S" poke Clients 1 "South"]
		"E" [poke Trainees 1 "E" poke Clients 1 "East"]
		"W" [poke Trainees 1 "W" poke Clients 1 "West"]
	]
]
Dbut-Jeu: does[
	if not match?[contrat-aller/text: none]
	output-message: join "Start of Board" newline
	Waiting-Ready-for-Deal?: true
	Foreach Client-Port Client-Ports[while [Client-port/user-data <> []][remove Client-port/user-data]]
	Dispatch-Message
	Clear Main-Buffer
	enchres-lues: copy []
	either match-retour?[
		if none? PAR-comment[output-message: join "match-aller" newline dispatch-to-remote]
    ][
		either none? PAR-comment[
			][
			PAR-text/text: translate-PAR Par-comment
			show making-array
		]
	]
	if Ready-for-Deal = All-Ready-for-Deal[Send-deal]
]
Send-deal: does[
"Send the deal information and his hand to each client"
	Waiting-Ready-for-Deal?: false
	Ready-for-Deal: 0
	Deal-Info: Copy "Board "
	Nom-Donne: join "number " to-string NumDonne
	Append Deal-info Nom-Donne
	Append Deal-info ". Dealer "
	Append Deal-Info Dealer-name
	Append Deal-info ". "
	Append Deal-Info V-case
	Append Deal-Info " vulnerable. "
	output-message: copy join Deal-Info newline
	dispatch-message
	Dispatch-to-remote
	send-hands
]
send-hands: does[
	if not mode-fun?[if version17 <> Ready-for-Cards?[exit]]
	Foreach Client-Port Client-Ports[
		b: first Client-Port/user-data
		while [Client-port/user-data <> []][remove Client-port/user-data]
		Client: first (parse b none)
		output-message: hand-makes Client
		Dispatch-to-remote
		if Print? [Print Output-message]
		insert Client-port output-message
		c: parse/all output-message to-string newline
		forall c[append Communication-log first c]
		if (length? Communication-log) > 100 [remove Communication-log]
	]
	if none? PAR-Comment [output-message: join "PAR request" newline Dispatch-to-remote]
	EW-wait?: not NS-wait?: even? index? find joueurs dealer
	Dbut-calcul: Dbut-attente: now/time/precise
	Ready-for-Cards?: 0
	either Mode-Enchres?[Entranement-Enchres][if enchres-lues = [][Dveloppement-Enchres]]
]
Hand-makes: func[Client [string!]][
		output-message: copy Client	
		append output-message "'s cards : "
		either mode-Fun?[Seat: Seat-saisi + 1][Joueur: to-string First Client Seat: index? find Joueurs Joueur]
		Main: pick Hands Seat
		K: 1
		foreach Col PBN-colors [
			Couleur-Nombre: 0
			append output-message Col
			while [Col = first (get in (pick Main K)'data)][
				append output-message " "
				append output-message second (get in(pick Main K)'data)
				Couleur-Nombre: Couleur-nombre + 1
				if K = 13 [BREAK]
				K: K + 1
			]
			append output-message either Couleur-nombre = 0 [" -. "][". "]
		]
		append output-message newline
]
Bid-Dispatch: func [
{Objective: sending the last made bidding and Caller to connected people according to the specified rules and ressources.}	Last-Bid [String!]	"Last auction made"
	S [integer!]		"Seat of Caller"
	][
	if tog-pause/text = "Continue" [exit]
	Output-message: copy pick ["South" "West" "North" "East"] (S + 1)
	Switch/default last-bid [
		"X"	[Ench: " doubles"]
		"XX"	[Ench: " redoubles"]
		"Pass" [Ench: " Passes"]
	][Ench: rejoin [" bids " Last-Bid]]
	append output-message Ench
	Output-alerted-message: rejoin [output-message Alert-info newline]; add alert message if any
	append output-message newline							;create no-alerted message for partner
	if Print? [prin join newline ">>" Prin output-message]
	append Communication-log rejoin [">>" Output-message]
	if (length? Communication-log) > 100 [remove Communication-log]
	Bid-to-dispatch?: to-logic false
	K: 1
	foreach Client Clients [
		Joueur: to-string first Client
		Seat: (index? Find Joueurs Joueur) - 1
		If seat <> S [
			Client-Port: pick Client-Ports K
			remove-each data Client-Port/user-data[found? find data "'s bid"]
			either Alert?[
				either alert-transmit?[
					either Odd? ((S - Seat) // 2)[
						insert Client-Port  Output-alerted-message
						][
						insert Client-Port output-message
					]
					][

					insert Client-Port output-message
					if next-player-seat = client-port/user[
						EW-wait?: not NS-wait?: even? Next-player-seat
						Dbut-attente: now/time/precise
					]
				]
				][
				insert Client-Port output-message
				if next-player-seat = client-port/user[
					EW-wait?: not NS-wait?: even? Next-player-seat
					Dbut-attente: now/time/precise
				]
			]
		]
		K: K + 1
	]
]
Dummy-Dispatch: does [
	Output-message: copy "Dummy's cards : "
	Main: pick hands (Dummy-seat + 1)
	K: 1
	foreach Col PBN-colors [
		Couleur-Nombre: 0
		append output-message Col
		while [Col = first (get in (pick Main K)'data)][
			append output-message " "
			append output-message second(get in (pick Main K)'data)
			Couleur-Nombre: Couleur-nombre + 1
			if K = 13 [BREAK]
			K: K + 1
		]
		append output-message either Couleur-nombre = 0 [" -. "][". "]
	]
	append output-message newline
if Print? [prin join newline ">>" Prin Output-message]
	append Communication-log rejoin [">>" Output-message]
	if (length? Communication-log) > 100 [remove Communication-log]
	Count: 1
	foreach Client Clients [
		Joueur: to-string First Client
		Seat: index? find Joueurs Joueur
		if seat <> (Dummy-seat + 1) [
			Client-port: pick Client-ports Count
			remove-each data Client-Port/user-data [found? find data "Ready for dummy"]
			insert Client-port output-message
		]
		Count: Count + 1
	]
]
Card-Dispatch: FUNC[
	C	[String!]
	S [integer!]
][
	if Card-to-dispatch?: (tog-pause/text = "Continue") [Joueur-en-suspens: S exit]
	Output-message: copy pick ["South plays " "West plays " "North plays " "East plays "] (S + 1)
	Carte: join (second C) (first c)
	append output-message Carte
	append output-message newline
	Dispatch-to-remote
	if Print? [prin join newline ">>" Prin output-message]
	append Communication-log rejoin [">>" Output-message]
	if (length? Communication-log) > 100 [remove Communication-log]
	K: 1
	players-ready?: to-logic false
	foreach Client Clients [
		Joueur: to-string first Client
		Seat: (index? Find Joueurs Joueur) - 1
		Either S = Dummy-seat [
			If seat <> ((S + 2)// 4)[
				Client-Port: pick Client-Ports K
				remove-each data Client-Port/user-data[found? find data "to trick"]
				insert Client-Port output-message
			]
			][
			If seat <> S [
				Client-Port: pick Client-Ports K
				remove-each data Client-Port/user-data[found? find data "to trick"]
				insert Client-Port output-message
			]
		]
		K: K + 1
	]
	EW-wait?: not NS-wait?: even? Next-player-seat
	Dbut-attente: now/time/precise
]

; ========================
; getting ready to make a bid
; ========================
Call-Bid: func [
"According the expected call: if it occurs on the present computer ask for it or wait for another calling"
	Best-call [string!]
	next-player-seat [integer!]
	Peut-Contrer? [logic!]
	Peut-Surcontrer? [logic!]
	][
	Arrows next-player-seat
	either Trainee? next-player-seat[
		if Alert? [exit]	;wait for elapsed time or acknowlegemnt of player
		either next-player-seat = Computer-Seat [
			Card-feel-redirect next-player-seat "Bid"
			Make-Call Best-call Peut-Contrer? Peut-Surcontrer?
			][
			retour-timer: "Attente-Enchre"
		]
		][
		either TM? [				;fifth chair
			either Mode-Enchres?[
				append enchres-lues first enchres-rfrence
				remove enchres-rfrence
				bid-ready
				][
				if not match?[Com-Zone/text: Evaluer]
				Card-feel-redirect next-player-seat "bid"
				if not mode-fun?[Make-Call Best-call Peut-Contrer? Peut-Surcontrer?]
			]
			][
			if Alert? [exit]	;wait for elapsed time or acknowlegemnt of player
			P: switch next-player-seat [0 [copy "South"] 1 [copy "West"] 2 [copy "North"] 3 [copy "East"]]
			output-message: rejoin [Client-place " ready for " P "'s bid" newline]
			if computer-seat < 4 [insert Trainee-port output-message]
			retour-timer: "Attente-Enchre"	; will wait 
		]
	]
]
attente-carte: does[
"if not next-player-seat sends  ready for x 'card to trick N"
	if dummy-seat = next-player-seat [
		if declarer-seat = computer-seat [exit]]
	if ((computer-seat <> next-player-seat) or (computer-seat = dummy-seat ))[
		P: switch next-player-seat [0 [copy "South"] 1 [copy "West"] 2 [copy "North"] 3 [copy "East"]]
		if dummy-seat = next-player-seat [P: copy "dummy"]
		output-message: rejoin [Client-Place " ready for " P "'s card to trick " Trick-count newline]
if Print? [Prin output-message]
		insert trainee-port output-message
	]
]
; ========================
; getting ready to produce a card
; ========================

Call-Card: func [
{Launch the request procedure and return}
	Color [string! none!]				; color asked for
	Next-Player-Seat [integer!]		; seat of Player (0 for S to 3 clockwise
	][
	Arrows Next-Player-Seat
	if computer-seat > 4 [exit]
	either Trainee? Next-Player-Seat [			; a distant player must play
		if Dummy-seat = Next-Player-seat [
			if computer-seat = dummy-seat [attente-carte exit]
			if computer-seat = declarer-seat[Activer-cartes]
		]
		if Next-Player-Seat = Computer-Seat [Activer-Cartes]
		][
		either TM? and (not Mode-fun?)[					;if present computer is manager and must play
			if Next-player-seat = dummy-seat[if trainee? declarer-seat[halt exit]]
			if Client-number = 1 [
				if Next-Player-Seat = declarer-seat[if trainee? dummy-seat [halt exit]]
			]
			Activer-Cartes
			][
			if computer-seat < 4 [attente-carte]				;if present computer not to play
		]
	]
]
Activer-Cartes: does[
	if extras?[if Job7[exit]]
	Card-must-Play: only-card
	either none? Card-must-Play  [
		either extras?[
			Job8
			][
			Card-feel-redirect Next-Player-Seat "Play"
		]
		][
		C-rank: get in (find-card Card-must-Play) 'user-data
		PlayedCard Card-must-play Next-player-seat C-rank
	]
]
Trick-Leader: does [
" Open right to trick leader to play the first card of the trick"
	ArrOn: ArrOff
	if Trick-to-lead?: (tog-pause/text = "Continue") [exit]
	EW-wait?: not NS-wait?: even? Trick-First-Player
	Dbut-attente: now/time/precise
	wait attente-fin-Leve
	either Trick-First-Player = Dummy-seat [
		Output-message: copy "Dummy"
 		Leader-name: pick ["North" "East" "South" "West"] (Trick-first-player + 1)
		][
		Leader-name: pick ["South" "West" "North" "East"] (Trick-first-player + 1)
		Output-Message: copy Leader-name
	]
 	Client-rank: index? find Clients Leader-name
	Client-port: pick Client-ports Client-rank
	append output-message " to lead"
	append output-message newline
	insert either mode-fun? [fun-port][Client-port] output-message
	if Print? [Prin join ">>" output-message]
	append Communication-log rejoin [">>" Output-message]
	if (length? Communication-log) > 100 [remove Communication-log]
	
]
;================================
; checks if the player must play one card (last trick or single card remaining of the resquested color)
; ===============================
Only-Card: does [
	if mode-Fun? [return none]
	Card-must-play: none
	Main-Joueur: pick Hands (Next-Player-seat + 1)
	either trick-Count = 13 [
; for the last trick everybody automatically gives his last card!
		card-must-play: get in first Main-Joueur 'data
		][				; normal trick: check if a card is alone in the requested color
		Card-alone: to-integer 0
		if not (None? Couleur-demande)  [
			foreach Crd Main-Joueur[
				if ((to-string first Crd/data) = Couleur-demande)[
					Card-must-Play: Crd/data
					Card-alone: Card-alone + 1
					if Card-alone > 1 [return none]
				]
			]
			if Card-Alone <> 1 [Card-must-play: none]
		]
	]
	return Card-must-play
]
; ========================
; Posting a new Call or card 
; ========================
Item-Record: func [
{ Reports the new item in the PBN reference file}
	New-item [String!]
	Balise [string!]	"Balise de reprage qui distingue entre enchres et cartes joues"
	][
	Start: index? find Donne Balise
	Bids: find/tail (skip Donne start) newline
	if found? find Donne "* " [replace Donne "* " "+"]
	Start: (index? Find (skip Donne start) "+") - 1
	Donne: insert skip Donne start New-item
	if Alert?[
		Alert-count: Alert-count + 1
		if alert-info = "" [Alert-info: copy "Alert."]
		append Alert-list rejoin [Dbut-crochet {Note "} to-string Alert-count ":" Alert-info {"} fin-crochet]
		Donne: insert Donne rejoin[" =" Alert-count "="]
	]
	Count: length? either balise = "Auction "[enchres-lues][cartes-lues]
	Donne: insert Donne (either (count // 4) = 0 [Newline][" "])
	Donne: head Donne
	Write DonneRef Donne
]
; =======================
; Decides what to do with the clicked card according to its attributes
; =======================
What-todo: func [
	"Get the clicked card played. decide what to do with it"
	Face [object!]
	action 
	event	[event!]
	][
	Rang: either lettres? [Face/parent-face/user-data][Face/user-data]
	todo: get in (pick Jeu Rang) 'todo
	Seat: get in (pick Jeu Rang) 'seat
	Dc: get in (pick Jeu rang) 'data
	switch todo [
		"Play" [
			if Mode-Fun?[exit]
			if carte-pope[
				memo: Rang + pivot-cartes - 1
				remove find/last MainWin/pane face
				insert (skip MainWin/Pane memo) face
				Carte-pope: false
			]
			PlayedCard Dc Seat Rang
		] 
		"Bid" [bid-feel Dc]
		"Remove" [Trick-Remove]
		"Select" [Card-Select face]
		"unselect" [Card-unSelect face]
	]
]
PlayedCard: func [
	"Get the card played by hand. Check for eligibiity. Display it. Send it or Update in the reference PBN file"
	Card-name 
	Seat
	Rang [integer!]	"card ranking in the deck" 
	][
	Color: to-string Pick Card-Name 1
	Main-Joueur: pick Hands (Seat + 1)
	Accept-Color?: to-logic (none? Couleur-demande) 
	if (Couleur-demande = Color) [Accept-Color?: to-logic true]
	if not accept-color? [if (Not Remains-Color?) [Accept-Color?: to-logic true]]
	If Accept-color?	[
		Com-zone/action: none
		com-zone/text: copy ""
; Fast display : will be repeated later by the background program with no effect
		either Lettres?[
			temp: pick alpha-hands (Seat + 1)
			temp/pane/5/size/x: 200
			][
			Displayed-Card: pick Jeu Rang
			Displayed-Card/todo: "remove"
			if computer-seat = seat [
				Displayed-Card/offset: (pick Hand-Places (Seat + 1)) + pick Play-Places (Seat + 1)
				show MainWin
			]
		]
		foreach Crd Main-Joueur[if Crd/todo = "Play" [Crd/todo: none]]
		append Cartes-lues Card-name
		either TM? [
			Item-Record Card-Name "Play "
			Card-ready		; to check anyway if players (if any) are ready.
			If Players-ready? [Lire-Carte]
			][
			P: switch seat [0 [copy "South"] 1 [copy "West"] 2 [copy "North"] 3 [copy "East"]]
			output-message: rejoin [P " plays " second card-name color]
			if Print? [Print output-message]
			Insert Trainee-port join output-message newline
			either DummyUnveiled? [Lire-Carte][
				output-message: rejoin [Client-place " ready for Dummy" newline]
				insert trainee-port output-message
			]
		]
; if a card is played when it is possible to lay down, then reset
		if extras?[job9]
	]
]
Remains-Color?: does [
	foreach Crd Main-Joueur[if ((to-string first Crd/data) = Couleur-demande) [return true]]
	return false
]
; ======================================
;  Displaying hand
; ======================================
display-hand: make function! [
	"displays one of the hands"
	hand [Block!] 
	][ 
	Joueur-rang: (get in first hand 'seat) + 1
	either Lettres?[
		temp: pick alpha-hands Joueur-rang
		if 4 < length? temp/pane/2/pane[clear skip head temp/pane/2/pane 4]
		ML: pick Mains-lettres Joueur-Rang
		Longueur: 0
		dcalage: either lo-res[21x-3][27x-3]
		Step-x: as-pair (largeur-alpha-carte + 1) 0
		Step-y: either lo-res[0x29][0x35]
		saut-couleur: 0
		foreach H ML[
			if Longueur < Length? H  [Longueur: Length? H]
			foreach L H[
				rang-carte: (index? find symboles-cartes to-string L) + saut-couleur
				jeton: get in pick alpha-cartes rang-carte 'face
				jeton/offset: dcalage
				append temp/pane/2/pane jeton
				dcalage: dcalage + Step-x
			]
			dcalage/x: either lo-res [21][27]
			dcalage: dcalage + Step-y
			saut-couleur: saut-couleur + 13
			if saut-couleur = 26[saut-couleur: saut-couleur + 13];to take into account club/diamond order
			if saut-couleur = 52[saut-couleur: 26]
		]
; special fit for west
		longueur: longueur - 1
		if longueur < 3[longueur: 3]
		either Joueur-Rang = 2[
			Longueur: (either lo-res[50][60]) + (Longueur * Step-x/x)
			place-origine: temp/offset + temp/size
			temp/size/x: Longueur + either lo-res[7][12]
			temp/pane/1/size/x: Longueur + either lo-res[7][12]
			temp/offset: Place-origine - temp/size
			W-bar/offset: to-pair compose[(Longueur ) 0]
			West-alpha-name/size: to-pair compose[(longueur) 20]
			][
			Longueur: (either lo-res[50][60]) + (Longueur * Step-x/x)
			temp/size/x: Longueur + either lo-res[21][27]
			temp/pane/1/size/x: Longueur + either lo-res[21][27]
		]
			a: last temp/pane
			c: rejoin[get in pick Points Joueur-rang 'PH "H"]
			if Joueur-rang = 4[insert c " "]
			a/text: c
			a/font/valign: 'top
			a/font/align: 'left
		temp/show?: true
		show MainWin
		][
		switch Joueur-Rang [
			1 [Panel: SPane ximg: 0 yimg: 0]
			2 [Panel: WPane ximg: 0 yimg: (Spane/y - card-width - Wpane/y)dy: - dx2]
			3 [Panel: NPane ximg: 0 yimg: 0]
			4 [Panel: EPane ximg: 0 yimg: 0 dy: dx2]
		]	
		K: 0
		Main-Joueur: copy Hand
		sort/compare Main-Joueur func[a b][a/user-data < b/user-data]
		foreach Displayed-Card Main-Joueur[
			Displayed-Card/offset: panel + to-pair compose [(ximg) (yimg)]	; dfinir la position de l'image
			either odd? Joueur-rang [
				ximg: ximg + dx
				Displayed-Card/size: Vtaille-Carte
				Displayed-Card/effect: [rotate 0 aspect]
				][
				Displayed-Card/size: Htaille-Carte
				Displayed-Card/effect: [rotate 90 aspect]
				yimg: yimg + dy
			]
			show displayed-card
		]
	]
]
; ===================================================================
; Interpretating PBN file and displaying hands
; ===================================================================
load-Hands: make function! [
	"Interprte le Texte au format .pbn"
	texte [block!]		"Le contenu du fichier"
	][
	; Extraire le donneur (dealer), la vunerabilit (vulnerable) et la chane strhands contenant la dfinition des 4 mains
	D: switch Dealer ["S" [second noms-seats] "W" [third noms-seats] "N" [fourth noms-seats] "E" [fifth noms-seats]]
	Dealer-name: switch Dealer ["S" ["South"] "W" ["West"] "N" ["North"] "E" ["East"]]
	V: switch Vulnerable ["Neither" [Personne] "None" [Personne] "NS" [NS] "EW" [EO] "All" [Tous] "Both" [Tous]]
	V-case: switch Vulnerable ["Neither" ["Neither"] "None" ["Neither"] "NS" ["N/S"] "EW" ["E/W"] "All" ["Both"] "Both" ["Both"]]
	statusbar2/text: rejoin [Donneur D Vulnrabilit V]
    	show statusbar2

		; Supprimer le dbut
		; ----------------------
		First-hand: to-string first strhands 
		str: find/tail strhands ":"

        ; Lister les dfinitions des 4 mains dans un bloc blk
		; ---------------------------------------------------
	Place: (index? find Joueurs First-hand) - 1
	blk: parse/all str " "
       ; Lister les dfinitions des 4 couleurs composant les mains en commenant par le dealer
	foreach Main-joueur blk [
		Main-Acharger: copy []
		Blk1: parse/all (Join Main-Joueur ".") "."
		K: to-integer 1
		foreach Couleur-Joueur Blk1 [
			Coul: to-string first (to-string Pick PBN-colors k)
			off-coul: (K - 1) * 13
			foreach Crd Couleur-Joueur [
				Rang: Pick indice-crois (off-coul + index? find strcardsnames Crd)
				Card: Pick Jeu Rang
				Card/seat: Place
				append Main-Acharger Card
			]
			K: K + 1
		]
		poke Hands (Place + 1) Main-Acharger
		Evaluer-Points Main-Acharger Place
		Place: (Place + 1)
; translate Mains-lettres if not english
		if language <> "english"[
			B: copy[]
			foreach Col Blk1[
				D: copy ""
				foreach C Col[append D pick symboles-cartes (index? find cards-names to-string C)]
				append B D
			]
			blk1: copy b
		]
		Poke mains-lettres Place blk1
		Place: Place // 4
		display-hand Main-Acharger
	]
	DummyUnveiled?: to-logic False
]
;=========================
;extracting data from a pbn format
;=========================
load-deal: does [	
	Clear Frquences
	Frquence?: false
	PAR-comment: none
	feasability-array: none
	foreach C Donne-initiale [
		if found? find C "Board" [
			N1: Copy C
			Nom-D: second parse N1 none
			replace Nom-D fin-crochet ""
			either (length? Nom-D) > 0 [
				Nom-Donne: Nom-D
				][
				if value? 'Nom-Donne[C: rejoin[dbut-crochet {Board "} Nom-Donne {"} fin-crochet]]
			]
			either error? try[N: to-integer Nom-Donne][
				if not value? 'Nom-donne[Nom-Donne: Donne-inconnue]
				Statusbar1/text: Nom-Donne
				][
				Statusbar1/text: rejoin [Etui N]
			]
		]
		if found? find C "Event"[J: C Deal-Event: copy(find C " ")replace Deal-Event "]" ""]
		either Frquence?[
			either C = "}"[frquence?: false][append Frquences C]
			][
			either found? find C "Frq."[
				Frquence?: true
				][
				parse C [thru {[dealer "} copy dealer to {"]}]
				parse C [thru {[Vulnerable "} copy vulnerable to {"]}]
				parse C [thru {[Deal "} copy strhands to {"]}]
			]
		]
		if Found? find C "PAR of the deal"[
			Par-comment: copy C
			PAR-text/text: translate-PAR PAR-Comment
			show making-array
		]	
		if Found? find C "feasability"[feasability-array: copy skip replace C "}" "" 1 faisabilit feasability-array show making-array]
	]
	if not none? PAR-Comment[Par-text/text: copy translate-par PAR-Comment]
	either none? feasability-array[
		hide making-array
		][
		if lettres?[faisabilit feasability-array]
	]
	Frquence?: (length? Frquences) > 0
	Lettres?: TM-Lettres?
	if lettres? [reset-display]
	clear enchres-lues
	load-hands Donne-initiale
	replace vulnerable "/" ""
	Switch Vulnerable [
		"All"		[foreach P Names-Places[P/effect: [colorize red fit]]]
		"Both"	[foreach P Names-Places[P/effect: [colorize red fit]]]
		"EW"		[forskip  Names-Places 2[
			set in first names-places 'effect [fit]
			set in second names-places 'effect [colorize red fit]]]
		"NS"		[forskip Names-Places 2[set in second names-places 'effect [fit] 
				set in first names-places 'effect [colorize red fit]]]
		"None"	[foreach P Names-Places[P/effect: [fit]]]
		"Neither"	[foreach P Names-Places[P/effect: [fit]]]
	]
	names-places: head names-places
	If found? find CDOnnes/data (fifth Jouer3) [remove find CDonnes/data (fifth Jouer3)]
	if not connect? [			; menu spcifique au jeu en monoposte
		either found? find CDonnes/data fourth Jouer3 [
			change find CDonnes/data (fourth Jouer3) (fourth Jouer2)
			][
			if not found? find CDonnes/data (fourth Jouer2) [append CDonnes/data (fourth Jouer2)]
		]
	]
	show mainWin
; If connected ==> auction
	either connect? [if Client-num = Client-number [Dbut-Jeu]][Visionner]
] 
DF-File: does[
	a: parse copy skip strhands 2 none
	switch first strhands[
		#"N" [Nord: first a Est: Second a Sud: Third a Ouest: last a] 
		#"E" [Est: first a Sud: Second a Ouest: Third a Nord: last a] 
		#"S" [Sud: first a Ouest: Second a Nord: Third a Est: last a] 
		#"W" [Ouest: first a Nord: Second a Est: Third a Sud: last a] 
	]
	a: copy ["" "" ]
	append a join "Deal:  1                              " DF-Format Nord
	if contract <> ""[if Contract <> "Pass"[
	append a rejoin["Contract:  " Contract "-" pick ["South" "West" "North" "East"] (declarer-seat + 1) " " DF-Format Ouest "                  " DF-Format Est]
	append a rejoin["OnLead:  " pick ["West" "North" "East" "South" ] (declarer-seat + 1) "                        " DF-Format Sud]
	append a "Lead:  Any"
	]]
 	write/lines %DFfile.txt a
	if exists? Deep-Finesse-path[write/lines join Deep-Finesse-path "last Hand.txt" a]
]
DF-Format: func[X][
	if  #"." = first X  [replace x "." "- "]
	if  #"." = last X  [reverse X replace x "." "- " reverse X]
	replace/all X ".." " - "
	replace/all X "." " "
]
;=========================
; choosing initial file and directory
;=========================
Choix-fichier-rpertoire: does[
;checks also the nature of chosen file
	nom-complet-fichier: none
	Rpertoire: what-dir
	if exists? Donnes-dir [change-dir Donnes-dir]
	while [none? nom-complet-fichier] [
		nom-complet-fichier: request-file/only/keep/filter "*.pbn"
		standard?: false
		either tournoi-auto?[Basic2-reset/show?: true ][Basic2-reset/show?: false ]
		if None? nom-complet-fichier[
			iF match?[IRMAS-set/show?: true]
			inform confirmer-aucun-fichier
			IRMAS-set/show?: false
			if standard?[
				change-dir Rpertoire
				change-prefs
				chk4/data: false
				chang?: true
				tournoi-auto?: false
				view/title MainWin join "Bridge Moniteur version " version
				exit
			]
		]
	]
	if nom-complet-fichier = 0 [change-dir Rpertoire exit]
	Donne-initiale: read/lines nom-complet-fichier
	texte: read/lines nom-complet-fichier
	set [Donnes-dir fichier-pbn] split-path nom-complet-fichier	  
;if wished pbn standard conformity could be checked here
; counting and getting pointers for multi pbn files
	NDonnes: length? pointeurs: copy reprer-donnes
	NumDonne: to-integer 0
	either NDonnes = 1[inform Fichier-Une-donne][MonoDonne?: false]
	either MonoDonne? [
; if only one deal in the file, pointers becomes valid pbn entries in the folder
	  MonoDonne?: to-logic true
		clear pointeurs
		Fichiers-jauge: read Donnes-dir
		forall Fichiers-jauge [
			if found? find first fichiers-jauge ".pbn" [
				append pointeurs index? fichiers-jauge
				if fichier-pbn = first fichiers-jauge[numDonne: length? pointeurs]
			]
		]
		fichiers-Jauge: head fichiers-Jauge
		NDonnes: length? pointeurs
		][
		Fichiers-Jauge: copy texte
		Fichier-Asauver: copy ""
		NS-Total: 0
		EW-Total: 0 	  
	]
	change-dir Rpertoire
; save last accessed folder
	Param: copy []
	if exists? %BM_ini.txt[
		param: read/lines %BM_ini.txt
		k: copy []
		foreach P param [if (found? find P (join Dbut-crochet "Donnes"))[append K P]]
		forall K [remove find Param first K]
	]
	append param rejoin[Dbut-Crochet "Donnes " Donnes-dir Fin-Crochet]
	write/lines %BM_ini.txt param
]
Choix-fichier-initial: does[
; after file choice, set the pointer to the chosen file: if interrupted a session can restart from last game
	Choix-fichier-rpertoire
	if nom-complet-fichier = 0 [exit]
	RAZ
	if not MonoDonne? [
		Pointeur-Donne/text: to-string NDonnes
		if NDonnes <> 1[inform Choix-Donne]
		NumDonne: to-integer Pointeur/text
		either NumDonne = 1[
			Bouton-Prev/text: none
			Bouton-Prev/action: none
			Bouton-Suivante/text: st-suivante
			Bouton-Suivante/action: [suivante]
			][
			Bouton-Prev/text: st-Prev
			Bouton-Prev/action: [Prcdente]
			either NumDonne >= NDonnes[
				Bouton-Suivante/text: none
				Bouton-Suivante/action: none
				][
				Bouton-Suivante/text: st-suivante
				Bouton-Suivante/action: [suivante]
			]
		]
	]
	Donne-initiale: fetch-deal NumDonne Fichiers-jauge
	com-zone/text: none
	launch-deal
]
launch-deal: does[
	either TM?[
		Load-deal 
		][;if not TM send the reference file to the TM to have it played
		insert trainee-port join "Rfrence:" newline
		if not found? find form copy Donne-initiale "Board" [
			insert next Donne-initiale rejoin [Dbut-Crochet {Board "} Nom-Donne {"} Fin-Crochet]
		] 
		foreach L Donne-initiale[
			if not found? find statusbar1/text random-deal[
				If MonoDonne? [if found? find L "Board" [
					Nom-Donne: first (parse/all fichier-pbn ".")
					L: rejoin [Dbut-Crochet "Board " {"} Nom-Donne {"} Fin-Crochet]
				]
			]]
			insert trainee-port rejoin["&" L newline]
		]
		insert trainee-port join "Fin Rfrence" newline
		exit
	]
]
; ==============================================================================================================
;                  10th section - MMI  MAN MACHINE INTERFACE MODULES
; ==============================================================================================================
;at start of a new game reset the hands display
reset-display: does[
	Lettres?: TM-Lettres?
	either lettres? [
		set-alpha
		foreach temp alpha-hands[
			if 4 < length? temp/pane/2/pane[clear skip temp/pane/2/pane 4]
			a: last temp/pane
			a/text: none
		]
		Crer-alpha-cartes
		][
		set-graphics
		hide north-alpha
		hide south-alpha
		hide East-alpha
		hide West-alpha
	]
]

Set-alpha: does[
; change ligths
	lights: copy reduce[S-Bar W-Bar N-Bar E-Bar]
; change name places
	SName: South-alpha-name
	WName: West-alpha-name
	NName: North-alpha-name
	EName: East-alpha-name
	Names-places: REDUCE [SName WName NName EName]
; change Bid places
	Bid-offsets: either lo-res[copy [0x-53 5x0 0x140 -53x0]][copy [0x-53 5x0 0x169 -53x0]]
	foreach H alpha-hands[if not found? find MainWin/pane H[append MainWin/pane H]H/show?: true]
]
Set-graphics: does[
; change ligths
	lights: copy reduce[S-Connect W-Connect N-Connect E-Connect ]
; change name places
	SName: SName0
	WName: WName0
	NName: NName0
	EName: EName0
	Names-places: REDUCE [SName WName NName EName]
; change Bid places
	Bid-offsets: copy Bid-offsets0
	foreach H alpha-hands[hide H]
]
Traite-Alerte: does[
	Joueur: pick Noms-seats (next-player-seat + 2)
	Enchre-faite/text: copy rejoin[
		Joueur
		Switch/default Enchre[
			"X"	[st-contre]
			"XX"	[st-surcontre]
		][rejoin [
				enchrit 
				first Enchre " "
				switch to-string second Enchre [
					"S" [first Noms-couleurs]
					"H"	[second Noms-couleurs]
					"D"	[third Noms-couleurs]
					"C"	[fourth Noms-couleurs]
					"N"	[fifth Noms-couleurs]
				]
			]
		]
	]

	Commentaire/text: alert-explain: copy Alert-info
	affiche-Alerte
	either odd? next-player-seat[
		alerte-file: NS-alert-file
		liste-alerte: NS-alert-messages
		alert-arrow/show?:  to-logic length? NS-alert-messages
		][
		alerte-file: EW-alert-file
		liste-alerte: EW-alert-messages
		alert-arrow/show?:  to-logic length? EW-alert-messages
	]
	if liste-alerte <> [][
		append clear choix-alerte/pane/1/data copy head liste-alerte
		fix-slider choix-alerte/pane/1
	]
	alerte-layout/show?: true
	Alerte-display/show?: true
	if not (com-zone/pane = Bouton-Pause)[com-zone/pane: bouton-pause]
	tog-pause/data: next head tog-pause/data     ;will stop the process
	show MainWin
	Chang?: false
]
affiche-Alerte: does[
	for K 6 13 1[alerte-display/pane/(K)/text: "-"]
	HCPMin/text: copy HCPmax/text: copy"-"
	TMin/text: copy Tmax/text: copy"-"
	if found? find alert-explain "S="[
		a: copy skip (find alert-explain "S=") 2
		Pave-Cases a SMin Smax
	]
	if found? find alert-explain "H="[
		a: copy skip (find alert-explain "H=") 2
		Pave-Cases a HMin Hmax
	]
	if found? find alert-explain "D="[
		a: copy skip (find alert-explain "D=") 2
		Pave-Cases a DMin Dmax
	]
	if found? find alert-explain "C="[
		a: copy skip (find alert-explain "C=") 2
		Pave-Cases a CMin Cmax
	]
	if found? find alert-explain "HCP="[
		a: copy skip (find alert-explain "HCP=") 4
		Pave-Cases a HCPMin HCPmax
	]
	if found? find alert-explain "Total="[
		a: copy skip (find alert-explain "Total=") 6
		Pave-Cases a TMin Tmax
	]
]
Pave-cases: func[a [string!] Maxi Mini [object!]][
	trim/all a
	clear find a ","
	clear find a "."
	b:  copy head a
	clear find b #"-"
	if 0 = length? b[b: copy "-"]
	c: find a #"-"
	if 1 < length? c[remove c]
	Maxi/text: copy b
	Mini/Text: copy c
]
Clore-Alerte: func[Case [logic!]][
	hide alerte-layout
	hide Alerte-display
	hide Choix-alerte
	tog-pause/data: head tog-pause/data
	show mainwin
	either Case[
		either Chang?[
			alert-info: copy " Alert."
			if (SMax/text <> "-") or (SMin/text <> "-")[append alert-info construire-alerte "S=" SMax/text SMin/text] 
			if (HMax/text <> "-") or (HMin/text <> "-")[append alert-info construire-alerte "H=" HMax/text HMin/text] 
			if (DMax/text <> "-") or (DMin/text <> "-")[append alert-info construire-alerte "D=" DMax/text DMin/text] 
			if (CMax/text <> "-") or (CMin/text <> "-")[append alert-info construire-alerte "C=" CMa/textx CMin/text] 
			if (HCPMax/text <> "-") or (HCPMin/text <> "-")[append alert-info construire-alerte "HCP=" HCPMax/text HCPMin/text] 
			if (TMax/text <> "-") or (TMin/text <> "-")[append alert-info construire-alerte "Total=" TMax/text TMin/text]
			remove find/last alert-info
			append alert-info "."
		if "" <> trim Commentaire/text [
			append alert-info Commentaire/text
			if not found? find liste-alerte Commentaire/text[
				insert liste-alerte Commentaire/text
				write/lines alerte-file liste-alerte
			probe liste-alerte
			]
		]
		][
		]
		Alert-info: copy ". Alert."
		Alert?: true
	][
		Alert?: false
	]
	Bid-Dispatch Enchre Caller
]
construire-alerte: func[a [string!] Maxi[string!] Mini[string!]:local r][
	if mini = "-"[R: rejoin ["-" Maxi ","] return R]
		if Maxi = "-"[R: [rejoin Mini "-" ","] return R]
	R: rejoin [mini "-" Maxi ","]
	return R
]
MaJ-P: does[
	alert-offset: alerte-layout/offset
	forall Param[if Found? find first param "Alerte Pos"[remove param break]]
	append Param: head Param rejoin[Dbut-Crochet "Alerte pos " alert-offset fin-Crochet]
	write/lines %BM_ini.txt Param 
]
Reset-to-initial-display: does[
	Effacer-Bids
	hide trick-display
	hide auction-display
	for k 1 4 1[
		P: pick Names-Places K
		N: pick Noms K
		P/text: either N = "Coach"[pick Noms-seats K + 1][N]
		show P 
		Light: pick Lights K
		if k <= length? Client-lights[Light/effect: copy (pick Client-Lights K)]
		show light
	]
]
; ===================================
; Update each team winning tricks count
; ===================================
Display-Trick-count: does [
	Result-Info: rejoin [NS "  " to-string NS-Tricks]
	append Result-info rejoin["    " EO "   "]
	append Result-info to-string EW-Tricks
	statusbar4/text: Result-info
	show statusbar4
]
; ===================================
; Card feel managing for play/bid/remove
; ===================================
Card-feel-redirect: func [
	Joueur-Seat [integer!]
	A-faire [string!]
	][
	main-Joueur: pick Hands (Joueur-seat + 1)
	either A-faire = "Play"[
		either none? couleur-demande[
			foreach Crd Main-Joueur[Crd/todo: "Play"]
			Main-joueur: pick alpha-hands (Joueur-seat + 1)
			if not mode-fun?[Main-Joueur/pane/5/size/x: 30]
			show main-joueur
			][
			Accept-Color?: to-logic false
			foreach Crd Main-Joueur[
				either (Couleur-demande = to-string first Crd/data)[
					Crd/todo: "Play"
					Accept-Color?: to-logic true
					][
					Crd/todo: none
				]
			]
			if not accept-color?[foreach Crd Main-Joueur[Crd/todo: "Play"]]
			Main-joueur: pick alpha-hands (Joueur-seat + 1)
			if not mode-fun?[Main-Joueur/pane/5/size/x: 30]
			show main-joueur
		]
		][
		foreach Crd Main-Joueur[Crd/todo: A-faire]
	]
]

; ===================================
; Enables to pick color for bidding by touching the card of the right color
; ===================================
Bid-feel: func [
	Donnes-Carte
	][
	switch pick Donnes-Carte 1 [#"C" [Bid 1] #"D" [Bid 2] #"H" [Bid 3] #"S" [Bid 4]]
]
; ================================
; Faire tourner la flche pour indiquer le joueur actif
; ================================
Arrows: func [
	Joueur-Seat [integer!] "La place du joueur autour de la table"
	/local a
	][
	if lettres?[
		if not none? Save-seat[
			a: pick alpha-hands save-seat
			a/pane/1/show?: true
			a/pane/3/effect: save-light
			show a
		]
		Save-Seat: Joueur-seat + 1
		a: pick alpha-hands save-seat
		Save-Light: copy a/pane/3/effect
		poke a/pane/3/effect 2 red
		hide a/pane/1
		exit

	]
	ArrOn: switch Joueur-Seat [0 ArrSouth 1 ArrWest 2 ArrNorth 3 ArrEast]
]
; ========================
; faire clignoter la flche
; ========================
Arrows-Blink: does [
	if lettres?[hide Fle exit]
	either etat-fle [Fle/image: ArrOff etat-Fle: to-logic false][Fle/image: ArrOn etat-Fle: to-logic true]
	Show Fle
]
; ========================
; Faire une enchre
; ========================
Make-Call: make function! [
	"Opens a Bidding Box, waits for and returns a Bid"
	Enchre-Courante [string!] "best bid limiting possibles following bids"
	Peut-Contrer? [logic!] "enables Doubling "
	Peut-Surcontrer? [logic!] "enables redoubling "
	][
	either ((length? enchres-lues) < 5)[
		Com-Zone/text: Evaluer
		Com-Zone/action: [Evaluation]
		][
		Com-Zone/text: ""
		Com-Zone/action: none
	]
	Bid-Result: none
; Dterminer le niveau de la prochaine enchre possible
	Couleur: 0
	show niveau
	show NT
	either Enchre-Courante = "Pass" [
		Niveaux-Possibles: to-block Niveaux
		Auction-Level: to-integer 0
		][
		A:  to-string first Enchre-courante
		Auction-level:  to-integer A
		either found? find Enchre-courante "NT" [
			either Auction-level = 7 [Couleur: 5
				bid-level: 7
				hide niveau
				][
				Niveaux-possibles: copy/part (skip  Niveaux Auction-level) (7 - Auction-level)
			]
			][
			Niveaux-possibles: copy/part (skip  Niveaux (Auction-level - 1)) (8 - Auction-level)
			if found? find Enchre-courante "C" [Couleur: 1]
			if found? find Enchre-courante "D" [Couleur: 2]
			if found? find Enchre-courante "H" [Couleur: 3]
			if found? find Enchre-courante "S" [Couleur: 4]
		]
	]
	niveau/data: Niveaux-possibles

	show Bid-Row
	Contrat-possible
]
Contrat-possible: does [
	"Gre l'affichage des enchres possibles en tenant compte du niveau" 
	bid-level: to-integer Niveau/text
	either Bid-level > Auction-level [
		show Club show Diamond show Heart show Spade
		][
		either Couleur > 0 [hide Club]	[show Club]
		either Couleur > 1 [hide Diamond]	[show Diamond]
		either Couleur > 2 [hide Heart]	[show Heart]
		either Couleur > 3 [hide Spade]	[show Spade]
		either Couleur > 4 [hide NT]		[show NT]
	]
]
bid: func [
	"Dtermine l'enchre faite"
	Rang [Integer!] "Numro du pav qui a t slectionn"
	][
	Bid-r: pick Choix-Couleur Rang
	Premier-Niveau-Possible: to-integer Niveau/Text
	switch Bid-r [
		"C" [if not Club/show? [Premier-Niveau-Possible: Premier-Niveau-Possible + 1] Club/show?: false]
		"D" [if not Diamond/show? [Premier-Niveau-Possible: Premier-Niveau-Possible + 1]]
		"H" [if not Heart/show? [Premier-Niveau-Possible: Premier-Niveau-Possible + 1]]
		"S" [if not Spade/show? [Premier-Niveau-Possible: Premier-Niveau-Possible + 1]]
	]
	if Premier-Niveau-Possible > 7 [exit]				; reject a bid at this level
	Bid-result: pick Choix-Couleur Rang
	if Rang < 6 [Bid-result: join (to-string Premier-Niveau-Possible) Bid-result	]
	Main-Joueur: pick Hands (next-player-seat + 1)
	foreach Crd main-Joueur[Crd/todo: none]
	hide Bid-row
	either TM?[
		append enchres-lues Bid-result
		Item-record Bid-result "Auction "
		bid-ready
		][
		Output-message: join Client-place " "
		either Bid-Result = "Pass" [append output-message "passes"][
			either Bid-Result = "X" [append output-message "doubles"][
				either Bid-Result = "XX" [append output-message "redoubles"][
					output-message: rejoin [output-message "bids " Bid-result]
				]
			]
		]
		Insert Trainee-port join output-message newline
		either Mode-Enchres?[][append enchres-lues Bid-result Lire-Enchre]
	]
]

; ========================
; display the bid on the board
; ========================
Affiche: func [Ench [string!]][
	Seat: next-player-seat
	equipe: Seat // 2
		alpha-bid-Step: 50x0
		either 1 = length? enchres-lues[
			alpha-bid-offset: 5x20 + (50x0 * ((Seat + 3) // 4))
			][
			alpha-bid-offset: alpha-Bid-offset + alpha-bid-Step
			if alpha-Bid-offset/x > 160[alpha-Bid-Offset: to-pair compose[5 (alpha-bid-offset/y + 20)]]
		]
		alpha-BidCard Ench alpha-Bid-offset
		Bid-turn: to-integer (((length? enchres-lues) - 1) / 4)
		either lettres?[
			switch Seat[
				0 [Bid-offset: South-alpha/offset + pick Bid-offsets  1 ]
				1 [Bid-offset: West-alpha/offset  + pick Bid-offsets  2
					Bid-offset/x: Bid-offset/x + West-alpha/size/x]
				2 [Bid-offset:  North-alpha/offset + pick Bid-offsets  3]
				3 [Bid-offset:  East-alpha/offset + pick Bid-offsets  4]
			]
			][
			bid-offset: (pick Bid-offsets (Seat + 1)) + pick Hand-Places (Seat + 1)
		]
		either equipe = 0 [bid-Step: 30x0][bid-Step: 0x25]
		offs: to-pair bid-offset + (bid-Step * bid-turn)
		BidCard Ench offs
	show MainWin 
]
; ========================
; display the Card on the board
; ========================
Card-Display: func [
	"Remove Card from hand and put it on the table front of player"
	Crd [string!]
	S [integer!]
	][
	Displayed-Card: find-card crd
	Displayed-Card/offset: (pick Hand-Places (S + 1)) + pick Play-Places (S + 1)
	Displayed-Card/todo: "remove"
	Card-Displace?: to-logic false
	switch to-string first crd[
		"C" [L2: Trefle alpha-col: black]
		"D" [L2: Carreau alpha-col: 191.32.38]
		"H" [L2: Coeur alpha-col: 191.32.38]
		"S" [L2: Pique alpha-col: black]		
	]
	O: to-pair compose [(5 + (52 * ((S + 3) // 4))) (20 * Trick-count)]
	c: copy pick Symboles-Cartes (rang-carte: index? find cards-names to-string second crd)
	if affichage-10?[if rang-carte = 5 [C: copy "I0"]]
	append trick-display/pane layout/offset/size[
						Backdrop white
						space 0
						across
						origin  0x0
						at 12x0
					 box 25x20 l2
						at 0x0
						h2 black c 
		] O 35x20
	either computer-seat >= 4 [Card-Displace?: to-logic true			;fith chair all hands are visible
		][
		if computer-seat = S [Card-Displace?: to-logic true]		;trainee's computer==> remove card
		if s = ((declarer-seat + 2 ) // 4) [Card-Displace?: to-logic true];Dummy play
	]
	if mode-fun?[card-displace?: false]
	either Card-Displace? [
		Main-Joueur: pick Hands (S + 1)
		Remove find Main-Joueur Displayed-Card
		][
		either (S // 2) <> 0 [
			Displayed-Card/size: Htaille-Carte
			Displayed-Card/effect: [rotate 90 aspect]
			][
			Displayed-Card/size: Vtaille-Carte
			Displayed-Card/effect: [rotate 0 aspect]
		]
		show Displayed-card
	]
	append Trick Displayed-Card	
	if ((length? cartes-sorties) > 0)[
		for K 1 (Length? Cartes-sorties) 1[
			Card: pick Cartes-sorties k
			if Card <> Displayed-Card[
				Card/offset: pick Cartes-sorties-places k
				show card
			]
		]
		Cartes-sorties: copy []
		Cartes-sorties-places: copy []
	]
	show MainWin
]
Alpha-Card-Display: func [
	"Remove Card from hand and put it on the table front of player"
	Crd [string!]
	S [integer!]
	/local a temp Main-Joueur Displayed-Card off b
	][
	Displayed-Card: find-card crd
	Displayed-Card/todo: none
	append Trick Displayed-Card
	l: pick mains-lettres (s + 1)
	c: second crd
	c: copy pick Symboles-Cartes (rang-carte: index? find cards-names to-string c)
	if (computer-seat > 3) or (computer-seat = s) or (s = dummy-seat)[
		Main-Joueur: pick Hands (S + 1)
		Remove find Main-Joueur Displayed-Card
		Main-Joueur: pick alpha-Hands (S + 1)
		a: get in pick alpha-cartes Displayed-Card/user-data 'face
		either Alpha-trace = "fantme"[
			a/pane/1/font/color: white
			a/pane/1/font/shadow: 1x1
			][
			off: a/offset/y
			a: Remove find  Main-Joueur/pane/2/pane a 
			if not none? a[
				if alpha-trace = "Resserrer"[
					if 0 < length? a[
						b: first a
						while[ b/offset/y = off][
							b/offset/x: b/offset/x - (largeur-alpha-carte + 1)
							if b = last a [break]
							a: next a
							b: first a
						]
					]
				] 
			]
		]
	]
	switch to-string first crd[
		"C" [L2: Trefle alpha-col: gray]
		"D" [L2: Carreau alpha-col: papaya]
		"H" [L2: Coeur alpha-col: 191.32.38]
		"S" [L2: Pique alpha-col: black]		
	]
	O: to-pair compose [(5 + (50 * ((S + 3) // 4))) (20 * Trick-count)]
	if affichage-10?[if rang-carte = 5 [C: copy "I0"]]
	append trick-display/pane layout/offset/size[
						Backdrop white
						space 0
						across
						origin  0x0
						at 12x0
					 box 25x20 l2
						at 0x0
						h2 black c 
		] O 35x20
	P: layout/size[
		backdrop white
		across
		at 25x5
		box 52x42 L2
		at -2x0
		h2 C alpha-col font-size 40
	]70x50
	switch s[
		0 [P/offset: south-alpha/offset + pick alpha-Play-Places 1]
		1 [P/offset: West-alpha/offset + pick alpha-Play-Places 2
				P/offset/x: P/offset/x + west-alpha/size/x]
		2 [P/offset: North-alpha/offset + pick alpha-Play-Places 3]
		3 [P/offset: East-alpha/offset + pick alpha-Play-Places 4]
	]
	append mainWin/pane P
	append alpha-card-suit P
	show MainWin
]
; ====================
; dfinit les attributs du carton qui doit tre affich
; ====================
BidCard: func [
	Enchre [string!]
	O [pair!]
	][
	trouv: to-logic false
	if Enchre = "Pass" [P: make passe [offset: O] trouv: to-logic true]
	if Enchre = "X" [P: make Bid-X [offset: O] trouv: to-logic true]
	if Enchre = "XX" [P: make Bid-XX [offset: O] trouv: to-logic true]
	if trouv [
		if Seat // 2 = 0 [
			P/size: 37x49
			P/effect: [rotate 270]
		]
		Append MainWin/pane P
		Append Bids-Suit P
		exit
	]
	if found? Find Enchre "NT" [
		P: make Bid-NT [offset: O]
			either equipe = 1 [
				P/text:  join (Pick Enchre 1) SA
				][
				P/text:  rejoin [(Pick Enchre 1) " " SA]
				P/size: 38x49
			]
		Append MainWin/pane P
		Append Bids-Suit P
		exit
	]
	Coul: to-string pick Enchre 2
	Bid-level: copy/part Enchre 1
	P: make Bid-Num [offset: O text: Bid-Level]
	if equipe = 0 [P/size: 34x20]
	Append MainWin/pane P
	Append Bids-Suit P
	if Coul = "C" [P: make Bid-tr [offset: O + 0x20]]
	if Coul = "D" [P: make Bid-ca [offset: O + 0x20]]
	if Coul = "H" [P: make Bid-co [offset: O + 0x20]]
	if Coul = "S" [P: make Bid-pi [offset: O + 0x20]]
	either equipe = 1 [
		P/offset:  O + 13x0
		Q: make comp [offset: O + 13x28]
		Append MainWin/pane Q
		Append Bids-Suit Q
		][
		Q: make comp [offset: O + 34x0 size: 14x48]
		Append MainWin/pane Q
		Append Bids-Suit Q
	]
	Append MainWin/pane P
	Append Bids-Suit P
]
; ====================
; dfinit les attributs du carton qui doit tre affich
; ====================
Alpha-BidCard: func [
	Enchre [string!]
	O [pair!]
	][
		if found? find Enchre #"!"[Alert?: true replace Enchre "!" ""]
	if Enchre = "Pass" [append auction-display/pane layout/offset/size[backdrop black] O + 15x10 10x3 exit]
	if Enchre = "X" [
		append auction-display/pane layout/offset/size[
			Backdrop either alert?[255.200.0][white]
			at 15x0
			h2 " X"
		] O 40x20
		exit
	]
	if Enchre = "XX" [append auction-display/pane layout/offset/size[
			Backdrop either alert?[255.200.0][white]
			at 5x0
			h2 "XX"] O 40x20
			exit
	]
	if found? Find Enchre "NT" [
		append auction-display/pane layout/offset/size[
			Backdrop either alert?[255.200.0][white]
			at 0x0
			h2 join (Pick Enchre 1) SA
		] O 40x20
		exit
	]
	Coul: to-string pick Enchre 2
	Bid-level: copy/part Enchre 1
	if Coul = "C" [alpha-col: black l2: Trefle]
	if Coul = "D" [alpha-col: 191.32.38 l2: Carreau]
	if Coul = "H" [alpha-col: 191.32.38 l2: Coeur]
	if Coul = "S" [alpha-col: black l2: Pique]
	append auction-display/pane layout/offset/size[
			Backdrop either alert?[255.200.0][white]
			space 0
			across
			origin  0x0
			at 10x0 box 30x20 l2
			at 0x0
			h2 black copy to-string Pick Enchre 1 
		] O 40x20
]

; ===========================
; Remove all biddings
; ===========================
Effacer-Bids: does [
	if computer-seat < 4[hide auction-display]
	if 0 = length? enchres-lues[clear skip auction-display/pane 2] 
	Foreach Bid bids-suit [remove find Bid/parent-face/pane Bid	]
]
; ===========================
; Remove last played trick
; ===========================
Trick-remove: does [If (Length? Trick) = 4 [
	append tricks-suit copy trick
	Part-Trick-Remove]
]
Part-Trick-remove: does[
	if lettres? [foreach Crd alpha-card-suit [remove find mainWin/pane CRD] clear alpha-card-suit]
	Foreach Crd Trick [hide Crd]
	clear Trick
]
;===========================
; displaying current active hand evaluation
;===========================
Evaluation: does[
	Either TM?[			; Coach's computer
		Place: next-player-seat
		][
		Place: computer-Seat
	]
	Pts: pick Points (Place + 1)
	Plus-Moins-Values: Pts/PMV
	if Pts/PMV < 0 [PMV: "-"]
	if Pts/PMV < 1 [PMV: "--"]
	if Pts/PMV = 0 [PMV: "="]
	if Pts/PMV > 0 [PMV: "+"]
	if Pts/PMV > 1 [PMV: "++"]
	Texte-aide: rejoin ["Points H: " Pts/PH newline "Points L: " Pts/PL newline "+/- values: " PMV]
	Com-Zone/text: Texte-aide	
]

;==========================================================================================================================
; 		11th section - Overall Management
;==========================================================================================================================
; =================
; Menu choice execution
; =================

menu-donnes: does [
	switch/default CDonnes/text reduce[
		second Jouer1 [Make-Deal]
		third Jouer1 [Choix-fichier-initial]
		fourth Jouer2 [Mode-Enchres]
		fourth Jouer3 [Reprise-Donne]
		fifth Jouer3 [];[Reprise-Play]
		fourth Jouer4 [Reprise-Donne]
		fifth Jouer5 [Sauver]
	][if extras?[Job10]]
]

menu-init: does [
	switch CInit/text reduce[
		second setup2 [Dconnexion]
		second setup1 [if not connect? [matre]]
		third setup1	[if not connect? [Elve]]
		fourth setup1	[Jauge]
		fifth setup1 [Remote-display-request]
;		sixth setup1 [Emuler-WBridge5]
		last setup1 [Quit-Requested]
		first setup4	[Sortir-aide]
	]
]

menu-help: does [
	switch CHelp/text reduce[
		second menu3 [Aide]
		third menu3 [Change-Prefs]
		fourth menu3 [inform AboutWin]
		fifth menu3  [Changer-Langue]
		pick menu3 6 [Pas--pas]
		pick menu3 7 [get-ip]
		"Match sheet" [Display-Match-sheet]
		"Report" [Display-Report]

	]
]
;==================
; Bidding Mode Choice
;==================
Mode-Enchres: does[
	com-zone/action: none
	either TM?[
		Dveloppement-Enchres
		][
		insert trainee-port join "Demande Entranement Enchres" newline
	]
]
;==================
; Preference Change
;==================
Change-Prefs: does[
	Memo-auction-display?: auction-display/show?
	hide auction-display
	Memo-Trick-display?: Trick-display/show?
	hide Trick-display
	if exists? %BM_ini.txt[
		param: read/lines %BM_ini.txt
		Foreach P Param [
			if found? Find P (join Dbut-crochet "Affichage")[Affichage: found? find P "Vrai"]
			if found? Find P (join Dbut-crochet "Popup")[Cartes-Popup: found? find P "Vrai"]
			if found? Find P (join Dbut-crochet "AlphaNum")[TM-Lettres?: found? find P "Vrai"]
			if found? Find P (join Dbut-crochet "Dpart Tournoi")[Tournoi-auto?: found? find P "Vrai"]
			if found? Find P (join Dbut-crochet "Attente")[Attente-Fin-Leve: to-integer second load P]
			if found? Find P (join Dbut-crochet "Pause")[parse P [thru "Pause " copy Mode-Pause to fin-crochet]]
			if found? Find P (join Dbut-crochet "Arrt Fin Jeu")[Pause-game?: found? find P "Vrai"]
			if found? Find P (join Dbut-crochet "Arrt Fin Enchres")[	Pause-auction?: found? find P "Vrai"]
			if found? Find P (join Dbut-crochet "IRMAS")[IRMAS?: found? find P "Vrai"]
			if found? Find P (join Dbut-crochet "Carte Joue")[parse P [thru "Carte Joue " copy Alpha-trace to fin-crochet]]
			if found? Find P (join Dbut-crochet "Affichage 10")[affichage-10?: found? find P "Vrai"]
			if found? find P  "Passer Les alertes"[alert-transmit?: found? find P "Vrai"]
		]
	]
	if alpha-trace = "none" [alpha-trace: none]
	Chang?: false
	Sauve-com-zone: com-zone/Pane
	com-zone/pane: Prefs-Box
	show prefs-Box
]
Paver-Prefs: does[
	in-Dlai/text: Attente-Fin-Leve
	chk3/data: TM-Lettres?
	chk4/data: Tournoi-auto?
	chk5/data: Pause-game?
	chk6/data: Pause-auction?
	chk7/data: IRMAS?
	chk-alert/data: alert-transmit?
	rad7/data: Mode-Pause = "Aucune"
	rad5/data: Mode-Pause = "Toujours"
	rad6/data: Mode-Pause = "Alerte"
	chk8/data: not none? backup-path
]
Suite-Prefs: does[
	save-text: com-zone/text
	com-zone/text: Cliquer
	either chk3/data[
		choix-10/text: either affichage-10?[Ten-Display][X-Display]
		either none? alpha-trace [
			choix-jou/text: Just-Remove
			][
			choix-jou/text: either alpha-trace = "Fantme"[Ghost-Display][Remove-stack]
		]
		com-zone/pane: alpha-Prefs
		show com-zone
		][
		PopCard/text: either cartes-popup[st-popup][st-no-popup]
		Choix-carte/text: either affichage[Taille-Cartes-True][Taille-Cartes-Prop]
		com-zone/pane: graphics-Prefs
		show com-zone
	]
]
change-10: does[
	choix-10/text: either affichage-10?: (choix-10/text = X-display)[ten-display][X-Display]
	clear alpha-cartes
	crer-alpha-cartes
	Chang?: true
	show com-zone
]
change-jou: does[
	either choix-jou/text = ghost-display [
		choix-jou/text: copy Just-remove
		alpha-trace: none
		][
		either choix-jou/text = Just-remove [
			choix-jou/text: copy Remove-stack
			alpha-trace: "Resserrer"
			][
			choix-jou/text: copy ghost-display
			alpha-trace: "Fantme"
		]
	]
	Chang?: true
	show com-zone
]
change-popup: does[
	PopCard/text: either  cartes-popup: (PopCard/text = st-no-popup)[st-popup][st-no-popup]
	Chang?: true
	show com-zone
]
change-cartes: does[
	Choix-carte/text: either  affichage: (Choix-carte/text = Taille-Cartes-Prop)[Taille-Cartes-True][Taille-Cartes-Prop]
	Chang?: true
	show com-zone
]
append-param: func[
	Pice-dplace [string!]
	position [pair!]
	/local a trouv?
	][
	trouv?: false
	foreach p param[
		if found? find P join Pice-dplace ":"[
			trouv?: true
			replace p second parse p none to-string position
			break
		]
	]
	if not trouv?[append param rejoin[Pice-dplace ": " position]]
	write/lines %BM_ini.txt param		
]
Save-Prefs: does[
	com-zone/text: save-text
	com-zone/Pane: Sauve-com-zone
	show com-zone
	Attente-Fin-Leve: to-integer in-dlai/text
	if Chang?[
		K: Copy []
		Foreach P param[
			if found? find P (join Dbut-Crochet "Affichage")[append K P]
			if found? find P (join Dbut-Crochet "Attente")[append K P]
			if found? find P (join Dbut-Crochet "Popup")[append K P]
			if found? find P (join Dbut-Crochet "AlphaNum")[append K P]
			if found? find P (join Dbut-Crochet "Dpart Tournoi")[append K P]
			if found? find P (join Dbut-Crochet "Pause")[append K P]
			if found? find P (join Dbut-Crochet "Arrt Fin Enchres")[append K P]
			if found? find P (join Dbut-Crochet "Arrt Fin Jeu")[append K P]
			if found? find P (join Dbut-Crochet "IRMAS")[append K P]
			if found? Find P (join Dbut-crochet "Carte Joue")[append K P]
			if found? Find P (join Dbut-crochet "Display 10")[append K P]
			if found? find P  "Passer Les alertes"[append K P]
			if found? find P (join Dbut-crochet "Backup: ")[append K P]
		]
		if k <> [][forall K[remove (find param (first K) )]]
		if rad7/data [Mode-Pause: copy "Aucune"]
		if rad6/data [Mode-Pause: copy "Alerte"]
		if rad5/data [Mode-Pause: copy "Toujours"]
		Pause-game?: chk5/data
		Pause-auction?: chk6/data
		TM-Lettres?: chk3/data
		IRMAS?: chk7/data
		alert-transmit?: chk-alert/data
		if not chk8/data [Backup-path: none]
		if none? Backup-path[if chk8/data[Backup-path: first request-file/title/path Choix-Backup st-choisir]]
		append param rejoin [Dbut-crochet "Affichage " either affichage["Vrai"]["Faux"] Fin-Crochet]
		append param rejoin [Dbut-crochet "Popup " either cartes-popup["Vrai"]["Faux"] Fin-Crochet]
		append param rejoin [Dbut-crochet "Attente " in-Dlai/text Fin-Crochet]
		append param rejoin [Dbut-crochet "AlphaNum " either chk3/data["Vrai"]["Faux"] Fin-Crochet]
		append param rejoin [Dbut-crochet "Dpart Tournoi " either chk4/data["Vrai"]["Faux"] Fin-Crochet]
		append param rejoin [Dbut-crochet "IRMAS " either chk7/data["Vrai"]["Faux"] Fin-Crochet]
		append param rejoin [Dbut-crochet "Pause " Mode-Pause Fin-Crochet]
		append param rejoin[Dbut-Crochet "Arrt Fin Enchres " either Pause-Auction?["Vrai"]["Faux"] fin-Crochet]
		append param rejoin[Dbut-Crochet "Arrt Fin Jeu " either Pause-Game?["Vrai"]["Faux"] fin-Crochet]
		append param rejoin[Dbut-Crochet "Carte Joue " Alpha-trace fin-Crochet]
		append param rejoin[Dbut-Crochet "Display 10 " either Affichage-10?["Vrai"]["Faux"] fin-Crochet]
		append param rejoin[Dbut-Crochet "Passer Les alertes " either alert-transmit?["Vrai"]["Faux"] fin-Crochet]
		if not none? Backup-path[	append param rejoin[dbut-crochet "Backup: %" Backup-path fin-crochet]]
		write/lines %BM_ini.txt param
	]
	if Memo-auction-display? [show auction-display]
	if Memo-trick-display? [show trick-display]
]
;=======================
; Language change 
;=======================
Changer-Langue: does[
; look first for available language. A language index is a .txt file beginning with "Language strings". then the available language is the following words up to .txt
	files: load %./
	Langues-disponibles: copy ["Franais"]
	foreach f files[
		if found? find f "Language strings"[
			if found? find f ".r"[
				parse f [thru "Language strings " copy L to ".r"]
				append Langues-disponibles L
			]
		]
	]
	Random-deal?: found? find statusbar1/text Random-deal
	Com-zone/pane: layout/offset[
		backdrop couleur-com effect[tile]
		choix-language: text-list data Langues-disponibles[
			language: first face/picked
			New-language Language
			append clear head CInit/data setup1
			Cinit/text: first setup1 
			append clear head CDonnes/data Jouer1
			CDonnes/text: first Jouer1 
			append clear head CHelp/data menu3
			CHelp/text: first menu3
			com-zone/pane: none
			if donne-initiale = "" [statusbar1/text: No-deal statusbar3/text: Etude com-zone/text: Peut-visionner]
			if random-deal?[	statusbar1/text: join Random-deal to-string NumDonne Affiche-deal Nom-Donne Dealer Vulnerable]
			show MainWin
			to-change: rejoin[dbut-crochet "Langue: " Language fin-crochet]
			either exists? %BM_ini.txt[
				Param: read/lines %BM_ini.txt
				Trouv?: false
				forall Param[
					if found? find first Param "Langue"[
						Trouv?: true
						change Param to-change
						break
					]
				]
				if not trouv?[append param to-change]
				][
				Param: to-change
			]   
			Param: head Param
			write/lines %BM_ini.txt param
		]
	]0x80
]
;=======================
; online Help 
;=======================
Aide: does [
	Pas--Pas?: false
	lancer-choix
]
Pas--pas: does[
	Pas--Pas?: true
	lancer-choix
]
lancer-choix: does[
	Sauve-com-zone: com-zone/Pane
	com-zone/Pane: choix-langue
	show com-zone
]
affiche-liste: does[
  either Pas--Pas?[
		help-file: either fr/data[ %"Pas  pas.doc"][  %"How to.doc"]
		][
		help-file: either fr/data[ %"Bridge Moniteur Mode Emploi.doc"][  %"Use of Bridge Moniteur.doc"]
	]
	if not exists? help-file [
		help-file: to-string help-file
		inform layout[ 
			backdrop Couleur-Com effect[tile]
			vh1 fichier-aide 
			vh1 help-file 
			vh1 pas-trouv
			button "Ok" [hide-popup]
		]
		com-zone/pane: none
		show com-zone
		exit
	]
	
	help-text: read help-file
; preparing the help entries
	Entries: copy []
	K: 1
	help-text: copy find help-text join to-integer K ") "
	Cherche-entres: copy help-text
	until [parse Cherche-entres[copy entry to ":"]
		append entries copy skip (find entry " ") 1
		K: K + 1
		error? try [Cherche-entres: copy find Cherche-entres join to-integer K ") "]
	]
	append clear choix-aide/data copy entries
	fix-slider choix-aide
	show choix-aide
	com-zone/pane: liste
	show com-zone
]
Aide-dtail: func[
	K [integer!]
	][
	Choix-fait: pick entries K
	Num-aide: K + 1
	Balise-aide: join (K + 1) ") "
	Explication: copy find help-text join K ") "
	Explication: copy find Explication choix-fait
	either found? find Explication Balise-aide[
		parse Explication [copy A to Balise-aide ]
		][
		A: copy ""
		Forall Explication [if (first Explication) < 10 [Break] append A first Explication]
	]
	either lo-res [L: 80][L: 100]
;limit each line to L car max
	A: parse/all A to-string newline
	Texte: copy []
	C: ""
	foreach B A[
			either (length? B) <= L[
				append Texte copy B
				][
				clear C
				foreach D parse B none[
					either ((length? C) + length? D) <= L[
						append C join D " "
						][
						append Texte copy C
						C: copy join D " "
					]
				]
				append texte copy C
			]
	]
	append clear head texte-aide/data copy Texte
	fix-slider texte-aide
	Win-aide/offset: 0x0
	if not found? find Cinit/text first setup4 [
		append mainwin/pane Win-aide
		head CInit/data
		Sauve-Setup: copy CInit/data
		append clear CInit/data copy setup4
		CInit/text: first setup4
	]
	show mainWin
]
Sortir-aide: does[
	texte-aide/font: [size: 12]
	com-zone/pane: Sauve-Com-zone
	show com-zone
	Head CInit/data
	Append clear CInit/data copy Sauve-setup
	CInit/text: first Sauve-setup
	remove find MainWin/pane Win-aide
	show MainWin
]
;=======================
;display the match sheet
;=======================
Display-Match-sheet: does[
	Sauve-Com-zone: com-zone/pane
	append clear head texte-aide/data copy Match
	texte-aide/font: [size: 14]
	fix-slider texte-aide
	Win-aide/offset: 0x0
	if not found? find Cinit/text "Retour" [
		append mainwin/pane Win-aide
		head CInit/data
		Sauve-Setup: copy CInit/data
		append clear CInit/data copy setup4
		CInit/text: first setup4
	]
	show mainWin
]
;=======================
;display the REPORT sheet (only if stats.r is present)
;=======================
Display-Report: does[
	Sauve-Com-zone: com-zone/pane
	append clear head texte-aide/data copy Report-sheet
	texte-aide/font: [size: 14]
	fix-slider texte-aide
	Win-aide/offset: 0x0
	if not found? find Cinit/text "Retour" [
		append mainwin/pane Win-aide
		head CInit/data
		Sauve-Setup: copy CInit/data
		append clear CInit/data copy setup4
		CInit/text: first setup4
	]
	show mainWin
]
;=======================
;display the past communications
;=======================
Communication-Backlog: does[
	sauve-com-zone: com-zone/pane
	append clear head texte-aide/data copy Communication-log
	fix-slider texte-aide
	if not found? find Cinit/text first setup4 [
		Win-aide/offset: 0x0
		append mainwin/pane Win-aide
		head CInit/data
		Sauve-Setup: copy CInit/data
		append clear CInit/data copy setup4
		CInit/text: first setup4
	]
	show mainWin
]

;=======================
;create an event handler
;=======================
evt-handler: func [face event][
    either event/type = 'close [quit-requested 
        none         
	][
	if event/type = 'key [
		if event/control [
			if event/key = #"^P" [Print?: Not Print? return none]
			if event/key = #"^D" [debug?: Not debug? if mode-Fun?[List-debug] return none]
			if event/key = #"^Q" [Quit-requested return none]
			if event/key = #"^H" [halt]	;for debug purpose
			if event/key = #"^A" [if exists? %anamonitor.r[do %anamonitor.r] return none]	;for debug purpose
			if event/key = #"^L" [if TM?[Communication-Backlog] return none]
			if event/key = #"^S" [if stats?[write/lines %report.txt report-sheet] return none]
			if event/key = #"^F" [
				if TM?[ if 0 < length? remote-displays[
					output-message: "Personne"
					Inform/title layout[
						below
						h1 "Sud est donneur"
						h1 "Indiquer la vulnrabilit"
						across
						radio of 'grp-vul true[Output-message: "Personne"] h1 "Personne" return
						radio of 'grp-vul[Output-message: "NS"] h1 "NS" return
						radio of 'grp-vul[Output-message: "EO"] h1 "EO" return
						radio of 'grp-vul[Output-message: "Tous"] h1 "Tous" return
						Button "ok" [hide-popup]
					]"FunBridge"
					insert first remote-displays rejoin["Donneur Sud. Vulnerable " Output-message newline]
				none
				]
			]]
			if event/key = #"^W" [
				if TM?[
					if Connect?[
						Permanent-Pause-Leve?: not Permanent-Pause-Leve?
						Pause-Leve?: permanent-pause-leve?
						 return none
					]
				]
			]
		]
		if event/key = 'F1 [Aide return none]
		if event/key = 'F2 [if not Match? [if computer-seat < 5[Reprise-Donne]] return none]
		if event/key = 'F3 [if not Match? [if computer-seat < 5[Suivante]] return none]
		if event/key = 'F4 [if not Match? [if computer-seat < 5[Prcdente]] return none]
		if event/key = 'F5 [if Etude? [Mode-Enchres] return none]
		if event/key = 'F9 [
			if TM? [if found? find statusbar3/text st-attente[if Client-num < Client-number[auto-connect-WB5 return none]]]
			if computer-seat < 4[insert trainee-port join "auto-connect-WB5" newline]
			]
		if event/key = 'F8 [Emuler-WBridge5 return none]
		if event/key = #"^[" [halt return none]
]
; allow other events to pass through
	event
    ]
]
auto-connect-WB5: does[
	either none? Wbridge5-path[
		inform layout[ h2 choix-WB5 h2 Guide-WB5 button "Ok" [hide-popup]]
		Wbridge5-path: first request-file/title "Recherche de Wbridge5" "Choisir"
		append param rejoin[dbut-crochet "Wbridge5 %" WBridge5-path fin-crochet]
		write/lines %BM_ini.txt param
		][
		if not exists?  Wbridge5-path[Wbridge5-path: first request-file/title "Recherche de Wbridge5" "Choisir"]
		forall param[if found? find first param "WBridge5"[remove param]]
		append param rejoin[dbut-crochet "Wbridge5 %" WBridge5-path fin-crochet]
		param: head param
		write/lines %BM_ini.txt param
	]
	call reduce[Wbridge5-path  "Autoconnect" num-port]
]
Emuler-WBridge5: does[
	elve
	In-Host/show?: false
	In-Port/show?: false
	retirer2/show?: false
	retirer3/show?: false
	retirer4/show?: false
	Button-connect/action: [lancer-TM]
	statusbar3/text: st-jeu-WB5
	show statusbar3
	append param "Emulation WBridge5 requise"
	write/lines %BM_ini.txt param
	show trainee-box
]
lancer-TM: does[
	call join rpertoire "bridge_moniteur16.exe"
	hide trainee-box
	auto-connect?: true
	trainee-connect
]
; insert the handler
insert-event-func :evt-handler
;====================
; Disconnecting
;====================
Dconnexion: does[
	either TM? [
		if ((length? Clients) > 0) [
			Output-message: join "End of session" newline
			dispatch-message output-message
			forall Client-ports [
				remove find system/ports/wait-list first Client-ports
				close first Client-ports
			]
;save any updated file
			if Match?[
				if 4 < length? match[
					if exists? match-sheet[delete match-sheet]
					forall match[
						either 1 < length? match [
							write/lines/append match-sheet first match
							][
							either 50 < length? first match[
								write/lines/append match-sheet first match
								][
								write/append match-sheet first match
							]
						]
					]
					if stats?[write/lines %report.txt report-sheet]
				]
			]
			connect?: to-logic false
			either Quitter?[
				remove find system/ports/wait-list server-port
				wait 1
				close server-port
				quit
				][
				foreach L lights[hide l]
				foreach N Names-Places [N/text: ""]
				clear statusBar3/text
				Clients-ports: copy []
				Clients: copy []
				Trainees: copy []
				unview MainWin
				view/title MainWin join "Bridge Moniteur version " version
			]
		]
		][
		either Quitter?[
			quit
			][
			close trainee-port
			connect?: to-logic false
		]
	]
	CInit/data: head CInit/data
	append clear CInit/data copy setup1		;back to initial menu
]  
;===============
; Quitting
;===============
quit-requested: does [
	if Computer-seat = 5[if Connect?[close Trainee-port]quit]
	inform layout [
		backdrop Couleur-Com effect[tile]
		vh2 arrter? across
		Bt1:	Button Oui 52x26 [
			if extras?[Job11]
			either TM?[
				either (length? clients) > 0[
					Quitter?: true
					Dconnexion
					][
					quit
				]
				][
				if not connect?[quit]
				output-message: join "Quitter" newline
				if Print? [Prin output-message]
				insert trainee-port output-message
				Quitter?: true
				hide-popup
			]
		] 
		Button Non 52x26 [hide-popup]
	]
]
clore: does[
	if extras? [Job13]
	Quitter?: true
	Dconnexion
]
; ======================================
; Restore hands during game 
; ======================================
Restore-Hands: does[
	either TM? [foreach Hand Hands [display-Hand Hand]
		][
		display-hand (pick Hands (computer-seat + 1))
		Hand: pick Hands (Dummy-seat + 1)
		foreach Crd Hand[hide Crd]
	]
]

;==========================
; at end of game "Suivante" has been selected
;==========================
Suivante: does[
	Reset-to-initial-display
	foreach Crd Jeu[hide CRD] 
	bouton-prev/text: st-Prev
	bouton-prev/action: [Prcdente]
	if match?[Com-zone/pane: none show com-zone]
	if Mode-Enchres? or visionneuse? or Etude?[
		if NumDonne = Length? Pointeurs[bouton-suivante/text: none bouton-suivante/action: none]
		if NumDonne < length? Pointeurs[
			Prochain-jeu
			exit
	]
	]
	either (length? fichiers-jauge) = 0[
		either found? find statusbar1/text random-deal [
			Make-Deal
			][
			Com-zone/pane: none
			Com-zone/text: none
			show com-zone
		]
		][
		Continuer-match?: true
		Prochain-jeu
	]
]
;==========================
; "Prcdente" has been called
;==========================
Prcdente: does[
	bouton-suivante/text: st-suivante
	bouton-suivante/action: [suivante]
	either found? find statusbar1/text random-deal [
		Make-Deal
		][
		either NumDonne > 1[
			NumDonne: NumDonne - 1 Donne-initiale: fetch-deal NumDonne Fichiers-jauge launch-deal
			if NumDonne = 1[bouton-prev/text: none bouton-prev/action: none]
			][
			bouton-prev/text: none
			bouton-prev/action: none
		]
		show com-zone
	]	
]
;==========================
; at end of game "Revoir" has been selected
;==========================
Revoir: does[
	Trick-remove
	hide bid-row
	if Mode-Enchres? Or Visionneuse?[
		if 2 < length? Trick-Display/pane[clear skip Trick-Display/pane 2]
		hide Trick-Display
		effacer-bids
		K: 1
		foreach X donne-initiale[
			K: K + 1
			if found? find X "[Play " [
				Leader-Seat: (index? find Joueurs (second parse x none)) - 1
				break
			]
		]
		Cartes-joues: copy ""
		For N K (K + 12) 1 [append Cartes-joues join pick Donne-initiale N newline]
		cartes-joues: parse cartes-joues none
		clear tricks-suit
		foreach CRD Cartes-joues[append Tricks-suit find-card CRD]
	]
	Trick-First-Player: Leader-Seat
	Arrows Trick-first-player
; first display Bids
	foreach Bid Bids-suit[append mainWin/pane Bid]
;then, hands
	load-hands Donne-initiale
	if lettres?[crer-alpha-cartes]
	foreach Hand Hands [display-Hand Hand]
	Marche-arrt/image: bouton-Continu
	Mode-Continu: false
	Dbut/image: Sans-bouton
	Com-Zone/pane: Playback-Control-panneau
	show com-zone
	trick-count: 0
	NS-Tricks: EW-Tricks: 0
	retour-timer: "attente-suite"
	tempo/rate: 1
	show MainWin
]
Montrer-pli: does[
	effacer-Bids
	Part-Trick-remove
	Dbut/image: Bouton-Dbut
	either trick-count < 13 [
		for k 1 4 1 [append Trick (pick Tricks-suit ((trick-count * 4) + k))]
		foreach Crd Trick[
				l: pick mains-lettres (crd/seat + 1)
				c: second crd/data
				c: copy pick Symboles-Cartes (rang-carte: index? find cards-names to-string c)
				switch to-string first crd/data[
					"C" [remove find fourth L to-char C L2: Trefle alpha-col: gray]
					"D" [remove find third L to-char C L2: Carreau alpha-col: papaya]
					"H" [remove find second L to-char C L2: Coeur alpha-col: 191.32.38]
					"S" [remove find first L to-char C L2: Pique alpha-col: black]		
				]
				O: to-pair compose [(5 + (50 * ((crd/seat + 3) // 4))) (20 * (trick-count + 1))]
				if affichage-10?[if rang-carte = 5 [C: copy "I0"]]
				append trick-display/pane layout/offset/size[
						Backdrop white
						space 0
						across
						origin  0x0
						at 12x0
					 box 25x20 l2
						at 0x0
						h2 black c 
					] O 35x20
			either lettres?[
				Main-Joueur: pick alpha-Hands (crd/seat + 1)
				a: get in pick alpha-cartes Crd/user-data 'face
				either Alpha-trace = "fantme"[
					a/pane/1/font/color: white
					a/pane/1/font/shadow: 1x1
					][
					off: a/offset/y
					a: Remove find  Main-Joueur/pane/2/pane a 
					if alpha-trace = "Resserrer"[
						if 0 < length? a[
							b: first a
							while[ b/offset/y = off][
								b/offset/x: b/offset/x - (largeur-alpha-carte + 1)
								if b = last a [break]
								a: next a
								b: first a
							]
						] 
					]
				]
				P: layout/size[
					backdrop white
					across
		at 25x5
		box 52x42 L2
		at -2x0
		h2 C alpha-col font-size 40
				]70x50
				switch crd/seat[
					0 [P/offset: south-alpha/offset + pick alpha-Play-Places 1]
					1 [P/offset: West-alpha/offset + pick alpha-Play-Places 2
							P/offset/x: P/offset/x + west-alpha/size/x]
					2 [P/offset: North-alpha/offset + pick alpha-Play-Places 3]
					3 [P/offset: East-alpha/offset + pick alpha-Play-Places 4]
				]
				append mainWin/pane P
				append alpha-card-suit P
				show MainWin
				][
				crd/offset: (pick Hand-Places (crd/Seat + 1)) + pick Play-Places (crd/Seat + 1)
				show Crd
			]
		]
		trick-count: trick-count + 1
		either Mode-Enchres? or visionneuse?[
			c: pick trick (((Trick-First-Player - Leader-Seat + 4) // 4) + 1)
			Trick-First-Player: Leader-Seat
			][
			c: first trick
		]
		Couleur-demande: to-string first (get in C 'data)
		Trick-Winner: Win-Trick ;trick/cards Trick/seats
		Either even? Trick-winner [NS-Tricks: NS-Tricks + 1][EW-Tricks: Ew-Tricks + 1]
		Display-Trick-Count
		a: pick trick-display/pane ((Memo-length: length? trick-display/pane) - 3 + ((Trick-Winner - Trick-First-player + 4) // 4))
		a/pane/1/color: 255.200.0
		show a
		if odd? trick-winner - declarer-seat[
     	O: to-pair compose [0  ((20 * trick-count) + 3)]
			insert skip trick-display/pane (memo-length - 4 )layout/offset/size[backdrop orange] O 197x14
		]
		Trick-First-Player: Trick-Winner
		Arrows Trick-first-player
		show MainWin
		][
		if not none? Save-seat[
			a: pick lights save-seat
			a/effect: save-light
			show a
			a: pick alpha-hands save-seat
			a/pane/1/show?: false
			show a
		]
		Afficher-marque
		com-zone/pane: suite-box
		Mode-Continu: false
		Marche-arrt/image: bouton-Continu
	]
	show trick-display
	show MainWin
]
Dfiler: does[either Mode-Continu[
	PlayBack-tempo: none
	Mode-Continu: false
	Marche-arrt/image: bouton-Continu
	][
	Mode-Continu: true
	Marche-arrt/image: bouton-Stop
	PlayBack-tempo: 2
	tempo-rate: 1
	retour-timer: "attente-suite"
	]
	show Marche-arrt
]
;==========================
; overall resetting parameters ang display
;==========================
RAZ: does[
	clear Statusbar3/text
	clear Statusbar4/text
	foreach Card Jeu[
			card/show?: false
			card/seat: 4
			todo: none
	]
	clear skip auction-display/pane 2
	clear skip trick-display/pane 2
	Reset-to-initial-display
	show MainWin
]
;==========================================================================================================================
; 		12th section - Set of Graphics Definitions
;==========================================================================================================================
taille-fen: xmax - table-width
do %Layouts.r
; =====================================
; Main Window Construction
; =====================================
taille-com: to-pair compose [(taille-fen) (table-height - 102)] 
font2: either lo-res [10][12]
font3: either lo-res [12][15]
MainWin: layout/size[ 
	styles mes-styles
	; ---------
     ; 1 zne de type box pour le tapis
	; -----------------------------------------------
    origin to-pair compose [(tableX0) (tableY0)]
	table: box  to-pair compose [(table-width) (table-height)] Couleur-tapis 
		edge [size: -2x2
		color: 66.128.131
		effect: 'ibevel
	] effect [tile draw[] ]
	at pane-loc
	Fle: 	image ArrOff to-pair compose [(Pane-size) (pane-size)]; rate none feel [engage:[Arrows-Blink]]

	at 0x50
	Base-Carte: image image-carte feel [
		over: func [face act pos] [
			if cartes-popup[
				either act [
					if not Carte-pope[
						memo: face/user-data
						todo: get in pick jeu memo 'todo
							if not None? todo[
       	        		remove find MainWin/pane  face
        	      		append face/parent-face/pane face
							Carte-Pope: true
						]
					]
					][
					memo: face/user-data + Pivot-cartes - 1
     	  	      		remove find/last MainWin/pane face
        	        		insert (skip head Mainwin/pane memo) face
					Carte-pope: false
				]
				show Mainwin
			]
 	      ]
		engage: func [f act e][if act = 'up [what-todo f act e ]]
	]

	at S-Connect-Offset S-Connect: box image-tmoin to-pair compose[(pane-width) 4]  effect [colorize white fit]
	at N-Connect-Offset N-Connect: box image-tmoin to-pair compose[(pane-width) 4]  effect [colorize white fit]
	at W-Connect-Offset W-Connect: box image-tmoin to-pair compose[4 (Light-height)]  effect [colorize white rotate 90 fit]
	at E-Connect-Offset E-Connect: box image-tmoin to-pair compose[ 4 (Light-height)]  effect [colorize white rotate 90 fit]

	at SName-Offset SName0: box to-pair compose[(to-integer (pane-width / 3)) 15]couleur-tapis effect[tile] 
	at NName-Offset NName0: box to-pair compose[(to-integer(pane-width / 3)) 15]couleur-tapis effect[tile] 
	at WName-Offset WName0: box to-pair compose[(pane-height) 40]couleur-tapis effect[tile] 
	at EName-Offset EName0: box to-pair compose[(pane-height) 40]couleur-tapis effect[tile] 

	; --------------------------------------------------------
    ; 3 boutons pour prsenter des menus droulants
	; ---------------------------------------------
	across
	origin 0x0
	CDonnes: choice Pane-height left  font[color: black size: font2 shadow: none]
		 data copy Jouer1 [menu-donnes]
	origin to-pair compose [(table-width - Pane-height) 0]
	across
	space 0x0		
	CHelp: choice Pane-height left  font[color: black size: font2 shadow: none] center
		 data menu3 [menu-help]	
    	origin to-pair compose [(table-width) 0]
	across
	space 0x0
	Passe: image CartonPasse
	Bid-NT: Box "1SA" 48x37 255.255.255 font [color: black size: 20 shadow: none] center  Top
	Bid-Num: h1 "1" 14x37 black 255.255.255   font-size 20  center Top
	Bid-tr:	image %Couleurs/Trefle.bmp 35x28
	Bid-ca:	image %Couleurs/Carreau.bmp 35x28
	Bid-co:	image %Couleurs/Coeur.bmp 35x28
	return
	Bid-pi:	image %Couleurs/Pique.bmp 35x28
	Bid-X:	Box  "X" 48x37 220.10.0 font [color: white size: 20 shadow: none] left Top
	Bid-XX:	Box  "XX" 48x37 navy [color: white size: 20 shadow: none] left Top
	Comp: box 35x9 white
    	origin to-pair compose [(table-width) 0]
	CInit: choice taille-fen left  font[color: black size: font2 shadow: none]
		 data copy Setup1 [menu-init]	
   ; tat compose de 4 znes d'affichage de textes
	; --------------------------------------------------------
	below
	statusbar1: info to-pair compose [(taille-fen ) (24)] pewter font [size: font3 name:  "Arial" style: 'bold align: 'left]
	statusbar2: info to-pair compose [(taille-fen ) (24)] pewter Bold font-size font3 font-name "Arial"
	statusbar3: info to-pair compose [(taille-fen ) (24)] pewter bold font-size font3 font-name "Arial" font-color yellow
	statusbar4: info to-pair compose [(taille-fen ) (30)] pewter top center bold font-size 20 font-name "Arial" font-color white shadow 3x3
; un pav de communication
	Com-Zone: box taille-com top left couleur-com effect[tile]
; un voyant qui sert de timer
	at statusbar3/offset
	tempo: box 4x4 0.160.0 rate none feel [engage:[scrute]]
	at statusbar3/offset + 12x2 Color-contract: box 25x20 trefle
]to-pair compose [(xmax) (ymax)]
Color-contract/show?: false
; ====================================
; Playback Control panel Construction 
; ====================================
Bouton-Step: to-image load %Couleurs/Step.bmp
Bouton-Stop: to-image load %Couleurs/Stop.bmp
Bouton-Continu: to-image load %Couleurs/Continu.bmp
Bouton-Dbut: to-image load %Couleurs/Debut.bmp
Sans-bouton: to-image load %Couleurs/Sans-bouton.bmp
Playback-Control-panneau: layout/offset[
	origin 0x0
	across
	space 0
	Un-pas: box bouton-Step [either Pause-Leve?[Com-zone/pane: none show com-zone Trick-leader][Montrer-Pli]]
	Marche-arrt: box  bouton-Continu [
		either Pause-Leve?[
			Pause-Leve?: false
			com-zone/pane: none
			show com-zone
			Trick-leader
			][
			Dfiler
		]
	]
	Dbut: box Sans-bouton [Revoir]
]20x40
;============================
; Language choice
;============================
choix-langue: layout/offset[
  backdrop Couleur-Com effect[tile]
	across
	Fr: radio of 'grp true text Franais [fr/data: true]return
	En: radio of 'grp text Anglais [en/data: true] return
	button "Ok" [affiche-liste]
]0x80
;============================
; choice in help menu
;============================
largeur-liste: either lo-res[220][200]
Liste: layout/offset[
  backdrop Couleur-Com effect[tile]
	style lab label 200 left
	at 0x40 choix-aide: text-list largeur-liste[ Aide-dtail (choix-aide/cnt)]
]0x40
Win-Aide: layout/size[
	origin 0x0
	space 0
	Texte-aide: text-list to-pair compose[(to-integer (table-width * 1)) (to-integer(ymax * 1))] font-name font-fixed
]to-pair compose [(table-width) (ymax)]
;=====================================
; 'A propos' window Construction 
; =====================================
AboutWin: layout [
	backdrop 160.160.160
	across
	origin 50x20 image  join app-dir "BM.gif"
    panel [  
		origin 30x0  
        below        
		vh1 "Bridge Moniteur"
		text 300 bold italic rejoin ["version: " to-string version "        " to-string modification-date ]font[color: navy size: 12] 
		text 300 bold italic "Author: Grard Joyez" font[color: navy size: 12] 	
		text 300 bold italic "with kind contribution of Yves Costel and Pierre Cormault" font[color: navy size: 12] 	
	]300x120
    below
	indent -20  
    text bold {	This program is either a Bridge Table Manager, or an interface to play bridge thru a Table Manager.}
	text bold {A Table Manager acts as a server which allows computers to communicate with each other in order to play bridge over a network.
    The Table Manager's function is to give the hands and transmit and receive all communications among the four players  on up to four separate computers.}
	text bold {Extra feature accepts less than four distant players, and is specially thought for human training. For instance a single distant player seing only his own hand (and dummy's when it should) can be trained by a coach seing all hands. A player can also play with/against a combination of Bridge playing programs } 
	text bold {All communications are in plain-text ASCII format, using TCP/IP, and primarily follow protocol rules  drafted by Blue Chip Bridge (version 16 and later).
    } para [origin: 10x10 margin: 10x10] font[color: navy size: 12]
    indent 20 button "OK" [hide-popup] center
]  
;==========================================================================================================================
; 		13th section - Card Deck Building and launching program
;==========================================================================================================================
Mode-Continu: false

; =======================================
; Card Creating with attributes: name, place, rank, hand/seat number, what todo with, honour points...
; =======================================
Pivot-cartes: length? mainWin/pane
K: 1	;provides a rank to each card
Couleur-texte: 0.0.0
Forall colors [
		if #"H" = first colors[Couleur-texte: 191.32.38]
		if #"D" = first colors[Couleur-texte: papaya]
		if #"C" = first colors[Couleur-texte: gray]
	forall cards-names [
		Valeur-Carte: first cards-names
		Pts: none
		Pts: select ["A" 4 "K" 3 "Q" 2 "J" 1 "T" 0]Valeur-Carte
		card-name: join first colors Valeur-Carte
		fname: rejoin [Card-folder card-name ".bmp"]
		Card: make Base-Carte [
			data: Card-name
			image: load to-file fname
			offset: Deck-Place
			show?: false
			user-data: K
			seat: 4
			todo: none
			PH: Pts
			Couleur: Couleur-texte
		]
		K: K + 1
		append Jeu Card
		append MainWin/pane Card
	]
	cards-names: head cards-names
]
colors: head colors
Base-carte/show?: false
;=======================
;creating also alphanumeric cards
;=======================
Crer-alpha-cartes: does[
	if (0 < length? alpha-cartes) and (alpha-trace <> "Fantme")[exit]; exists and unmodified
	clear alpha-cartes
	Couleur-texte: 0.0.0
	foreach color colors[
		if color = #"H"[Couleur-texte: 191.32.38]
		if color = #"D"[Couleur-texte: papaya]
		if color = #"C"[Couleur-texte: gray]
		foreach c symboles-cartes[
			d: c
			dcal: either lo-res[2x-2][either 4 > index? find symboles-cartes c[-4x-6][0x-6]]
			f: either lo-res[26][38]
			l: largeur-alpha-carte
			if c = fifth symboles-cartes[
				if affichage-10?[
					d: "I0"
					dcal: either lo-res[-1x-2][-3x-5]
					f: either lo-res[24][36]
					l: largeur-alpha-carte + 10
				]
			]
			append alpha-cartes make Object![
				face: layout/size[
					backcolor white
					at dcal h1 d couleur-texte font-size f 
					feel [
						over: func [face act pos] [
							carte-pope: false
							memo: face/parent-face/user-data
							todo: get in pick jeu memo 'todo
							if not None? todo[
								either act[
									face/parent-face/pane/1/color: 255.220.220
									][
									face/parent-face/pane/1/color: white
								]
								show face
							]
						]
						engage: func [f act e][if act = 'up [f/parent-face/pane/1/color: white what-todo f act e ]]
				]
				]as-pair l either lo-res [28][34]
				data: c 
				seat: 4
				todo: none
				Couleur: Couleur-texte
			]
		]
	]
	K: 1
	foreach c alpha-cartes[
		c/face/user-data: K
		c/face/size: as-pair largeur-alpha-carte either lo-res [28][34]
		K: K + 1
	]
]
; ======================
; Excution du programme
; ====================== 
Lights: copy reduce[S-Connect W-connect N-connect E-connect]
foreach L Lights[L/show?: false]
Names-places: copy REDUCE [SName0 WName0 NName0 EName0]
SName: SName0 
WName: WName0 
NName: NName0 
EName: EName0 
center-face MainWin
center-face AboutWin
etat-Fle: to-logic false
statusbar1/text: No-deal
show statusbar1
statusbar3/text: Etude
com-zone/text: Peut-visionner
Append alpha-hands South-alpha
Append alpha-hands West-alpha
Append alpha-hands North-alpha
Append alpha-hands East-alpha
alpha-size: north-alpha/size
if None? Noff[Noff: Table-center - to-pair compose[(either lo-res[70][110]) (to-integer (pane-size / 2)  + alpha-size/y)]]
	if None? Soff[Soff: Table-center + to-pair compose[(either lo-res[-70][-110]) (to-integer (pane-size / 2))]]
if None? Woff[
	either lo-res[
		Woff: Table-Center - to-pair compose[(to-integer(Pane-size / 2) + 200) (to-integer(0.5 * alpha-size/y))]
	][
		Woff: Table-Center - to-pair compose[(to-integer(Pane-size / 2) + 240) (to-integer(0.5 * alpha-size/y))]
	]
]
if None? Eoff[Eoff: Table-Center + to-pair compose[(TO-integer (pane-size / 2)) (to-integer(-0.5 * alpha-size/y))]]
if none? Foff[Foff: Aoff + 0x200]
North-alpha/offset: Noff
West-alpha/offset: Woff
East-alpha/offset: Eoff
South-alpha/offset: Soff
making-array/offset: Foff
North-alpha/user-data: "Nord"
West-alpha/user-data: "Ouest"
East-alpha/user-data: "East"
South-alpha/user-data: "Sud"
alpha-Hand-places: reduce [soff woff noff eoff]
Noff: either lo-res[50x152][90x181] 
Soff: either lo-res[50x-70][90x-70] 
Woff: 20x41
Eoff: -80x41
alpha-play-places: reduce [soff woff noff eoff]
append MainWin/pane auction-display
auction-display/user-data: "Enchres"
auction-display/show?: false
auction-display/offset: Aoff
append mainwin/pane making-array
Trick-display/show?: false
Trick-display/user-data: "Leves"
Trick-display/Offset: Toff
append MainWin/pane Vision-enchres 
Vision-enchres/show?: false
Vision-tricks/show?: false
append MainWin/pane Vision-tricks 
append MainWin/pane match-aller
append MainWin/pane Freq-display
Freq-display/show?: false
IRMAS-set/show?: false
append mainwin/pane Alerte-display
append mainwin/pane Alerte-layout
append mainwin/pane Infos-display
append MainWin/pane Trick-display
making-array/show?: false
Alerte-layout/show?: false
Alerte-display/show?: false
Infos-display/show?: false
Infos-display/offset: Foff + 0x170
Paver-Prefs
append Mainwin/pane 	bid-row
bid-row/offset: to-pair compose [(Xmax - either lo-res [300][366]) (Ymax - either lo-res [80][90])]
Bid-row/show?: false
if TM-lettres?[set-alpha]
either Tournoi-auto? [
	show Basic-reset
	Jauge
	][
	Basic-reset/show?: false
	either auto-connect?[Matre prepare-connect ;do-events
		][
		view/title MainWin join "Bridge Moniteur version " version
	]
]

